﻿using MainRemit;
using MyDatabase;
using Newtonsoft.Json;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Request;
using SAIB_Web_Api.Models.Response;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace SAIB_Web_Api.BusinessManager
{
    public class CancellationCheckerManager
    {
        DAL dal = new DAL();
        CommonLogDetails commonLogDetails = new CommonLogDetails();

        string TrxnNo = string.Empty;
        DataTable MyDt = new DataTable();
        int TrxnStatus = 0;
        string IsMTOSuccess = string.Empty;
        string TxnDateTime = string.Empty;
        string _Description = string.Empty;
        string chmsg = string.Empty;
        public List<CancellationCheckerResponse> GetCancellationCheckerAllRecord(CancellationCheckerRequest cancellationCheckerRequest)
        {
            DataTable dt = dal.GetCancellationCheckerNormalTrxn(cancellationCheckerRequest);
            dt.Merge(dal.GetCancellationCheckerMGTrxn(cancellationCheckerRequest));
            dt.AcceptChanges();
            List<CancellationCheckerResponse> lstCancellationCheckerResponse = new List<CancellationCheckerResponse>();

            foreach (DataRow row in dt.Rows)
            {
                CancellationCheckerResponse _ancellationCheckerResponse = new CancellationCheckerResponse();
                if (!string.IsNullOrEmpty(Convert.ToString(row["LogID"])))
                {
                    _ancellationCheckerResponse.LogID = Convert.ToInt32(row["LogID"]);
                }
                else
                {
                    _ancellationCheckerResponse.LogID = null;
                }
                _ancellationCheckerResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                _ancellationCheckerResponse.TrxnDate = Convert.ToString(row["TrxnDate"]);
                _ancellationCheckerResponse.App_ID = Convert.ToString(row["App_ID"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["Old_Status"])))
                {
                    _ancellationCheckerResponse.Old_Status = Convert.ToInt32(row["Old_Status"]);
                }
                else
                {
                    _ancellationCheckerResponse.Old_Status = null;
                }
                _ancellationCheckerResponse.PayInCCY = Convert.ToString(row["PayInCCY"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["LC_Amount"])))
                {
                    _ancellationCheckerResponse.LC_Amount = Convert.ToDecimal(row["LC_Amount"]);
                }
                else
                {
                    _ancellationCheckerResponse.LC_Amount = null;
                }
                _ancellationCheckerResponse.PayOutCountry = Convert.ToString(row["PayOutCountry"]);
                _ancellationCheckerResponse.PayOutCCY = Convert.ToString(row["PayOutCCY"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["FC_Amount"])))
                {
                    _ancellationCheckerResponse.FC_Amount = Convert.ToDecimal(row["FC_Amount"]);
                }
                else
                {
                    _ancellationCheckerResponse.FC_Amount = null;
                }
                _ancellationCheckerResponse.CancelledBy = Convert.ToString(row["CancelledBy"]);
                _ancellationCheckerResponse.CancelledDate = Convert.ToString(row["CancelledDate"]);
                _ancellationCheckerResponse.MRemarks = Convert.ToString(row["MRemarks"]);
                _ancellationCheckerResponse.CheckedBy = Convert.ToString(row["CheckedBy"]);
                _ancellationCheckerResponse.CheckedDate = Convert.ToString(row["CheckedDate"]);
                _ancellationCheckerResponse.CancelledType = Convert.ToString(row["CancelledType"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["CanCode"])))
                {
                    _ancellationCheckerResponse.CanCode = Convert.ToInt32(row["CanCode"]);
                }
                else
                {
                    _ancellationCheckerResponse.CanCode = null;
                }

                _ancellationCheckerResponse.RF_Amount = Convert.ToString(row["RF_Amount"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["IsApproved"])))
                {
                    _ancellationCheckerResponse.IsApproved = Convert.ToInt32(row["IsApproved"]);
                }
                else
                {
                    _ancellationCheckerResponse.IsApproved = null;
                }
                _ancellationCheckerResponse.Remarks = Convert.ToString(row["Remarks"]);
                _ancellationCheckerResponse.hLink = Convert.ToString(row["hLink"]);
                lstCancellationCheckerResponse.Add(_ancellationCheckerResponse);
            }

            return lstCancellationCheckerResponse;
        }

        public List<TransactionStatusLog> GetChannelHoldTransactionLog(string TransactionNumber)
        {
            DataTable dt = dal.GetTransactionStatusLog(TransactionNumber);
            List<TransactionStatusLog> lstTransactionStatus = new List<TransactionStatusLog>();

            foreach (DataRow row in dt.Rows)
            {
                TransactionStatusLog _transactionStatusResponse = new TransactionStatusLog();
                _transactionStatusResponse.LogID = Convert.ToInt32(row["LogID"]);
                _transactionStatusResponse.SRTRNo = Convert.ToString(row["SRTRNo"]);
                _transactionStatusResponse.ActionName = Convert.ToString(row["ActionName"]);
                _transactionStatusResponse.SentDate = Convert.ToString(row["SentDate"]);
                _transactionStatusResponse.PrevValue = Convert.ToString(row["PrevValue"]);
                _transactionStatusResponse.UpdatedValue = Convert.ToString(row["UpdatedValue"]);
                _transactionStatusResponse.Remarks = Convert.ToString(row["Remarks"]);
                _transactionStatusResponse.ActionDate = Convert.ToString(row["ActionDate"]);
                _transactionStatusResponse.ActionTime = Convert.ToString(row["ActionTime"]);
                _transactionStatusResponse.ActionBy = Convert.ToString(row["ActionBy"]);
                lstTransactionStatus.Add(_transactionStatusResponse);
            }

            return lstTransactionStatus;
        }

        public List<CancellationCheckerResponse> GetCancellationCheckerView(string TransactionNumber)
        {
            DataTable dt = new DataTable();
            Boolean isMGTrxn = dal.chkTrxnType(TransactionNumber);

            if (isMGTrxn == true)
            {
                dt = dal.GetCancellationCheckerTransactionMGTrxn(TransactionNumber);
            }
            else
            {
                dt = dal.GetCancellationCheckerTransactionNormalTrxn(TransactionNumber);
            }
            List<CancellationCheckerResponse> lstCancellationCheckerResponse = new List<CancellationCheckerResponse>();

            foreach (DataRow row in dt.Rows)
            {
                CancellationCheckerResponse _ancellationCheckerResponse = new CancellationCheckerResponse();
                if (!string.IsNullOrEmpty(Convert.ToString(row["LogID"])))
                {
                    _ancellationCheckerResponse.LogID = Convert.ToInt32(row["LogID"]);
                }
                else
                {
                    _ancellationCheckerResponse.LogID = null;
                }
                _ancellationCheckerResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                _ancellationCheckerResponse.TrxnDate = Convert.ToString(row["TrxnDate"]);
                _ancellationCheckerResponse.App_ID = Convert.ToString(row["App_ID"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["Old_Status"])))
                {
                    _ancellationCheckerResponse.Old_Status = Convert.ToInt32(row["Old_Status"]);
                }
                else
                {
                    _ancellationCheckerResponse.Old_Status = null;
                }
                _ancellationCheckerResponse.PayInCCY = Convert.ToString(row["PayInCCY"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["LC_Amount"])))
                {
                    _ancellationCheckerResponse.LC_Amount = Convert.ToDecimal(row["LC_Amount"]);
                }
                else
                {
                    _ancellationCheckerResponse.LC_Amount = null;
                }
                _ancellationCheckerResponse.PayOutCountry = Convert.ToString(row["PayOutCountry"]);
                _ancellationCheckerResponse.PayOutCCY = Convert.ToString(row["PayOutCCY"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["FC_Amount"])))
                {
                    _ancellationCheckerResponse.FC_Amount = Convert.ToDecimal(row["FC_Amount"]);
                }
                else
                {
                    _ancellationCheckerResponse.FC_Amount = null;
                }
                _ancellationCheckerResponse.CancelledBy = Convert.ToString(row["CancelledBy"]);
                _ancellationCheckerResponse.CancelledDate = Convert.ToString(row["CancelledDate"]);
                _ancellationCheckerResponse.MRemarks = Convert.ToString(row["MRemarks"]);
                _ancellationCheckerResponse.CheckedBy = Convert.ToString(row["CheckedBy"]);
                _ancellationCheckerResponse.CheckedDate = Convert.ToString(row["CheckedDate"]);
                _ancellationCheckerResponse.CancelledType = Convert.ToString(row["CancelledType"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["CanCode"])))
                {
                    _ancellationCheckerResponse.CanCode = Convert.ToInt32(row["CanCode"]);
                }
                else
                {
                    _ancellationCheckerResponse.CanCode = null;
                }

                _ancellationCheckerResponse.RF_Amount = Convert.ToString(row["RF_Amount"]);
                if (!string.IsNullOrEmpty(Convert.ToString(row["IsApproved"])))
                {
                    _ancellationCheckerResponse.IsApproved = Convert.ToInt32(row["IsApproved"]);
                }
                else
                {
                    _ancellationCheckerResponse.IsApproved = null;
                }
                _ancellationCheckerResponse.Remarks = Convert.ToString(row["Remarks"]);
                _ancellationCheckerResponse.hLink = Convert.ToString(row["hLink"]);
                lstCancellationCheckerResponse.Add(_ancellationCheckerResponse);
            }

            return lstCancellationCheckerResponse;
        }

        public bool CancellationCheckerApproved(CancellationCheckerApproveRequest cancellationCheckerApproveRequest)
        {
            csMGCancelLog objcsMGCancelLog = new csMGCancelLog();
            Boolean isMGTrxn = false;
            string Message = "";
            int isMgSucess = 0;
            int isSucess = 0;
            string MGTrxnStatus = string.Empty;
            string MGError = string.Empty;
            decimal sendAmount = 0;
            decimal feeAmount = 0;
            string sendCurrency = string.Empty;
            string feeRefund = string.Empty;
            string operatorName = string.Empty;
            string RevReason = string.Empty;
            try
            {
                if (!string.IsNullOrEmpty(cancellationCheckerApproveRequest.G_UserID))
                {
                    throw new Exception("Please Close all windows and Login again.");
                }
                else
                {
                    csMG _csMG = new csMG();
                    string IsMTOSuccess = "N";
                    getCurrentTrxnStatus(cancellationCheckerApproveRequest.TransactionNumber);
                    //int isMgSucess = 0;
                    //int isSucess = 0;
                    //string MGTrxnStatus = string.Empty;
                    //string MGError = string.Empty;
                    //decimal sendAmount = 0;
                    //decimal feeAmount = 0;
                    //string sendCurrency = string.Empty;
                    //string feeRefund = string.Empty;
                    //string operatorName = string.Empty;

                    TrxnNo = cancellationCheckerApproveRequest.TransactionNumber;
                    int NewStatus = Convert.ToInt32(cancellationCheckerApproveRequest.CanCode);
                    RevReason = cancellationCheckerApproveRequest.ddlRevReason;

                    objcsMGCancelLog.TxnNumber = TrxnNo;
                    objcsMGCancelLog.CancelUser = cancellationCheckerApproveRequest.G_UserID;

                    if (NewStatus == 11)
                    {
                        feeRefund = "N";
                    }
                    else
                    {
                        feeRefund = "Y";
                    }

                    if (TrxnStatus == 0)
                    {
                        throw new Exception("Transaction number " + TrxnNo + " is not found");
                        //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "closePage", "window.close();", true);
                        //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "RedirectPage", "window.opener.location.href='frmCancellationChecker.aspx';", true);
                    }
                    else if (TrxnStatus == 37 || TrxnStatus == 38)
                    {
                        //btnApprove.Enabled = false;
                        //btnReject.Enabled = false;
                        //btnRecheck.Enabled = false;

                        if (!string.IsNullOrEmpty(cancellationCheckerApproveRequest.TransactionNumber))
                        {
                            #region added for MG_Cancellation by Khalid

                            isMGTrxn = dal.GetComplianceManagementTxnPrefix(TrxnNo);

                            if (isMGTrxn == true && IsMTOSuccess == "Y")
                            {
                                if (feeRefund == "N")
                                {
                                    if (!string.IsNullOrEmpty(TxnDateTime))
                                    {
                                        DateTime txntime = Convert.ToDateTime(TxnDateTime);
                                        if (DateTime.Now.Subtract(txntime).TotalHours < Convert.ToInt32(24))
                                        {
                                            throw new Exception("Request Cancellation do not refund charge after 24 Hours from transaction execution time.");
                                        }
                                    }
                                }


                                objcsMGCancelLog.RequestType = CanRequestType.Request;
                                objcsMGCancelLog.LogToDB();

                                DataTable dtLookUp = new DataTable();
                                //dtLookUp = _csMG.MG_detailLookup(Session["TrxnRef"].ToString(), TrxnNo);
                                dtLookUp = _csMG.MG_detailLookup(cancellationCheckerApproveRequest.App_ID.ToString(), TrxnNo);

                                if (dtLookUp.Rows.Count > 0)
                                {
                                    foreach (DataRow dr in dtLookUp.Rows)
                                    {
                                        isSucess = Convert.ToInt32(dr["IsSucess"]);
                                        MGTrxnStatus = dr["transactionStatus"].ToString();
                                        MGError = dr["ErrorDes"].ToString();
                                        sendAmount = Convert.ToDecimal(dr["sendAmount"]);
                                        feeAmount = Convert.ToDecimal(dr["feeAmount"]);
                                        sendCurrency = dr["sendCurrency"].ToString();
                                        operatorName = dr["operatorName"].ToString();
                                    }
                                }

                                if (isSucess == 1)
                                {
                                    if (MGTrxnStatus == "AVAIL" || MGTrxnStatus == "AFR" || MGTrxnStatus == "PRCSS")
                                    {
                                        DataTable dtMGCancel = new DataTable();
                                        //dtMGCancel = _csMG.MG_CancelTransaction(Session["TrxnRef"].ToString(), TrxnNo, sendAmount, feeAmount, sendCurrency, RevReason, feeRefund, operatorName);
                                        dtMGCancel = _csMG.MG_CancelTransaction(cancellationCheckerApproveRequest.App_ID, TrxnNo, sendAmount, feeAmount, sendCurrency, RevReason, feeRefund, operatorName);

                                        if (dtMGCancel.Rows.Count > 0)
                                        {
                                            foreach (DataRow dr in dtMGCancel.Rows)
                                            {
                                                isSucess = Convert.ToInt32(dr["IsSucess"]);
                                                MGError = dr["ErrorDes"].ToString();
                                            }
                                        }

                                        if (isSucess == 1)
                                        {
                                            isMgSucess = 1;
                                        }
                                        else
                                        {
                                            isMgSucess = 2;
                                        }
                                    }
                                    else if (MGTrxnStatus == "CANCL" || MGTrxnStatus == "REFND")
                                    {
                                        isMgSucess = 1;
                                    }
                                    else
                                    {
                                        isMgSucess = 2;
                                        //btnApprove.Visible = false;
                                        //btnReject.Visible = false;
                                        throw new Exception("This transaction cannot be cancelled.");
                                    }
                                }
                                else
                                {
                                    isMgSucess = 2;
                                    throw new Exception("MG_Error : " + MGError); ;
                                }
                            }

                            #endregion

                            if ((isMgSucess == 0) || (isMgSucess == 1))
                            {
                                string LogId = cancellationCheckerApproveRequest.LogID;
                                int OldStatus = Convert.ToInt32(cancellationCheckerApproveRequest.Old_Status.Trim());

                                string User = Convert.ToString(cancellationCheckerApproveRequest.G_UserID);
                                string Remarks = cancellationCheckerApproveRequest.txtR;
                                string _IsApproved = "1";
                                string _strSuccessFlag = string.Empty;
                                string _Description = string.Empty;

                                if (Remarks == null || Remarks == "")
                                {
                                    Remarks = "Transaction Cancellation Approved";
                                }

                                MyDt.Clear();
                                csCancellation _csCancellation = new csCancellation();

                                if (OldStatus == Status.Paid.GetHashCode())
                                {
                                    MyDt = _csCancellation.CancelPaidTransaction(TrxnNo, OldStatus, NewStatus, User, Remarks);
                                }
                                else
                                {
                                    MyDt = _csCancellation.CancelTransaction(TrxnNo, OldStatus, NewStatus, User, Remarks);
                                }

                                if (MyDt != null)
                                {
                                    foreach (DataRow dr in MyDt.Rows)
                                    {
                                        _strSuccessFlag = dr["strSuccessFlag"].ToString();
                                        _Description = dr["Description"].ToString();
                                    }
                                }

                                if (_strSuccessFlag != "0")
                                {
                                    UpdateTransaction(TrxnNo, LogId, Remarks, _IsApproved, NewStatus.ToString(), cancellationCheckerApproveRequest.G_UserID);

                                    if (isMGTrxn)
                                    {
                                        objcsMGCancelLog.Remark = "Request Completed";
                                        objcsMGCancelLog.Status = "S";
                                    }

                                    Message = "Cancellation request for transaction number " + TrxnNo + " is approved and transaction cancelled sucessfully";
                                    //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "closePage", "window.close();", true);
                                    // ClientScript.RegisterStartupScript(typeof(frmCanChecker), "RedirectPage", "window.opener.location.href='frmCancellationChecker.aspx';", true);
                                }
                                else
                                {
                                    //getdata();
                                    //btnApprove.Enabled = true;
                                    //btnReject.Enabled = true;
                                    //btnRecheck.Enabled = true;

                                    //btnApprove.Enabled = false;
                                    //btnReject.Enabled = false;
                                    //btnRecheck.Enabled = false;

                                    if (isMGTrxn)
                                    {
                                        objcsMGCancelLog.Remark = _Description;
                                        objcsMGCancelLog.Status = "C";
                                    }

                                    // DIV_Error.Visible = true;
                                    Message = _Description;
                                    //DIV_Error.Style.Add("color", "Red");
                                }
                            }
                            else
                            {
                                //btnApprove.Visible = false;
                                //btnReject.Visible = false;
                                // DIV_Error.Visible = true;
                                Message = "MG_Error : " + MGError;
                                //DIV_Error.Style.Add("color", "Red");

                                if (isMgSucess == 1 || isMgSucess == 2)
                                {
                                    objcsMGCancelLog.Remark = "MG_Error : " + MGError;
                                    objcsMGCancelLog.Status = "C";
                                }
                            }
                        }
                    }
                    else
                    {
                        Message = "Transaction number " + cancellationCheckerApproveRequest.TransactionNumber + " is not available for approval";
                        // ClientScript.RegisterStartupScript(typeof(frmCanChecker), "closePage", "window.close();", true);
                        // ClientScript.RegisterStartupScript(typeof(frmCanChecker), "RedirectPage", "window.opener.location.href='frmCancellationChecker.aspx';", true);
                    }
                }

                string result = JsonConvert.SerializeObject(cancellationCheckerApproveRequest);
                commonLogDetails.LogToDB("CancellationCheckerApproved", cancellationCheckerApproveRequest.G_UserID, "Success", "true", $"TransactionNumber: {cancellationCheckerApproveRequest.TransactionNumber},App_ID : {cancellationCheckerApproveRequest.App_ID},TrxnNo:{TrxnNo},sendAmount:{sendAmount},feeAmount:{feeAmount},sendCurrency:{sendCurrency},RevReason:{RevReason},FeeRefund:{feeRefund},operatorName:{operatorName}");

            }
            catch (Exception ex)
            {
                //getdata();
                objcsMGCancelLog.Remark = ex.Message;
                objcsMGCancelLog.Status = "C";
                Message = ex.Message.ToString();
                commonLogDetails.LogToDB("CancellationCheckerApproved", cancellationCheckerApproveRequest.G_UserID, objcsMGCancelLog.Remark, "Flase", $"TransactionNumber: {cancellationCheckerApproveRequest.TransactionNumber},App_ID : {cancellationCheckerApproveRequest.App_ID},TrxnNo:{TrxnNo},sendAmount:{sendAmount},feeAmount:{feeAmount},sendCurrency:{sendCurrency},RevReason:{RevReason},FeeRefund:{feeRefund},operatorName:{operatorName}");
            }
            finally
            {
                if (isMGTrxn)
                {
                    if (!string.IsNullOrEmpty(objcsMGCancelLog.RowID))
                    {
                        objcsMGCancelLog.RequestType = CanRequestType.Response;
                        objcsMGCancelLog.LogToDB();
                    }
                    objcsMGCancelLog = null;
                }
            }

            return true;
        }

        public void getCurrentTrxnStatus(string TrxnNo)
        {
            csMG _csMG = new csMG();
            Boolean isMgTrxn = false;

            try
            {
                if (!string.IsNullOrEmpty(TrxnNo))
                {
                    isMgTrxn = dal.GetComplianceManagementTxnPrefix(TrxnNo);

                    if (isMgTrxn == true)
                    {
                        csQueryBuilder _Query = new csQueryBuilder();
                        _Query.TableName = "sp_MG_Cancellation_MakerChecker";
                        _Query.QryType = csQueryBuilder.QueryType.Procedure;
                        _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                        _Query.Add("@SearchType", SqlDbType.Int, "2");
                        _Query.ViewType = csQueryBuilder.VType.View;
                        _Query.Add("@TransactionNumber", SqlDbType.NVarChar, TrxnNo.ToString());
                        _Query.Run();

                        csDatabase MyDb = new csDatabase(csCommon.GetConnectionString);
                        MyDt = MyDb.Return_DataTable(_Query.MyCmd);

                        if (MyDt.Rows.Count > 0)
                        {
                            TrxnStatus = Convert.ToInt32(MyDt.Rows[0]["StatusID"]);
                            TxnDateTime = Convert.ToString(MyDt.Rows[0]["TxnDateTime"]);
                            IsMTOSuccess = Convert.ToString(MyDt.Rows[0]["IsMTOSuccess"]);
                        }
                    }
                    else
                    {
                        csQueryBuilder _Query = new csQueryBuilder();
                        _Query.TableName = "spCancellation_MakerChecker";
                        _Query.QryType = csQueryBuilder.QueryType.Procedure;
                        _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                        _Query.Add("@SearchType", SqlDbType.Int, "2");
                        _Query.ViewType = csQueryBuilder.VType.View;
                        _Query.Add("@TransactionNumber", SqlDbType.NVarChar, TrxnNo.ToString());
                        _Query.Run();

                        csDatabase MyDb = new csDatabase(csCommon.GetConnectionString);
                        MyDt = MyDb.Return_DataTable(_Query.MyCmd);

                        if (MyDt.Rows.Count > 0)
                        {
                            TrxnStatus = Convert.ToInt32(MyDt.Rows[0]["TrStatusID"]);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public void UpdateTransaction(string TrxnNo, string LogId, string Remarks, string IsApproved, string Status, string G_UserID)
        {
            csMG _csMG = new csMG();
            Boolean isMgTrxn = false;

            try
            {
                isMgTrxn = dal.GetComplianceManagementTxnPrefix(TrxnNo);

                if (isMgTrxn == true)
                {
                    csQueryBuilder _Query = new csQueryBuilder();
                    _Query.TableName = "sp_MG_Cancellation_MakerChecker";
                    _Query.QryType = csQueryBuilder.QueryType.Procedure;
                    _Query.ProcedureType = csQueryBuilder.ProcType.Update;
                    _Query.ViewType = csQueryBuilder.VType.Process;
                    _Query.Add("@TransactionNumber", SqlDbType.NVarChar, TrxnNo);
                    _Query.Add("@LogID", SqlDbType.Int, LogId);
                    _Query.Add("@Remark", SqlDbType.NVarChar, Remarks);
                    _Query.Add("@IsApproved", SqlDbType.Int, IsApproved);
                    _Query.Add("@TrStatusID", SqlDbType.Int, Status);
                    _Query.Add("@UserID", SqlDbType.NVarChar, Convert.ToString(G_UserID));
                    _Query.Run();
                    csDatabase MyDb = new csDatabase(csCommon.ConnectionString);
                    MyDb.ExecuteNonQuery(_Query.MyCmd);
                }
                else
                {
                    csQueryBuilder _Query = new csQueryBuilder();
                    _Query.TableName = "spCancellation_MakerChecker";
                    _Query.QryType = csQueryBuilder.QueryType.Procedure;
                    _Query.ProcedureType = csQueryBuilder.ProcType.Update;
                    _Query.ViewType = csQueryBuilder.VType.Process;
                    _Query.Add("@TransactionNumber", SqlDbType.NVarChar, TrxnNo);
                    _Query.Add("@LogID", SqlDbType.Int, LogId);
                    _Query.Add("@Remark", SqlDbType.NVarChar, Remarks);
                    _Query.Add("@IsApproved", SqlDbType.Int, IsApproved);
                    _Query.Add("@TrStatusID", SqlDbType.Int, Status);
                    _Query.Add("@UserID", SqlDbType.NVarChar, Convert.ToString(G_UserID));
                    _Query.Run();
                    csDatabase MyDb = new csDatabase(csCommon.ConnectionString);
                    MyDb.ExecuteNonQuery(_Query.MyCmd);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public bool CancellationCheckerReject(CancellationCheckerRejectRequest cancellationCheckerRejectRequest)
        {
            string TrxnNo = string.Empty;
            string RowID = string.Empty;
            string LogId= string.Empty;
            string Status = string.Empty;
            string IsApproved = string.Empty;
            string Remarks = string.Empty;
            string User = string.Empty;

                if (string.IsNullOrEmpty(cancellationCheckerRejectRequest.G_UserID))
                {
                    throw new Exception("Please Close all windows and Login again.");
                }
                else
                {
                    
                    csCancellation _Cancellation = new csCancellation();

                    TrxnNo = cancellationCheckerRejectRequest.TransactionNumber;
                    LogId = cancellationCheckerRejectRequest.LogID.Trim();
                    Status = cancellationCheckerRejectRequest.Old_Status.Trim();
                    IsApproved = "2";
                    Remarks = cancellationCheckerRejectRequest.txtR;
                    User = Convert.ToString(cancellationCheckerRejectRequest.G_UserID);

                    if (Remarks == null || Remarks == "")
                    {
                        Remarks = "Transaction Cancellation Rejected";
                    }

                    try
                    {
                        #region Maintain DB log

                        RowID = _Cancellation.MaintaainDBLog("Req", 0, "RJT", TrxnNo, User, 2, Remarks, 0, 0, 0, null);

                        #endregion

                        getCurrentTrxnStatus(cancellationCheckerRejectRequest.TransactionNumber);

                        if (TrxnStatus == 0)
                        {
                            chmsg = "Transaction number " + cancellationCheckerRejectRequest.TransactionNumber + " is not found";

                            #region Maintain DB log

                            _Cancellation.MaintaainDBLog("Resp", Convert.ToInt32(RowID), "", "", "", 0, "", 0, 0, 0, chmsg);

                            #endregion

                            //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "closePage", "window.close();", true);
                            //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "RedirectPage", "window.opener.location.href='frmCancellationChecker.aspx';", true);
                        }
                        else if (TrxnStatus == 37 || TrxnStatus == 38)
                        {
                            UpdateTransaction(TrxnNo, LogId, Remarks, IsApproved, Status, cancellationCheckerRejectRequest.G_UserID);

                            chmsg = "Cancellation request for transaction number " + TrxnNo + " is Rejected.";

                            #region Maintain DB log

                            _Cancellation.MaintaainDBLog("Resp", Convert.ToInt32(RowID), "", "", "", 0, "", 0, 0, 0, chmsg);

                            #endregion

                            // ClientScript.RegisterStartupScript(typeof(frmCanChecker), "closePage", "window.close();", true);
                            // ClientScript.RegisterStartupScript(typeof(frmCanChecker), "RedirectPage", "window.opener.location.href='frmCancellationChecker.aspx';", true);
                        }
                        else
                        {
                            chmsg = "Transaction number " + cancellationCheckerRejectRequest.TransactionNumber + " is not available for approval";

                            #region Maintain DB log

                            _Cancellation.MaintaainDBLog("Resp", Convert.ToInt32(RowID), "", "", "", 0, "", 0, 0, 0, chmsg.ToString());

                            #endregion

                            //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "closePage", "window.close();", true);
                            //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "RedirectPage", "window.opener.location.href='frmCancellationChecker.aspx';", true);
                        }
                        commonLogDetails.LogToDB("CancellationCheckerReject", cancellationCheckerRejectRequest.G_UserID, "Success", "true", $"TransactionNumber: {cancellationCheckerRejectRequest.TransactionNumber},TrxnNo:{TrxnNo},LogId:{LogId},Status:{Status},IsApproved:{IsApproved},Remarks:{Remarks},User:{User},TrxnStatus:{TrxnStatus}");

                    }
                    catch (Exception ex)
                    {
                        #region Maintain DB log

                        _Cancellation.MaintaainDBLog("Resp", Convert.ToInt32(RowID), "", "", "", 0, "", 0, 0, 0, ex.Message);

                    #endregion
                    commonLogDetails.LogToDB("CancellationCheckerReject", cancellationCheckerRejectRequest.G_UserID, ex.ToString(), "Flase", $"TransactionNumber: {cancellationCheckerRejectRequest.TransactionNumber},TrxnNo:{TrxnNo},LogId:{LogId},Status:{Status},IsApproved:{IsApproved},Remarks:{Remarks},User:{User},TrxnStatus:{TrxnStatus}");
                    throw ex;
                    }
                    return true;
                }
                

        }

        public bool CancellationCheckerRecheck(CancellationCheckeRecheckRequest cancellationCheckeRecheckRequest)
        {
            try
            {
                if (!string.IsNullOrEmpty(cancellationCheckeRecheckRequest.TransactionNumber))
                {
                    TrxnNo = cancellationCheckeRecheckRequest.TransactionNumber;
                    string OrgMsgID = cancellationCheckeRecheckRequest.OrgMsgID.Trim();
                    string LogId = cancellationCheckeRecheckRequest.LogID.Trim();
                    int OldStatus = Convert.ToInt32(cancellationCheckeRecheckRequest.Old_Status);
                    int NewStatus = Convert.ToInt32(cancellationCheckeRecheckRequest.CanCode);
                    string User = Convert.ToString(cancellationCheckeRecheckRequest.G_UserID);
                    string Remarks = cancellationCheckeRecheckRequest.txtR;
                    string _IsApproved = "1";
                    string _strSuccessFlag = string.Empty;
                    string _Description = string.Empty;

                    if (Remarks == null || Remarks == "")
                    {
                        Remarks = "Transaction Cancellation Approval Rechecked";
                    }

                    MyDt.Clear();
                    csCancellation _csCancellation = new csCancellation();
                    MyDt = _csCancellation.CancelRecheck(TrxnNo, OrgMsgID, OldStatus, NewStatus, User, Remarks);

                    if (MyDt != null)
                    {
                        foreach (DataRow dr in MyDt.Rows)
                        {
                            _strSuccessFlag = dr["strSuccessFlag"].ToString();
                            _Description = dr["Description"].ToString();
                        }
                    }

                    if (_strSuccessFlag != "0")
                    {
                        UpdateTransaction(TrxnNo, LogId, Remarks, _IsApproved, NewStatus.ToString(), cancellationCheckeRecheckRequest.G_UserID);

                        String Message = "Cancellation request for transaction number " + TrxnNo + " is approved and transaction cancelled sucessfully";
                        //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "closePage", "window.close();", true);
                        //ClientScript.RegisterStartupScript(typeof(frmCanChecker), "RedirectPage", "window.opener.location.href='frmCancellationChecker.aspx';", true);
                    }
                    else
                    {
                        //getdata();
                        //btnApprove.Enabled = true;
                        //btnReject.Enabled = true;
                        //btnRecheck.Enabled = true;

                        //DIV_Error.Visible = true;
                        //this.DIV_Error.InnerText = _Description;
                        //DIV_Error.Style.Add("color", "Red");
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return true;
        }

    }
}