﻿using MyDatabase;
using Newtonsoft.Json;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Request;
using SAIB_Web_Api.Models.Response;
using SMQ;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;

namespace SAIB_Web_Api.BusinessManager
{
    public class ChannelCancelTransactionManager
    {
        DAL dal = new DAL();
        SqlConnection conn = null;
        SqlCommand cmd = null;
        SqlDataAdapter adapter = null;
        CommonLogDetails commonLogDetails = new CommonLogDetails();

        public List<ChannelCancelTransactionResponse> GetChannelCancelTransactionAllRecordByDate(string frmDate, string toDate, string TransactionStatus, int CustomerType)
        {
            try
            {
                string filter = string.Empty;
                if (TransactionStatus != "0")
                {
                    filter += " Mq.Status='" + TransactionStatus + "'";
                }
                if (CustomerType != 0)
                {
                    if (CustomerType == 1)
                        filter += string.IsNullOrEmpty(filter) ? " Mq.CustType = 1" : " AND Mq.CustType = 1";
                    else
                        filter += string.IsNullOrEmpty(filter) ? " Mq.CustType in (2,3,4)" : " AND Mq.CustType in (2,3,4)";
                }

                DataTable dt = dal.GetChannelCancelTransactionAllRecord(frmDate, toDate, filter);

                string str = JsonConvert.SerializeObject(dt);

                List<ChannelCancelTransactionResponse> lstChannelCancelTransactionResponse = new List<ChannelCancelTransactionResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    ChannelCancelTransactionResponse _channelCancelTransactionResponse = new ChannelCancelTransactionResponse();
                    _channelCancelTransactionResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                    _channelCancelTransactionResponse.Status = Convert.ToString(row["Status"]);
                    _channelCancelTransactionResponse.StatusDisplay = Convert.ToString(row["StatusDisplay"]);
                    _channelCancelTransactionResponse.StatusDisplay1 = Convert.ToString(row["StatusDisplay1"]);
                    _channelCancelTransactionResponse.TxnDateTime = Convert.ToString(row["TxnDateTime"]);
                    _channelCancelTransactionResponse.ProcessedDateTime = Convert.ToString(row["ProcessedDateTime"]);
                    _channelCancelTransactionResponse.ProcessedBy = Convert.ToString(row["ProcessedBy"]);
                    _channelCancelTransactionResponse.Remarks = Convert.ToString(row["Remarks"]);
                    _channelCancelTransactionResponse.OrgMsgID = Convert.ToString(row["OrgMsgID"]);
                    _channelCancelTransactionResponse.hLink = Convert.ToString(row["hLink"]);

                    lstChannelCancelTransactionResponse.Add(_channelCancelTransactionResponse);
                }

                string result = JsonConvert.SerializeObject(lstChannelCancelTransactionResponse);
                commonLogDetails.LogToDB("GetChannelCancelTransactionAllRecordByDate", "N/A", "Success", "true", $"FromDate: {frmDate},ToDate : {toDate},TransactionStatus:{TransactionStatus},CustomerType:{CustomerType}");

                return lstChannelCancelTransactionResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetChannelCancelTransactionAllRecordByDate", "N/A", ex.ToString(), "Flase", $"FromDate: {frmDate},ToDate : {toDate},TransactionStatus:{TransactionStatus},CustomerType:{CustomerType}");
                throw ex;
            }
        }

        public List<ChannelCancelTransactionResponse> GetChannelCancelTransactionAllRecordByTransactionNumber(string TransactionNumber, string TransactionStatus, int CustomerType)
        {
            try
            {
                string filter = string.Empty;
                if (!string.IsNullOrEmpty(TransactionNumber))
                {
                    filter = " Mq.TransactionNumber ='" + TransactionNumber.Trim() + "'";
                }

                if (TransactionStatus != "0")
                {
                    filter += string.IsNullOrEmpty(filter) ? " Mq.Status='" + TransactionStatus + "'" : " AND Mq.Status='" + TransactionStatus + "'";
                }
                if (CustomerType != 0)
                {
                    if (CustomerType == 1)
                        filter += string.IsNullOrEmpty(filter) ? " Mq.CustType = 1" : " AND Mq.CustType = 1";
                    else
                        filter += string.IsNullOrEmpty(filter) ? " Mq.CustType in (2,3,4)" : " AND Mq.CustType in (2,3,4)";
                }

                DataTable dt = dal.GetChannelCancelTransactionAllRecord(null, null, filter);

                string str = JsonConvert.SerializeObject(dt);

                List<ChannelCancelTransactionResponse> lstChannelCancelTransactionResponse = new List<ChannelCancelTransactionResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    ChannelCancelTransactionResponse _channelCancelTransactionResponse = new ChannelCancelTransactionResponse();
                    _channelCancelTransactionResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                    _channelCancelTransactionResponse.Status = Convert.ToString(row["Status"]);
                    _channelCancelTransactionResponse.StatusDisplay = Convert.ToString(row["StatusDisplay"]);
                    _channelCancelTransactionResponse.StatusDisplay1 = Convert.ToString(row["StatusDisplay1"]);
                    _channelCancelTransactionResponse.TxnDateTime = Convert.ToString(row["TxnDateTime"]);
                    _channelCancelTransactionResponse.ProcessedDateTime = Convert.ToString(row["ProcessedDateTime"]);
                    _channelCancelTransactionResponse.ProcessedBy = Convert.ToString(row["ProcessedBy"]);
                    _channelCancelTransactionResponse.Remarks = Convert.ToString(row["Remarks"]);
                    _channelCancelTransactionResponse.OrgMsgID = Convert.ToString(row["OrgMsgID"]);
                    _channelCancelTransactionResponse.hLink = Convert.ToString(row["hLink"]);

                    lstChannelCancelTransactionResponse.Add(_channelCancelTransactionResponse);
                }

                string result = JsonConvert.SerializeObject(lstChannelCancelTransactionResponse);
                commonLogDetails.LogToDB("GetChannelCancelTransactionAllRecordByTransactionNumber", "N/A", "Success", "true", $"TransactionNumber: {TransactionNumber},TransactionStatus : {TransactionStatus},CustomerType:{CustomerType}");

                return lstChannelCancelTransactionResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetChannelCancelTransactionAllRecordByTransactionNumber", "N/A", ex.ToString(), "Flase", $"TransactionNumber: {TransactionNumber},TransactionStatus : {TransactionStatus},CustomerType:{CustomerType}");
                throw ex;
            }
        }

        public bool ChannelCancelTransactionCancellationStatus(ChannelCancelTransactionRequest channelCancelTransactionRequest)
        {
            try
            {
                bool Result = false;


                if (string.IsNullOrEmpty(channelCancelTransactionRequest.G_UserID))
                {
                    throw new Exception("<b>" + "Please Logout and Login again." + "</b>");

                }
                else
                {

                    int isMgSucess = ProcessMGCancellation(channelCancelTransactionRequest.TransactionNumber, channelCancelTransactionRequest.G_UserID, channelCancelTransactionRequest.Remark);


                    if (isMgSucess == 1)
                    {
                        #region Doubtful Request
                        if (!string.IsNullOrWhiteSpace(channelCancelTransactionRequest.CustomerType) && channelCancelTransactionRequest.CustomerType != "1")
                        {
                            ICSDoubtFulCancelRequest objICSDoubtFulRequest = new ICSDoubtFulCancelRequest();
                            objICSDoubtFulRequest.OriginalMsgID = channelCancelTransactionRequest.OrgMsgID.Trim();
                            objICSDoubtFulRequest.ReferenceNo = channelCancelTransactionRequest.TransactionNumber;
                            objICSDoubtFulRequest.CustType = channelCancelTransactionRequest.CustomerType;
                            objICSDoubtFulRequest.CancelUser = channelCancelTransactionRequest.G_UserID;
                            bool success = objICSDoubtFulRequest.SentToICS();
                            if (success)
                            {
                                if (ProcessedTransaction("S", channelCancelTransactionRequest.TransactionNumber, channelCancelTransactionRequest.Remark, channelCancelTransactionRequest.G_UserID, channelCancelTransactionRequest.CustomerType, channelCancelTransactionRequest.OrgMsgID))
                                {
                                    //send db updation request
                                    DataTable dtData = GetDetails(channelCancelTransactionRequest.TransactionNumber);
                                    ChannelRequest objChannelRequest = new ChannelRequest();
                                    objChannelRequest.ReferenceNo = channelCancelTransactionRequest.TransactionNumber;
                                    objChannelRequest.CancelRequstedUser = Convert.ToString(channelCancelTransactionRequest.G_UserID);
                                    objChannelRequest.IsReverse = false;
                                    switch (Convert.ToString(dtData.Rows[0]["TxnStatus"]))
                                    {
                                        case "4":
                                            objChannelRequest.CancelType = CancelType.ComplianceBlockCancel;
                                            objChannelRequest.StatusValue = 25;
                                            break;
                                        case "26":
                                            objChannelRequest.CancelType = CancelType.ComplianceHoldCancel;
                                            objChannelRequest.StatusValue = 25;
                                            break;
                                        case "37":
                                            objChannelRequest.CancelType = CancelType.NormalCancel;
                                            objChannelRequest.StatusValue = 10;
                                            break;
                                        case "38":
                                            objChannelRequest.CancelType = CancelType.NormalCancel;
                                            objChannelRequest.StatusValue = 11;
                                            objChannelRequest.IsReverse = true;
                                            break;
                                    }

                                    objChannelRequest.CancelMessage = channelCancelTransactionRequest.Remark;
                                    objChannelRequest.PartnerCode = Convert.ToInt32(dtData.Rows[0]["PartnerCode"]);
                                    objChannelRequest.CustType = channelCancelTransactionRequest.CustomerType;
                                    if (objChannelRequest.ProcessDBCancellation())
                                    {
                                        //check khalid code for cs cancellation
                                        //objICSDoubtFulRequest.UpdateTransaction();

                                        Result = true;
                                    }
                                    else
                                    {
                                        throw new Exception(objChannelRequest.Description + "Y");
                                    }
                                }

                            }
                            else
                            {
                                if (objICSDoubtFulRequest.NNN)
                                {
                                    //btnRecheck.Enabled = false;
                                    //btnSend.Enabled = true;
                                }
                                else
                                {

                                    //DisplayMessage(objICSDoubtFulRequest.ResponseCode.ToString() + "-" + objICSDoubtFulRequest.Description, (objICSDoubtFulRequest.ResponseCode.ToString() == "000" ? "N" : "Y"));

                                }
                            }
                        }
                        else
                        {
                            //Need to define process for PPS customer , Currently NOT available.
                            throw new Exception("PPS Transaction, Please Contact Administrator." + "Y");
                        }
                        #endregion
                    }
                }

                string result = JsonConvert.SerializeObject(channelCancelTransactionRequest);
                commonLogDetails.LogToDB("ChannelCancelTransactionCancellationStatus", "N/A", "Success", "true", result);

                return Result;
            }
            catch (Exception ex)
            {
                string result = JsonConvert.SerializeObject(channelCancelTransactionRequest);
                commonLogDetails.LogToDB("ChannelCancelTransactionCancellationStatus", "N/A", ex.ToString(), "Flase", result);
                throw ex;
            }
        }

        public int ProcessMGCancellation(string TxnNo, string UserID, string Remark)
        {
            try
            {
                int isMgSucess = 0;
                Boolean isMGTrxn = false;

                int isSucess = 0;
                string MGTrxnStatus = string.Empty;
                string MGError = string.Empty;
                decimal sendAmount = 0;
                decimal feeAmount = 0;
                string sendCurrency = string.Empty;
                string feeRefund = string.Empty;
                string operatorName = string.Empty;

                csMG _csMG = new csMG();
                isMGTrxn = dal.GetComplianceManagementTxnPrefix(TxnNo);
                if (isMGTrxn == true)
                {
                    if (CheckMGCancellationStatus(TxnNo))
                    {
                        isMgSucess = 1;
                    }
                    else
                    {
                        csMGCancelLog objcsMGCancelLog = new csMGCancelLog();
                        objcsMGCancelLog.TxnNumber = TxnNo;
                        objcsMGCancelLog.CancelUser = Convert.ToString(UserID);

                        objcsMGCancelLog.RequestType = CanRequestType.Request;
                        objcsMGCancelLog.LogToDB();

                        string MG_referenceNumber = "";
                        var paramObj = new { Txn_No = TxnNo };
                        MG_referenceNumber = _csMG.get_tbl_data("usp_Get_MG_RefNumber", paramObj).Tables[0].Rows[0]["MG_refno"].ToString();

                        DataTable dtLookUp = new DataTable();
                        dtLookUp = _csMG.MG_detailLookup(MG_referenceNumber, TxnNo);

                        if (dtLookUp.Rows.Count > 0)
                        {
                            foreach (DataRow dr in dtLookUp.Rows)
                            {
                                isSucess = Convert.ToInt32(dr["IsSucess"]);
                                MGTrxnStatus = dr["transactionStatus"].ToString();
                                MGError = dr["ErrorDes"].ToString();
                                sendAmount = Convert.ToDecimal(dr["sendAmount"]);
                                feeAmount = Convert.ToDecimal(dr["feeAmount"]);
                                sendCurrency = dr["sendCurrency"].ToString();
                                operatorName = dr["operatorName"].ToString();
                            }
                        }
                        if (isSucess == 1)
                        {
                            if (MGTrxnStatus == "AVAIL" || MGTrxnStatus == "AFR" || MGTrxnStatus == "PRCSS")
                            {
                                DataTable dtMGCancel = new DataTable();
                                dtMGCancel = _csMG.MG_CancelTransaction(MG_referenceNumber, TxnNo, sendAmount, feeAmount, sendCurrency, Remark, feeRefund, operatorName);

                                if (dtMGCancel.Rows.Count > 0)
                                {
                                    foreach (DataRow dr in dtMGCancel.Rows)
                                    {
                                        isSucess = Convert.ToInt32(dr["IsSucess"]);
                                        MGError = dr["ErrorDes"].ToString();
                                    }
                                }

                                if (isSucess == 1)
                                {
                                    isMgSucess = 1;
                                }
                            }
                            else if (MGTrxnStatus == "CANCL" || MGTrxnStatus == "REFND")
                            {
                                isMgSucess = 1;
                            }
                            else
                            {
                                throw new Exception("This transaction cannot be cancelled." + "Y");
                            }
                        }
                    }
                }
                else
                {
                    isMgSucess = 1;
                }

                commonLogDetails.LogToDB("ProcessMGCancellation", "N/A", "Success", "true", $"TransactionNumber : {TxnNo},UserID:{UserID},Remark:{Remark}");
                return isMgSucess;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ProcessMGCancellation", "N/A", ex.ToString(), "Flase", $"TransactionNumber : {TxnNo},UserID:{UserID},Remark:{Remark}");
                throw ex;
            }
        }

        public bool CheckMGCancellationStatus(string TxnNo)
        {
            Boolean IsMGCancel = false;

            DataTable dt = new DataTable();
            try
            {
                using (conn = new SqlConnection(csCommon.GetConnectionString))
                {
                    cmd = new SqlCommand("sp_MG_Check_CancelStatus", conn);
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.AddWithValue("@Txn_No", TxnNo);

                    adapter = new SqlDataAdapter(cmd);
                    adapter.Fill(dt);
                    if (dt != null && dt.Rows.Count > 0)
                    {
                        if (Convert.ToString(dt.Rows[0]["MGCancelRef"]) != "")
                        {
                            IsMGCancel = true;
                        }
                    }
                }

                commonLogDetails.LogToDB("CheckMGCancellationStatus", "N/A", "Success", "true", $"TransactionNumber : {TxnNo}");
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("CheckMGCancellationStatus", "N/A", ex.ToString(), "Flase", $"TransactionNumber : {TxnNo}");
                throw ex;
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }

            return IsMGCancel;
        }

        public bool ProcessedTransaction(string status, string TransactionNumber, string Remark, string UserID, string CustomerType, string OrgMsgID)
        {
            #region Processed Transaction
            bool isSuccess = false;

            try
            {
                using (conn = new SqlConnection(csCommon.ConnectionString))
                {
                    cmd = new SqlCommand("sp_Channel_Cancel_DoubtFul_Trasnactions", conn);
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.AddWithValue("@ProcedureType", 1);
                    cmd.Parameters.AddWithValue("@TransactionNumber", TransactionNumber.Trim());
                    cmd.Parameters.AddWithValue("@Remarks", Remark.Trim());
                    cmd.Parameters.AddWithValue("@Status", status);
                    cmd.Parameters.AddWithValue("@ProcessedBy", UserID);
                    cmd.Parameters.AddWithValue("@CustType", CustomerType.Trim());
                    cmd.Parameters.AddWithValue("@OrgMsgID", OrgMsgID);


                    if (conn.State == ConnectionState.Closed)
                    {
                        conn.Open();
                    }
                    cmd.ExecuteNonQuery();
                }

                commonLogDetails.LogToDB("ProcessedTransaction", UserID, "Success", "true", $"TransactionNumber : {TransactionNumber},Status:{status},Remark : {Remark},CustomerType:{CustomerType},OrgMsgID:{OrgMsgID}");

                isSuccess = true;

            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ProcessedTransaction", UserID, ex.ToString(), "Flase", $"TransactionNumber : {TransactionNumber},Status:{status},Remark : {Remark},CustomerType:{CustomerType},OrgMsgID:{OrgMsgID}");
                throw ex;
            }
            finally
            {
                cmd.Dispose();
                conn.Close();
            }

            return isSuccess;
            #endregion
        }

        public DataTable GetDetails(string TxnNo)
        {
            DataTable dt = new DataTable();

            try
            {
                #region UserCode
                using (conn = new SqlConnection(csCommon.GetConnectionString))
                {
                    cmd = new SqlCommand("sp_Channel_Cancel_DoubtFul_Trasnactions", conn);
                    cmd.Parameters.AddWithValue("@ProcedureType", 0);
                    cmd.Parameters.AddWithValue("@ViewType", 1);
                    cmd.Parameters.AddWithValue("@TransactionNumber", TxnNo);

                    cmd.CommandType = CommandType.StoredProcedure;
                    adapter = new SqlDataAdapter(cmd);
                    adapter.Fill(dt);
                    if (dt != null && dt.Rows.Count > 0)
                    {

                    }
                    else
                    {
                        //showError("No Record Found.");
                    }
                }

                #endregion
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {

            }
            return dt;
        }

        public bool ChannelCancelTransactionSend(ChannelCancelTransactionSendRequest channelCancelTransactionSendRequest)
        {
            try
            {
                bool Result = false;
                if (string.IsNullOrEmpty(channelCancelTransactionSendRequest.G_UserID))
                {
                    throw new Exception("<b>" + "Please Logout and Login again." + "</b>");
                }
                else
                {
                    string TransNo = channelCancelTransactionSendRequest.TransactionNumber;
                    int isMgSucess = ProcessMGCancellation(channelCancelTransactionSendRequest.TransactionNumber, channelCancelTransactionSendRequest.G_UserID, channelCancelTransactionSendRequest.Remark);
                    if (isMgSucess == 1)
                    {
                        #region Send Host Request
                        DataTable dtData = GetDetails(channelCancelTransactionSendRequest.TransactionNumber);

                        string RejectReason = string.Empty;
                        RejectReason = channelCancelTransactionSendRequest.Remark;

                        string PartnerCode = Convert.ToString(dtData.Rows[0]["PartnerCode"]);
                        string TxnStatus = Convert.ToString(dtData.Rows[0]["TxnStatus"]);

                        csQueryBuilder _query = new csQueryBuilder();
                        csDatabase MyDB = new csDatabase(csCommon.ConnectionString);
                        //DataTable MyDt;

                        string _strSuccessFlag = "0";
                        try
                        {
                            #region ICS PPS REQUEST

                            if (channelCancelTransactionSendRequest.CustomerType == "1")
                            {
                                #region PPS
                                throw new Exception("PPS Transaction, Please Contact Administrator. ," + "Y");

                                #endregion

                            }
                            else
                            {
                                #region ICS

                                ICSRequest objICSRequest = new ICSRequest();
                                objICSRequest.IsReverse = false;
                                switch (TxnStatus)
                                {
                                    case "4":
                                        objICSRequest.CancelType = CancelType.ComplianceBlockCancel;
                                        break;
                                    case "26":
                                        objICSRequest.CancelType = CancelType.ComplianceHoldCancel;
                                        break;
                                    case "37":
                                        objICSRequest.CancelType = CancelType.NormalCancel;
                                        break;
                                    case "38":
                                        objICSRequest.CancelType = CancelType.NormalCancel;
                                        objICSRequest.IsReverse = true;
                                        break;

                                }
                                objICSRequest.ReferenceNo = TransNo;
                                objICSRequest.PartnerCode = Convert.ToInt32(PartnerCode);
                                objICSRequest.CancelMessage = RejectReason;
                                objICSRequest.CustType = channelCancelTransactionSendRequest.CustomerType;
                                objICSRequest.CancelRequstedUser = Convert.ToString(channelCancelTransactionSendRequest.G_UserID);

                                if (objICSRequest.SentToICS())
                                {
                                    _strSuccessFlag = "1";

                                }
                                else
                                {
                                    _strSuccessFlag = "0";

                                    if (objICSRequest.Description.Contains("Could not read message"))
                                    {
                                        //btnRecheck.Enabled = true;
                                        //btnSend.Enabled = false;
                                    }
                                }

                                #endregion
                            }
                            #endregion

                            if (_strSuccessFlag == "1")
                            {
                                //DisplayMessage("Request Process Successfully.", "N");
                                Result = true;
                            }
                        }
                        catch (Exception ex)
                        {
                            throw ex;
                        }
                        #endregion
                    }
                }


                string result = JsonConvert.SerializeObject(channelCancelTransactionSendRequest);
                commonLogDetails.LogToDB("ChannelCancelTransactionSend", channelCancelTransactionSendRequest.G_UserID, "Success", "True", result);

                return Result;
            }
            catch (Exception ex)
            {
                string result = JsonConvert.SerializeObject(channelCancelTransactionSendRequest);
                commonLogDetails.LogToDB("ChannelCancelTransactionSend", channelCancelTransactionSendRequest.G_UserID, ex.ToString(), "Flase", result);
                throw ex;
            }
        }
    }

    public class ICSDoubtFulCancelRequest
    {
        internal int ResponseCode { get; set; }
        internal string Description { get; set; }
        internal string ReferenceNo { get; set; }
        internal string OriginalMsgID { get; set; }
        internal string RCID { get; set; }
        internal bool IsDoubtfulFail { get; set; }
        internal string BeneficiaryNo { get; set; }
        internal string PaymentMode { get; set; }
        internal string CustType { get; set; }

        public bool IsHostSuccess { get; set; }
        internal bool NNN { get; set; }
        internal string CancelUser { get; set; }
        clsSMQ objSMQ;

        public ICSDoubtFulCancelRequest()
        {
            objSMQ = new clsSMQ();
            objSMQ.SQL_Database_Name = ConfigurationManager.AppSettings["SQL_Database_Name"].ToString();
            objSMQ.SQL_Password = ConfigurationManager.AppSettings["SQL_Password"].ToString();
            objSMQ.SQL_Server_IP = ConfigurationManager.AppSettings["SQL_Server_IP"].ToString();
            objSMQ.SQL_Server_Port = ConfigurationManager.AppSettings["SQL_Server_Port"].ToString();
            objSMQ.SQL_UserName = ConfigurationManager.AppSettings["SQL_UserName"].ToString();
        }

        internal bool SentToICS()
        {
            #region Declare Variables
            bool IsSuccess = false;
            csQueryBuilder _Query;
            csDatabase _MyDB;
            DataTable MyDT;
            CommonLogDetails commonLogDetails = new CommonLogDetails();
            #endregion

            if (CheckCurrentStauts())
            {
                CheckHostSuccess();

                if (IsHostSuccess)
                {
                    IsSuccess = true;
                }
                else
                {
                    clsDoubtfulMessage_Response DoubtfulRes = new clsDoubtfulMessage_Response();
                    clsFundsTransfer objFundTrf = new clsFundsTransfer();
                    clsFundsTransfer_Response objFundTrfRes = new clsFundsTransfer_Response();

                    string strMID = "";
                    string ICSLoggedInUser = "";

                    try
                    {

                        #region Set Parameters
                        _Query = new csQueryBuilder();
                        _Query.TableName = "spMQConnectionData";
                        _Query.QryType = csQueryBuilder.QueryType.Procedure;
                        _Query.ViewType = csQueryBuilder.VType.Process;
                        _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                        _Query.Run();
                        _MyDB = new csDatabase(csCommon.GetConnectionString);
                        MyDT = _MyDB.Return_DataTable(_Query.MyCmd);

                        objSMQ._LogPath = ConfigurationManager.AppSettings["MQLog"].ToString();
                        objSMQ._MQ_Machine = MyDT.Rows[0]["MQ_Machine"].ToString();
                        objSMQ._Unit = MyDT.Rows[0]["Unit"].ToString();//"QRD";
                        objSMQ._LoggedUser = MyDT.Rows[0]["LoggedUser"].ToString();
                        ICSLoggedInUser = MyDT.Rows[0]["LoggedUser"].ToString();
                        objSMQ._SrcEnvName = MyDT.Rows[0]["SrcEnvName"].ToString();
                        objSMQ._SrcSysName = MyDT.Rows[0]["SrcSysName"].ToString();
                        objSMQ._DstEnvName = MyDT.Rows[0]["DstEnvName"].ToString();
                        objSMQ._DstSysName = MyDT.Rows[0]["DstSysName"].ToString();
                        objSMQ._BrnCde = MyDT.Rows[0]["BrnCde"].ToString();
                        objSMQ._MQ_Channel = MyDT.Rows[0]["MQ_Channel"].ToString();
                        objSMQ._MQ_ReadQueue = MyDT.Rows[0]["MQ_ReadQueue"].ToString();
                        objSMQ._MQ_WriteQueue = MyDT.Rows[0]["MQ_WriteQueue"].ToString();
                        objSMQ._TmeOut = Convert.ToInt32(MyDT.Rows[0]["TmeOut"].ToString());
                        objSMQ._MQ_Server = MyDT.Rows[0]["MQ_Server"].ToString();

                        if (ReferenceNo != null)
                            objSMQ.TxnNumber = (ReferenceNo.Length < 8) ? ReferenceNo.PadLeft(8, 'P') : ReferenceNo.Substring(ReferenceNo.Length - 8, 8);
                        #endregion




                        bool _isbool = false;
                        try
                        {
                            _isbool = objSMQ.Connect(true);
                        }
                        catch
                        {
                            ResponseCode = 301;
                            Description = "Could not connected to ICS System";
                        }


                        if (_isbool == true)
                        {

                            #region Set Commission Amount
                            _Query = new csQueryBuilder();
                            _Query.TableName = "spGetCommissionForTransactionAPI";
                            _Query.QryType = csQueryBuilder.QueryType.Procedure;
                            _Query.ViewType = csQueryBuilder.VType.Process;
                            _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                            _Query.Add("@TransactioNUmber", SqlDbType.NVarChar, ReferenceNo);
                            _Query.Run();
                            _MyDB = new csDatabase(csCommon.GetConnectionString);
                            DataTable MyDt1 = new DataTable();
                            MyDt1 = _MyDB.Return_DataTable(_Query.MyCmd);

                            if (CustType == "4")
                            {
                                objFundTrf = objSMQ.Build_FundTransfer_FromDB_DWR(ReferenceNo, "RMT");
                            }
                            else
                            {
                                objFundTrf = objSMQ.Build_FundTransfer_FromDB(ReferenceNo, "RMT");
                            }
                            objFundTrf.FinBrnReq.AmtChgCnt = 1;

                            structAmtChg[] AmtChgs = new structAmtChg[4];

                            if (MyDt1 != null && MyDt1.Rows.Count > 0)
                            {
                                AmtChgs[0].ChgAmt = MyDt1.Rows[0]["BaseToBaseCommissionAmount"].ToString().PadLeft(11, '0');
                            }

                            AmtChgs[0].ChgCde = "FR    ";
                            AmtChgs[0].ChgDsc = "FLEX TRFR REMIT";

                            AmtChgs[1].ChgAmt = "00000000000";
                            AmtChgs[1].ChgCde = "      ";
                            AmtChgs[1].ChgDsc = "               ";

                            AmtChgs[2].ChgAmt = "00000000000";
                            AmtChgs[2].ChgCde = "      ";
                            AmtChgs[2].ChgDsc = "               ";

                            AmtChgs[3].ChgAmt = "00000000000";
                            AmtChgs[3].ChgCde = "      ";
                            AmtChgs[3].ChgDsc = "               ";


                            objFundTrf.FinBrnReq.AmtChg = AmtChgs;
                            #endregion

                            #region Get Original MessageId from Database
                            _Query = new csQueryBuilder();
                            _Query.TableName = "sp_Maintain_MQTransactionLog";
                            _Query.QryType = csQueryBuilder.QueryType.Procedure;
                            _Query.ViewType = csQueryBuilder.VType.Process;
                            _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                            _Query.Add("@TransactionNo", SqlDbType.NVarChar, ReferenceNo);
                            _Query.Add("@MsgID", SqlDbType.NVarChar, OriginalMsgID);
                            _Query.Run();
                            _MyDB = new csDatabase(csCommon.GetConnectionString);
                            DataTable MQMID = new DataTable();
                            MQMID = _MyDB.Return_DataTable(_Query.MyCmd);

                            if (MQMID != null && MQMID.Rows.Count > 0)
                            {
                                strMID = Convert.ToString(MQMID.Rows[0]["MsgID"]).Trim();
                                RCID = Convert.ToString(MQMID.Rows[0]["SrNo"]).Trim().ToUpper();
                                objFundTrf.MsgID = strMID;

                                #region Throw Error for doubtful hit
                                throw new Exception("Could not read message");
                                #endregion
                            }
                            else
                            {
                                ResponseCode = 301;
                                Description = "Original Request to ICS Failed.";
                            }

                            #endregion



                        }
                        else
                        {
                            ResponseCode = 301;
                            Description = "Could not connected to ICS System";
                        }



                    }
                    catch (Exception ex)
                    {
                        #region Comment Code
                        IsDoubtfulFail = false;
                        if (ex.Message.ToString().Contains("Could not read message"))
                        {
                            try
                            {

                                clsDoubtfulMessage_Response objclsDoubtfulMessage_Response = new clsDoubtfulMessage_Response();
                                bool IsDoubtFulSuccess = IsDoubtfulSuccess(strMID, ICSLoggedInUser, ReferenceNo, out objclsDoubtfulMessage_Response);

                                if (IsDoubtFulSuccess)
                                {
                                    if (objclsDoubtfulMessage_Response == null)
                                    {
                                        IsSuccess = false;
                                        ResponseCode = 301;
                                        Description = "MQ Response object is null.";

                                    }
                                    else
                                    {
                                        if (objclsDoubtfulMessage_Response.OrgMsgFlg == "Y" && objclsDoubtfulMessage_Response.OrgMsgFin == "Y")
                                        {
                                            //SendTransactionSMS(); 
                                            MaintainDBLog("", objclsDoubtfulMessage_Response.Header, strMID, "Doubtful Success.", "1");
                                            IsSuccess = true;
                                            ResponseCode = 101;
                                            Description = "Sucess";
                                        }

                                        else if (objclsDoubtfulMessage_Response.OrgMsgFlg == "Y" && objclsDoubtfulMessage_Response.OrgMsgFin == "N")
                                        {
                                            MaintainDBLog("", objclsDoubtfulMessage_Response.Header, strMID, "MQ Response found but financial result data is NOT filled.", "1");
                                            IsSuccess = false;
                                            ResponseCode = 301;
                                            IsDoubtfulFail = true;
                                            Description = "MQ Response found but financial result data is NOT filled.";
                                        }
                                        else
                                        {
                                            IsSuccess = false;
                                            ResponseCode = 301;
                                            Description = "MQ Response as Doubtful Msg not found.";
                                        }
                                    }

                                }
                                else
                                {

                                    IsSuccess = false;
                                    ResponseCode = 301;
                                    Description = "MQ Doubtful Msg failed.";
                                    if (objclsDoubtfulMessage_Response != null)
                                    {
                                        if (objclsDoubtfulMessage_Response.OrgMsgFlg == "N" && objclsDoubtfulMessage_Response.OrgMsgFin == "N")
                                        {
                                            IsSuccess = false;
                                            NNN = true;
                                            ResponseCode = 301;
                                            Description = "MQ Response as Doubtful Msg not found.";
                                        }

                                    }

                                }
                                commonLogDetails.LogToDB("SentToICS", "N/A", ex.Message, "Flase", $"strMID:{strMID},ICSLoggedInUser:{ICSLoggedInUser},ReferenceNo:{ReferenceNo},objclsDoubtfulMessage_Response:{objclsDoubtfulMessage_Response}");

                            }
                            catch (Exception exMsg)
                            {
                                IsSuccess = false;
                                ResponseCode = 301;
                                Description = exMsg.Message;
                                
                                commonLogDetails.LogToDB("SentToICS", "N/A", exMsg.Message, "Flase", $"ResponseCode:{ResponseCode},IsSuccess:{IsSuccess}");
                            }

                        }
                        else
                        {

                            IsSuccess = false;
                            ResponseCode = 301;
                            Description = ex.Message;
                        }

                        #endregion
                    }
                    finally
                    {
                        _Query = null;

                        DoubtfulRes = null;
                        objFundTrf = null;
                        objFundTrfRes = null;
                        objSMQ.DisconnectSMQ();
                        objSMQ = null;

                    }
                }
            }
            else
            {
                IsSuccess = false;
                this.ResponseCode = 301;

            }
            return IsSuccess;
        }

        private void SendTransactionSMS()
        {
            #region MQ text sms
            clsSMSText objSmsTxt = new clsSMSText();
            csQueryBuilder _Query;
            csDatabase _MyDB;
            DataTable MyDT;
            string strTxtMsgResp = "";
            CommonLogDetails commonLogDetails = new CommonLogDetails();
            try
            {
                #region GetTxnDetails
                _Query = new csQueryBuilder();
                _Query.TableName = "Sp_MqTxnDetails";
                _Query.QryType = csQueryBuilder.QueryType.Procedure;
                _Query.ViewType = csQueryBuilder.VType.Process;
                _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                _Query.Add("@TransactionNo", SqlDbType.NVarChar, ReferenceNo);
                _Query.Run();
                _MyDB = new csDatabase(csCommon.GetConnectionString);
                MyDT = new DataTable();
                MyDT = _MyDB.Return_DataTable(_Query.MyCmd);

                if (MyDT != null && MyDT.Rows.Count > 0)
                {
                    BeneficiaryNo = MyDT.Rows[0]["BeneficiaryNo"].ToString();
                    PaymentMode = MyDT.Rows[0]["PaymentMode"].ToString();

                    string strFlag = "4";
                    switch (PaymentMode.ToUpper())
                    {
                        case "BANK":
                            strFlag = "4";
                            break;
                        case "CASH":
                            strFlag = "4";
                            break;
                        default:
                            strFlag = "4";
                            break;
                    }

                    _Query = new csQueryBuilder();
                    _Query.TableName = "spMQSmsData";
                    _Query.QryType = csQueryBuilder.QueryType.Procedure;
                    _Query.ViewType = csQueryBuilder.VType.Process;
                    _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                    _Query.Add("@TransactionNo", SqlDbType.NVarChar, ReferenceNo);
                    _Query.Add("@BeneficiaryNo", SqlDbType.NVarChar, Convert.ToString(BeneficiaryNo));
                    _Query.Add("@Flag", SqlDbType.NVarChar, strFlag);
                    _Query.Run();
                    _MyDB = new csDatabase(csCommon.GetConnectionString);
                    MyDT = new DataTable();
                    MyDT = _MyDB.Return_DataTable(_Query.MyCmd);

                    if (MyDT != null && MyDT.Rows.Count > 0)
                    {

                        objSmsTxt.CusNum = MyDT.Rows[0]["CusNum"].ToString();
                        objSmsTxt.MobTel = MyDT.Rows[0]["MobTel"].ToString();
                        objSmsTxt.MsgCls = MyDT.Rows[0]["MsgCls"].ToString();
                        objSmsTxt.SmsDlvDay = MyDT.Rows[0]["SmsDlvDay"].ToString();
                        objSmsTxt.SmsDlvNow = MyDT.Rows[0]["SmsDlvNow"].ToString();
                        objSmsTxt.SmsLng = MyDT.Rows[0]["SmsLng"].ToString();
                        objSmsTxt.SmsTxt = MyDT.Rows[0]["SmsTxt"].ToString();


                        strTxtMsgResp = objSMQ.SendMessage_SendSMS(objSmsTxt);


                        #region Maintian DB Log
                        _Query = new csQueryBuilder();
                        _Query.TableName = "spSaveMQSmsLog";
                        _Query.QryType = csQueryBuilder.QueryType.Procedure;
                        _Query.ViewType = csQueryBuilder.VType.Process;
                        _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                        _Query.Add("@CustNum", SqlDbType.NVarChar, objSmsTxt.CusNum);
                        _Query.Add("@MobTel", SqlDbType.NVarChar, objSmsTxt.MobTel);
                        _Query.Add("@MsgCls", SqlDbType.NVarChar, objSmsTxt.MsgCls);
                        _Query.Add("@SmsDlvDay", SqlDbType.NVarChar, objSmsTxt.SmsDlvDay);
                        _Query.Add("@SmsDlvNow", SqlDbType.NVarChar, objSmsTxt.SmsDlvNow);
                        _Query.Add("@SmsLng", SqlDbType.NVarChar, objSmsTxt.SmsLng);
                        _Query.Add("@SmsTxt", SqlDbType.NVarChar, objSmsTxt.SmsTxt);
                        _Query.Add("@Flag", SqlDbType.NVarChar, "1");
                        _Query.Add("@MethoName", SqlDbType.NVarChar, "Send Transfer Request");

                        _Query.Run();
                        _MyDB = new csDatabase(csCommon.ConnectionString);
                        _MyDB.ExecuteNonQuery(_Query.MyCmd);

                        if (string.IsNullOrEmpty(strTxtMsgResp))
                        {
                            strTxtMsgResp = "Response from MQ is null.";
                        }

                        csQueryBuilder _Query1 = new csQueryBuilder();
                        _Query1.TableName = "spSaveMQSmsLog";
                        _Query1.QryType = csQueryBuilder.QueryType.Procedure;
                        _Query1.ViewType = csQueryBuilder.VType.Process;
                        _Query1.ProcedureType = csQueryBuilder.ProcType.Select;
                        _Query1.Add("@CustNum", SqlDbType.NVarChar, objSmsTxt.CusNum);
                        _Query1.Add("@MobTel", SqlDbType.NVarChar, objSmsTxt.MobTel);
                        _Query1.Add("@MsgCls", SqlDbType.NVarChar, objSmsTxt.MsgCls);
                        _Query1.Add("@SmsDlvDay", SqlDbType.NVarChar, objSmsTxt.SmsDlvDay);
                        _Query1.Add("@SmsDlvNow", SqlDbType.NVarChar, objSmsTxt.SmsDlvNow);
                        _Query1.Add("@SmsLng", SqlDbType.NVarChar, objSmsTxt.SmsLng);
                        _Query1.Add("@SmsTxt", SqlDbType.NVarChar, objSmsTxt.SmsTxt);
                        _Query1.Add("@ResponseLog", SqlDbType.NVarChar, strTxtMsgResp);
                        _Query1.Add("@Flag", SqlDbType.NVarChar, "2");
                        _Query1.Add("@MethoName", SqlDbType.NVarChar, "Send Transfer Response");
                        _Query1.Run();
                        csDatabase _MyDB1 = new csDatabase(csCommon.ConnectionString);
                        _MyDB1.ExecuteNonQuery(_Query1.MyCmd);
                        #endregion

                    }

                }
                #endregion
                commonLogDetails.LogToDB("SendTransactionSMS", "N/A", "Success", "True", $"ReferenceNo:{ReferenceNo}");
            }
            catch (Exception ex)
            {
                ResponseCode = 301;
                Description = "Error while updating Sending SMS Transaction " + ReferenceNo + ":- " + ex.Message;
                commonLogDetails.LogToDB("SendTransactionSMS", "N/A", ex.Message, "Flase", $"ReferenceNo:{ReferenceNo}");
            }
            finally
            {
                objSmsTxt = null;
            }




            #endregion
        }

        private void MaintainDBLog(string ReqInfo, string Header, string MsgID, string FinBrnRsp, string ProcessType)
        {
            #region DB Logs
            CommonLogDetails commonLogDetails = new CommonLogDetails();
            try
            {
                
                csQueryBuilder _Query = new csQueryBuilder();
                //_Query.TableName = "spMQSentTransactionLog";
                _Query.TableName = "sp_Maintain_MQTransactionLog";
                _Query.QryType = csQueryBuilder.QueryType.Procedure;
                _Query.ViewType = csQueryBuilder.VType.Process;
                _Query.Add("@TransactionNo", SqlDbType.NVarChar, ReferenceNo);
                _Query.Add("@MsgID", SqlDbType.NVarChar, MsgID);
                if (ProcessType == "1")
                {
                    _Query.ProcedureType = csQueryBuilder.ProcType.Update;
                    _Query.Add("@Header", SqlDbType.NVarChar, Header);
                    _Query.Add("@FinBrnRsp", SqlDbType.NVarChar, FinBrnRsp);
                    _Query.Add("@SrNo", SqlDbType.NVarChar, RCID);
                    if (!string.IsNullOrEmpty(ReqInfo))
                    {
                        _Query.Add("@ReqInfo", SqlDbType.NVarChar, ReqInfo);
                    }

                    _Query.Run();
                    csDatabase _MyDB = new csDatabase(csCommon.ConnectionString);
                    _MyDB.ExecuteNonQuery(_Query.MyCmd);
                }
                else if (ProcessType == "2")
                {
                    _Query.ProcedureType = csQueryBuilder.ProcType.Insert;
                    _Query.Run();
                    csDatabase _MyDB = new csDatabase(csCommon.ConnectionString);
                    RCID = _MyDB.Return_SingleField(_Query.MyCmd, "SrNo");
                }
                commonLogDetails.LogToDB("MaintainDBLog", "N/A", "Success", "True", $"ReferenceNo:{ReqInfo},Header:{Header},MsgID:{MsgID},FinBrnRsp:{FinBrnRsp},ProcessType:{ProcessType}");
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("MaintainDBLog", "N/A", ex.Message, "Flase", $"ReferenceNo:{ReferenceNo},Header:{Header},MsgID:{MsgID},FinBrnRsp:{FinBrnRsp},ProcessType:{ProcessType}");
                throw ex;
                //ResponseCode = 301;
                //Description = "Error while updating MQ Log Information Transaction " + ReferenceNo + ":- " + ex.Message;
            }
            #endregion
        }

        private void MaintainDoubtFulDBLog(string Status, string Header, string MsgID, string NewID, string DbtResp, string FinBrnRsp, string Description)
        {
            #region DoubtFul Log
            CommonLogDetails commonLogDetails = new CommonLogDetails();
            try
            {
                csQueryBuilder _Query = new csQueryBuilder();
                _Query.TableName = "spMQDoubtFulLog";
                _Query.QryType = csQueryBuilder.QueryType.Procedure;
                _Query.ViewType = csQueryBuilder.VType.Process;
                _Query.ProcedureType = csQueryBuilder.ProcType.Select;
                _Query.Add("@TransactionNo", SqlDbType.NVarChar, ReferenceNo);
                _Query.Add("@Status", SqlDbType.NVarChar, Status);
                _Query.Add("@Header", SqlDbType.NVarChar, Header);
                _Query.Add("@OrgMsgID", SqlDbType.NVarChar, MsgID);
                _Query.Add("@MsgID", SqlDbType.NVarChar, NewID);
                if (!string.IsNullOrEmpty(DbtResp))
                {
                    _Query.Add("@DoubtFulRsp", SqlDbType.NVarChar, DbtResp);
                }
                if (!string.IsNullOrEmpty(FinBrnRsp))
                {
                    _Query.Add("@FinBrnRsp", SqlDbType.NVarChar, FinBrnRsp);
                }
                if (!string.IsNullOrEmpty(Description))
                {
                    _Query.Add("@Description", SqlDbType.NVarChar, Description);
                }
                _Query.Run();
                csDatabase _MyDB = new csDatabase(csCommon.ConnectionString);
                _MyDB.ExecuteNonQuery(_Query.MyCmd);
                commonLogDetails.LogToDB("MaintainDoubtFulDBLog", "N/A", "Success", "Flase", $"ReferenceNo:{ReferenceNo},Header:{Header},MsgID:{MsgID},FinBrnRsp:{FinBrnRsp},Description:{Description}");
            }
            catch (Exception ex)
            {
                ResponseCode = 301;
                Description = "Error while updating MQ DoubtFul Log Information Transaction " + ReferenceNo + ":- " + ex.Message;
                commonLogDetails.LogToDB("MaintainDoubtFulDBLog", "N/A", ex.ToString(), "Flase", $"ReferenceNo:{ReferenceNo},Header:{Header},MsgID:{MsgID},FinBrnRsp:{FinBrnRsp},Description:{Description}");
            }
            #endregion
        }

        private bool IsDoubtfulSuccess(string strMID, string UserID, string ReferenceNo, out clsDoubtfulMessage_Response DoubtfulRes)
        {
            bool IsSuccess = false;

            #region UserCode
            int intdoubtfulcnt = 0;
            clsDoubtfulMessage_Response DoubtfulResLocal = null;
            IList<string> lstMids = new List<string>();
            DoubtfulRes = null;
            System.Threading.Thread.Sleep(30000);
            string filenName = "";// "C:\\RITMAN\\saib_IsDoubtfulSuccess_" + DateTime.Now.ToString("ddMMyyyy") + ".txt";

        Start:
            intdoubtfulcnt += 1;

            try
            {


                if (intdoubtfulcnt <= 1)
                {

                    string NewMID = string.Empty;
                GetMIDDoubtful:
                    NewMID = objSMQ.GetNextMsgID();

                    #region Check MsgID

                    if (lstMids.Any(s => s.Contains(NewMID)))
                    {
                        goto GetMIDDoubtful;
                    }
                    else
                    {
                        lstMids.Add(NewMID);
                        csQueryBuilder objQuery = new csQueryBuilder();
                        objQuery.TableName = "Sp_IsMQ_MsgID_Present";
                        objQuery.QryType = csQueryBuilder.QueryType.Procedure;
                        objQuery.ViewType = csQueryBuilder.VType.Process;
                        objQuery.ProcedureType = csQueryBuilder.ProcType.Select;
                        objQuery.Add("@StrMID", SqlDbType.NVarChar, NewMID);
                        objQuery.Run();
                        csDatabase objMyDB = new csDatabase(csCommon.GetConnectionString);
                        DataTable MQMID = new DataTable();
                        MQMID = objMyDB.Return_DataTable(objQuery.MyCmd);

                        if (MQMID != null)
                        {
                            if (MQMID.Rows[0]["IsMsgIDPresent"].ToString().Trim().ToUpper() == "Y")
                            {
                                goto GetMIDDoubtful;
                            }
                        }
                    }

                    #endregion

                    if (CustType == "4")
                    {
                        DoubtfulResLocal = objSMQ.SendMessage_Doubtful_New("605530", strMID, UserID, NewMID, filenName);
                    }
                    else
                    {
                        DoubtfulResLocal = objSMQ.SendMessage_Doubtful_New("500030", strMID, UserID, NewMID, filenName);
                    }

                    if (DoubtfulResLocal == null)
                    {
                        MaintainDoubtFulDBLog("F", "No Header", strMID, NewMID, "", "", "Object is null.");
                        goto Start;
                    }
                    else
                    {
                        if (DoubtfulResLocal.Header == "No Header")
                        {
                            #region Insert Log for MQ
                            MaintainDoubtFulDBLog("F", DoubtfulResLocal.Header, strMID, NewMID, DoubtfulResLocal.DoubtFulRespTxt, "", DoubtfulResLocal.Description);
                            #endregion
                            goto Start;
                        }
                        else
                        {
                            if (DoubtfulResLocal.OrgMsgFlg == "Y" && DoubtfulResLocal.OrgMsgFin == "Y")
                            {
                                IsSuccess = true;
                                #region Insert Log for MQ
                                MaintainDoubtFulDBLog("Y", DoubtfulResLocal.ReqHeader + "|" + DoubtfulResLocal.MsgReqDat + "|" + DoubtfulResLocal.ReqBody, strMID, NewMID, DoubtfulResLocal.DoubtFulRespTxt, DoubtfulResLocal.OrgFinRsp.OrgRsp, DoubtfulResLocal.Description);
                                #endregion
                            }
                            else if (DoubtfulResLocal.OrgMsgFlg == "Y" && DoubtfulResLocal.OrgMsgFin == "N")
                            {
                                IsSuccess = true;
                                #region Insert Log for MQ
                                MaintainDoubtFulDBLog("F", DoubtfulResLocal.ReqHeader + "|" + DoubtfulResLocal.MsgReqDat + "|" + DoubtfulResLocal.ReqBody, strMID, NewMID, DoubtfulResLocal.DoubtFulRespTxt, DoubtfulResLocal.OrgFinRsp.OrgRsp, DoubtfulResLocal.Description);
                                #endregion
                            }
                            else
                            {
                                #region Insert Log for MQ
                                MaintainDoubtFulDBLog("F", DoubtfulResLocal.ReqHeader + "|" + DoubtfulResLocal.MsgReqDat + "|" + DoubtfulResLocal.ReqBody, strMID, NewMID, DoubtfulResLocal.DoubtFulRespTxt, DoubtfulResLocal.OrgFinRsp.OrgRsp, DoubtfulResLocal.Description);
                                #endregion
                                goto Start;
                            }
                            DoubtfulRes = DoubtfulResLocal;
                        }

                    }

                }
                else
                {
                    IsSuccess = false;
                }
            }
            catch (Exception ex1)
            {
                if (ex1.Message.ToString().Contains("Could not read message"))
                {
                    goto Start;
                }
            }
            #endregion

            return IsSuccess;
        }

        protected void CheckHostSuccess()
        {
            DataSet dataSet = new DataSet();

            using (SqlConnection connection = new SqlConnection(csCommon.GetConnectionString))
            {
                using (SqlCommand command = new SqlCommand("SP_CheckHost_Success", connection))
                {
                    command.CommandType = System.Data.CommandType.StoredProcedure;
                    command.Parameters.AddWithValue("@ProcedureType", 0);
                    command.Parameters.AddWithValue("@ViewType", 1);
                    command.Parameters.AddWithValue("@TransactionNumber", ReferenceNo);


                    using (SqlDataAdapter da = new SqlDataAdapter(command))
                    {
                        da.Fill(dataSet);
                    }

                    if (dataSet != null && dataSet.Tables[0].Rows.Count > 0)
                    {
                        IsHostSuccess = true;
                    }
                    else
                    {
                        IsHostSuccess = false;
                    }
                }
            }

        }

        protected bool CheckCurrentStauts()
        {
            DataSet dataSet = new DataSet();
            bool CanCancel = false;

            try
            {

                using (SqlConnection connection = new SqlConnection(csCommon.GetConnectionString))
                {
                    using (SqlCommand command = new SqlCommand("sp_VerifyCancelStatus", connection))
                    {
                        command.CommandType = System.Data.CommandType.StoredProcedure;
                        command.Parameters.AddWithValue("@ProcedureType", 0);
                        command.Parameters.AddWithValue("@ViewType", 1);
                        command.Parameters.AddWithValue("@TransactionNumber", ReferenceNo);


                        using (SqlDataAdapter da = new SqlDataAdapter(command))
                        {
                            da.Fill(dataSet);
                        }

                        if (dataSet != null && dataSet.Tables[0].Rows.Count > 0)
                        {
                            CanCancel = true;
                        }
                        else
                        {
                            CanCancel = false;
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                this.Description = ex.Message;
            }

            return CanCancel;
        }

        public void UpdateTransaction(string TrxnNo, string LogId, string Remarks, string IsApproved, string Status)
        {
            csMG _csMG = new csMG();
            Boolean isMgTrxn = false;
            DAL dal = new DAL();
            try
            {
                isMgTrxn = dal.GetComplianceManagementTxnPrefix(TrxnNo);

                if (isMgTrxn == true)
                {
                    csQueryBuilder _Query = new csQueryBuilder();
                    _Query.TableName = "sp_MG_Cancellation_MakerChecker";
                    _Query.QryType = csQueryBuilder.QueryType.Procedure;
                    _Query.ProcedureType = csQueryBuilder.ProcType.Update;
                    _Query.ViewType = csQueryBuilder.VType.Process;
                    _Query.Add("@TransactionNumber", SqlDbType.NVarChar, TrxnNo);
                    _Query.Add("@LogID", SqlDbType.Int, LogId);
                    _Query.Add("@Remark", SqlDbType.NVarChar, Remarks);
                    _Query.Add("@IsApproved", SqlDbType.Int, IsApproved);
                    _Query.Add("@TrStatusID", SqlDbType.Int, Status);
                    _Query.Add("@UserID", SqlDbType.NVarChar, CancelUser);
                    _Query.Run();
                    csDatabase MyDb = new csDatabase(csCommon.ConnectionString);
                    MyDb.ExecuteNonQuery(_Query.MyCmd);
                }
                else
                {
                    csQueryBuilder _Query = new csQueryBuilder();
                    _Query.TableName = "spCancellation_MakerChecker";
                    _Query.QryType = csQueryBuilder.QueryType.Procedure;
                    _Query.ProcedureType = csQueryBuilder.ProcType.Update;
                    _Query.ViewType = csQueryBuilder.VType.Process;
                    _Query.Add("@TransactionNumber", SqlDbType.NVarChar, TrxnNo);
                    _Query.Add("@LogID", SqlDbType.Int, LogId);
                    _Query.Add("@Remark", SqlDbType.NVarChar, Remarks);
                    _Query.Add("@IsApproved", SqlDbType.Int, IsApproved);
                    _Query.Add("@TrStatusID", SqlDbType.Int, Status);
                    _Query.Add("@UserID", SqlDbType.NVarChar, CancelUser);
                    _Query.Run();
                    csDatabase MyDb = new csDatabase(csCommon.ConnectionString);
                    MyDb.ExecuteNonQuery(_Query.MyCmd);
                }
            }
            catch (Exception ex)
            {

            }
        }

    }

}