﻿using BusinessManager;
using MainRemit;
using MoneyGramService.com.moneygram.extws;
using Newtonsoft.Json;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Response;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace SAIB_Web_Api.BusinessManager
{
    public class ComplianceManagementManager
    {
        DAL dal = new DAL();
        CommonLogDetails commonLogDetails = new CommonLogDetails();

        public List<ComplianceManagementViewResponse> GetComplianceManagementView(int UserID, int TransactionID, string TransactionNumber)
        {
            try
            {
                DataTable dt = dal.GetComplianceManagementView(UserID, TransactionID, TransactionNumber);
                List<ComplianceManagementViewResponse> lstcomplianceManagementView = new List<ComplianceManagementViewResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    ComplianceManagementViewResponse _complianceManagementViewResponse = new ComplianceManagementViewResponse();

                    _complianceManagementViewResponse.Pref = Convert.ToString(row["Pref"]);
                    _complianceManagementViewResponse.TransactionNumber = Convert.ToString(row["Transaction Number"]);
                    _complianceManagementViewResponse.Status = Convert.ToString(row["Status"]);
                    _complianceManagementViewResponse.Date = Convert.ToString(row["Date"]);
                    _complianceManagementViewResponse.RemitterName = Convert.ToString(row["Remitter Name"]);
                    _complianceManagementViewResponse.BeneficiaryName = Convert.ToString(row["Beneficiary Name"]);
                    _complianceManagementViewResponse.Remark = Convert.ToString(row["Remark"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentFC_Amount"])))
                    {
                        _complianceManagementViewResponse.AgentFC_Amount = Convert.ToDecimal(row["AgentFC_Amount"]);
                    }
                    else
                    {
                        _complianceManagementViewResponse.AgentFC_Amount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentLC_Amount"])))
                    {
                        _complianceManagementViewResponse.AgentLC_Amount = Convert.ToDecimal(row["AgentLC_Amount"]);
                    }
                    _complianceManagementViewResponse.hid = Convert.ToString(row["hid"]);
                    _complianceManagementViewResponse.hViewLink = Convert.ToString(row["hViewLink"]);
                    _complianceManagementViewResponse.Loglink = Convert.ToString(row["Loglink"]);
                    _complianceManagementViewResponse.ComplianceReason = Convert.ToString(row["PurposeOfTransfer"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SpecifyPOT"])))
                    {
                        _complianceManagementViewResponse.SpecifyPOT = Convert.ToInt32(row["SpecifyPOT"]);
                    }
                    else
                    {
                        _complianceManagementViewResponse.SpecifyPOT = null;
                    }
                    _complianceManagementViewResponse.Hlink = Convert.ToString(row["Hlink"]);
                    _complianceManagementViewResponse.OFACIds = Convert.ToString(row["OFACIds"]);
                    _complianceManagementViewResponse.CommentsView = Convert.ToString(row["CommentsView"]);
                    _complianceManagementViewResponse.CommentsAdd = Convert.ToString(row["CommentsAdd"]);
                    _complianceManagementViewResponse.CustomerNati = Convert.ToString(row["CustomerNati"]);
                    _complianceManagementViewResponse.BeneficiaryNati = Convert.ToString(row["BeneficiaryNati"]);
                    _complianceManagementViewResponse.AgentName = Convert.ToString(row["AgentName"]);
                    _complianceManagementViewResponse.PaymentMode = Convert.ToString(row["PaymentMode"]);
                    lstcomplianceManagementView.Add(_complianceManagementViewResponse);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceManagementView);
                commonLogDetails.LogToDB("GetComplianceManagementView",Convert.ToString(UserID).ToString(), "Success", result, $"UserID: {UserID}, TransactionID: {TransactionID}, TransactionNumber: {TransactionNumber}");

                return lstcomplianceManagementView;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementView", Convert.ToString(UserID).ToString(), ex.ToString(), "False", $"UserID: {UserID}, TransactionID: {TransactionID}, TransactionNumber: {TransactionNumber}");
                throw ex;
            }

        }

        public List<ComplianceManagementViewResponse> GetComplianceManagementViewBy_TransactionNumber(int UserID, string TransactionNumber)
        {
            try
            {
                DataTable dt = dal.GetComplianceManagementViewBy_TransactionNumber(UserID, TransactionNumber);
                //string str = JsonConvert.SerializeObject(dt);
                List<ComplianceManagementViewResponse> lstcomplianceManagementView = new List<ComplianceManagementViewResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    ComplianceManagementViewResponse _complianceManagementViewResponse = new ComplianceManagementViewResponse();

                    _complianceManagementViewResponse.Pref = Convert.ToString(row["Pref"]);
                    _complianceManagementViewResponse.TransactionNumber = Convert.ToString(row["Transaction Number"]);
                    _complianceManagementViewResponse.Status = Convert.ToString(row["Status"]);
                    _complianceManagementViewResponse.Date = Convert.ToString(row["Date"]);
                    _complianceManagementViewResponse.RemitterName = Convert.ToString(row["Remitter Name"]);
                    _complianceManagementViewResponse.BeneficiaryName = Convert.ToString(row["Beneficiary Name"]);
                    _complianceManagementViewResponse.Remark = Convert.ToString(row["Remark"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentFC_Amount"])))
                    {
                        _complianceManagementViewResponse.AgentFC_Amount = Convert.ToDecimal(row["AgentFC_Amount"]);
                    }
                    else
                    {
                        _complianceManagementViewResponse.AgentFC_Amount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentLC_Amount"])))
                    {
                        _complianceManagementViewResponse.AgentLC_Amount = Convert.ToDecimal(row["AgentLC_Amount"]);
                    }
                    _complianceManagementViewResponse.hid = Convert.ToString(row["hid"]);
                    _complianceManagementViewResponse.hViewLink = Convert.ToString(row["hViewLink"]);
                    _complianceManagementViewResponse.Loglink = Convert.ToString(row["Loglink"]);
                    _complianceManagementViewResponse.ComplianceReason = Convert.ToString(row["PurposeOfTransfer"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SpecifyPOT"])))
                    {
                        _complianceManagementViewResponse.SpecifyPOT = Convert.ToInt32(row["SpecifyPOT"]);
                    }
                    else
                    {
                        _complianceManagementViewResponse.SpecifyPOT = null;
                    }
                    _complianceManagementViewResponse.Hlink = Convert.ToString(row["Hlink"]);
                    _complianceManagementViewResponse.OFACIds = Convert.ToString(row["OFACIds"]);
                    _complianceManagementViewResponse.CommentsView = Convert.ToString(row["CommentsView"]);
                    _complianceManagementViewResponse.CommentsAdd = Convert.ToString(row["CommentsAdd"]);
                    _complianceManagementViewResponse.CustomerNati = Convert.ToString(row["CustomerNati"]);
                    _complianceManagementViewResponse.BeneficiaryNati = Convert.ToString(row["BeneficiaryNati"]);
                    _complianceManagementViewResponse.AgentName = Convert.ToString(row["AgentName"]);
                    _complianceManagementViewResponse.PaymentMode = Convert.ToString(row["PaymentMode"]);
                    lstcomplianceManagementView.Add(_complianceManagementViewResponse);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceManagementView);
                commonLogDetails.LogToDB("GetComplianceManagementViewBy_TransactionNumber", Convert.ToString(UserID).ToString(), "Success", result, $"UserID: {UserID}, TransactionNumber: {TransactionNumber}");

                return lstcomplianceManagementView;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementViewBy_TransactionNumber", Convert.ToString(UserID).ToString(), ex.ToString(), "False", $"UserID: {UserID}, TransactionNumber: {TransactionNumber}");
                throw ex;
            }

        }

        public List<ComplianceManagementViewResponse> GetComplianceManagementViewBy_TransactionID(int UserID, int TransactionID)
        {
            try
            {
                DataTable dt = dal.GetComplianceManagementViewBy_TransactionID(UserID, TransactionID);
                //string str = JsonConvert.SerializeObject(dt);
                List<ComplianceManagementViewResponse> lstcomplianceManagementView = new List<ComplianceManagementViewResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    ComplianceManagementViewResponse _complianceManagementViewResponse = new ComplianceManagementViewResponse();

                    _complianceManagementViewResponse.Pref = Convert.ToString(row["Pref"]);
                    _complianceManagementViewResponse.TransactionNumber = Convert.ToString(row["Transaction Number"]);
                    _complianceManagementViewResponse.Status = Convert.ToString(row["Status"]);
                    _complianceManagementViewResponse.Date = Convert.ToString(row["Date"]);
                    _complianceManagementViewResponse.RemitterName = Convert.ToString(row["Remitter Name"]);
                    _complianceManagementViewResponse.BeneficiaryName = Convert.ToString(row["Beneficiary Name"]);
                    _complianceManagementViewResponse.Remark = Convert.ToString(row["Remark"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentFC_Amount"])))
                    {
                        _complianceManagementViewResponse.AgentFC_Amount = Convert.ToDecimal(row["AgentFC_Amount"]);
                    }
                    else
                    {
                        _complianceManagementViewResponse.AgentFC_Amount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentLC_Amount"])))
                    {
                        _complianceManagementViewResponse.AgentLC_Amount = Convert.ToDecimal(row["AgentLC_Amount"]);
                    }
                    else
                    {
                        _complianceManagementViewResponse.AgentLC_Amount = null;
                    }
                    _complianceManagementViewResponse.hid = Convert.ToString(row["hid"]);
                    _complianceManagementViewResponse.hViewLink = Convert.ToString(row["hViewLink"]);
                    _complianceManagementViewResponse.Loglink = Convert.ToString(row["Loglink"]);
                    _complianceManagementViewResponse.ComplianceReason = Convert.ToString(row["PurposeOfTransfer"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SpecifyPOT"])))
                    {
                        _complianceManagementViewResponse.SpecifyPOT = Convert.ToInt32(row["SpecifyPOT"]);
                    }
                    else
                    {
                        _complianceManagementViewResponse.SpecifyPOT = null;
                    }
                    _complianceManagementViewResponse.Hlink = Convert.ToString(row["Hlink"]);
                    _complianceManagementViewResponse.OFACIds = Convert.ToString(row["OFACIds"]);
                    _complianceManagementViewResponse.CommentsView = Convert.ToString(row["CommentsView"]);
                    _complianceManagementViewResponse.CommentsAdd = Convert.ToString(row["CommentsAdd"]);
                    _complianceManagementViewResponse.CustomerNati = Convert.ToString(row["CustomerNati"]);
                    _complianceManagementViewResponse.BeneficiaryNati = Convert.ToString(row["BeneficiaryNati"]);
                    _complianceManagementViewResponse.AgentName = Convert.ToString(row["AgentName"]);
                    _complianceManagementViewResponse.PaymentMode = Convert.ToString(row["PaymentMode"]);
                    lstcomplianceManagementView.Add(_complianceManagementViewResponse);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceManagementView);
                commonLogDetails.LogToDB("GetComplianceManagementViewBy_TransactionID", Convert.ToString(UserID).ToString(), "Success", result, $"UserID: {UserID}, TransactionID: {TransactionID}");

                return lstcomplianceManagementView;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementViewBy_TransactionID", Convert.ToString(UserID).ToString(), ex.ToString(), "False", $"UserID: {UserID}, TransactionID: {TransactionID}");
                throw ex;
            }

        }

        public List<ViewComplianceResponse> GetComplianceManagementView_ViewCompliance(string TransactionNumber)
        {
            try
            {
                DataTable dt = dal.GetComplianceManagementView_ViewCompliance(TransactionNumber);
                List<ViewComplianceResponse> lstviewComplianceResponse = new List<ViewComplianceResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    ViewComplianceResponse _complianceManagementViewResponse = new ViewComplianceResponse();
                    _complianceManagementViewResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                    _complianceManagementViewResponse.Remarks = Convert.ToString(row["Remarks"]);
                    lstviewComplianceResponse.Add(_complianceManagementViewResponse);
                }
                string result = JsonConvert.SerializeObject(lstviewComplianceResponse);
                commonLogDetails.LogToDB("GetComplianceManagementView_ViewCompliance", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber}");

                return lstviewComplianceResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementView_ViewCompliance", "N/A", ex.ToString(), "False", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }

        }

        public List<ComplianceViewTransactionLog> GetComplianceManagementView_TransactionLog(string TransactionNumber)
        {

            try
            {
                DataTable dt = dal.GetComplianceManagementView_TransactionLog(TransactionNumber);
                string str = JsonConvert.SerializeObject(dt);
                List<ComplianceViewTransactionLog> lstcomplianceViewTransactionLogResponse = new List<ComplianceViewTransactionLog>();

                foreach (DataRow row in dt.Rows)
                {
                    ComplianceViewTransactionLog _complianceViewTransactionLogResponse = new ComplianceViewTransactionLog();
                    if (!string.IsNullOrEmpty(Convert.ToString(row["LogID"])))
                    {
                        _complianceViewTransactionLogResponse.LogID = Convert.ToInt32(row["LogID"]);
                    }
                    else
                    {
                        _complianceViewTransactionLogResponse.LogID = null;
                    }
                    _complianceViewTransactionLogResponse.SRTRNo = Convert.ToString(row["SRTRNo"]);
                    _complianceViewTransactionLogResponse.ActionName = Convert.ToString(row["ActionName"]);
                    _complianceViewTransactionLogResponse.SentDate = Convert.ToString(row["SentDate"]);
                    _complianceViewTransactionLogResponse.PrevValue = Convert.ToString(row["PrevValue"]);
                    _complianceViewTransactionLogResponse.UpdatedValue = Convert.ToString(row["UpdatedValue"]);
                    _complianceViewTransactionLogResponse.Remarks = Convert.ToString(row["Remarks"]);
                    _complianceViewTransactionLogResponse.ActionDate = Convert.ToString(row["ActionDate"]);
                    _complianceViewTransactionLogResponse.ActionTime = Convert.ToString(row["ActionTime"]);
                    _complianceViewTransactionLogResponse.ActionBy = Convert.ToString(row["ActionBy"]);
                    lstcomplianceViewTransactionLogResponse.Add(_complianceViewTransactionLogResponse);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceViewTransactionLogResponse);
                commonLogDetails.LogToDB("GetComplianceManagementView_TransactionLog", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber}");

                return lstcomplianceViewTransactionLogResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementView_TransactionLog", "N/A", ex.ToString(), "Flase", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }
        }

        public List<ComplianceManagementView_View> GetComplianceManagementView_RequiredDetail(string TransactionNumber)
        {

            try
            {
                DataTable dt = dal.GetComplianceManagementView_RequiredDetail(TransactionNumber);
                List<ComplianceManagementView_View> lstcomplianceView_ViewResponse = new List<ComplianceManagementView_View>();

                foreach (DataRow row in dt.Rows)
                {
                    ComplianceManagementView_View _complianceView_ViewResponse = new ComplianceManagementView_View();
                    _complianceView_ViewResponse.RemIDName = Convert.ToString(row["RemIDName"]);
                    _complianceView_ViewResponse.RemNatIDName = Convert.ToString(row["RemNatIDName"]);
                    _complianceView_ViewResponse.BenNatIDName = Convert.ToString(row["BenNatIDName"]);
                    _complianceView_ViewResponse.BenCustName = Convert.ToString(row["BenCustName"]);
                    _complianceView_ViewResponse.OrgMsgID = Convert.ToString(row["OrgMsgID"]);
                    _complianceView_ViewResponse.PreviousRemark = Convert.ToString(row["PreviousRemark"]);
                    _complianceView_ViewResponse.ISCustInCompliance = Convert.ToString(row["ISCustInCompliance"]);
                    _complianceView_ViewResponse.IsBenInCompliance = Convert.ToString(row["IsBenInCompliance"]);
                    _complianceView_ViewResponse.ISCustApprove = Convert.ToString(row["ISCustApprove"]);
                    _complianceView_ViewResponse.IsBenApprove = Convert.ToString(row["IsBenApprove"]);
                    _complianceView_ViewResponse.CustNumber = Convert.ToString(row["CustNumber"]);
                    _complianceView_ViewResponse.BenNo = Convert.ToString(row["BenNo"]);
                    _complianceView_ViewResponse.CustRemark = Convert.ToString(row["CustRemark"]);
                    _complianceView_ViewResponse.BenRemark = Convert.ToString(row["BenRemark"]);
                    _complianceView_ViewResponse.IsMGTxn = Convert.ToString(row["IsMGTxn"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["TxnTime"])))
                    {
                        _complianceView_ViewResponse.TxnTime = Convert.ToDateTime(row["TxnTime"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.TxnTime = null;
                    }

                    if (!string.IsNullOrEmpty(Convert.ToString(row["MGWaitMin"])))
                    {
                        _complianceView_ViewResponse.MGWaitMin = Convert.ToInt32(row["MGWaitMin"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.MGWaitMin = null;
                    }

                    _complianceView_ViewResponse.TRPayMode = Convert.ToString(row["TRPayMode"]);
                    _complianceView_ViewResponse.IsMTOSuccess = Convert.ToString(row["IsMTOSuccess"]);
                    _complianceView_ViewResponse.PartnerCode = Convert.ToString(row["PartnerCode"]);
                    _complianceView_ViewResponse.CustType = Convert.ToString(row["CustType"]);
                    lstcomplianceView_ViewResponse.Add(_complianceView_ViewResponse);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceView_ViewResponse);
                commonLogDetails.LogToDB("GetComplianceManagementView_RequiredDetail", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber}");

                return lstcomplianceView_ViewResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementView_RequiredDetail", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }
        }

        public List<ComplianceManagementView_BindData> GetComplianceManagementView_BindData(string TransactionNumber)
        {
            try
            {
                List<ComplianceManagementView_BindData> lstcomplianceView_ViewResponse = new List<ComplianceManagementView_BindData>();
                DataTable dt = dal.GetComplianceManagementView_BindData(TransactionNumber);
                int AgentID = 0;
                int PayInCountry = 0;
                int PayInCurrency = 0;
                decimal PayInAmount = 0;
                int PayOutCountry = 0;
                int PayOutCurrency = 0;
                decimal PayOutAmount = 0;
                int RecommendedAgent_ID = 0;
                foreach (DataRow row in dt.Rows)
                {
                    ComplianceManagementView_BindData _complianceView_ViewResponse = new ComplianceManagementView_BindData();
                    _complianceView_ViewResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                    _complianceView_ViewResponse.MemberShipID = Convert.ToString(row["MemberShipID"]);
                    _complianceView_ViewResponse.Customer_Name_F = Convert.ToString(row["Customer_Name_F"]);
                    _complianceView_ViewResponse.Customer_Name_M = Convert.ToString(row["Customer_Name_M"]);
                    _complianceView_ViewResponse.Customer_Name_L = Convert.ToString(row["Customer_Name_L"]);
                    _complianceView_ViewResponse.Customer_Address = Convert.ToString(row["Customer_Address"]);
                    _complianceView_ViewResponse.Customer_Mobile = Convert.ToString(row["Customer_Mobile"]);
                    _complianceView_ViewResponse.Customer_Phone = Convert.ToString(row["Customer_Phone"]);
                    _complianceView_ViewResponse.Customer_NationalityID = Convert.ToString(row["Customer_NationalityID"]);
                    _complianceView_ViewResponse.Customer_Relation = Convert.ToString(row["Customer_Relation"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Customer_DOB"])))
                    {
                        _complianceView_ViewResponse.Customer_DOB = Convert.ToDateTime(row["Customer_DOB"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Customer_DOB = null;
                    }
                    _complianceView_ViewResponse.Customer_PlaceofBirth = Convert.ToString(row["Customer_PlaceofBirth"]);
                    _complianceView_ViewResponse.Beneficiary_Name_F = Convert.ToString(row["Beneficiary_Name_F"]);
                    _complianceView_ViewResponse.Beneficiary_Name_M = Convert.ToString(row["Beneficiary_Name_M"]);
                    _complianceView_ViewResponse.Beneficiary_Name_L = Convert.ToString(row["Beneficiary_Name_L"]);
                    _complianceView_ViewResponse.Beneficiary_Address = Convert.ToString(row["Beneficiary_Address"]);
                    _complianceView_ViewResponse.Beneficiary_LandMark = Convert.ToString(row["Beneficiary_LandMark"]);
                    _complianceView_ViewResponse.Beneficiary_ZipCode = Convert.ToString(row["Beneficiary_ZipCode"]);
                    _complianceView_ViewResponse.Beneficiary_Mobile = Convert.ToString(row["Beneficiary_Mobile"]);
                    _complianceView_ViewResponse.Beneficiary_Phone = Convert.ToString(row["Beneficiary_Phone"]);
                    _complianceView_ViewResponse.Beneficiary_NationalityID = Convert.ToString(row["Beneficiary_NationalityID"]);
                    _complianceView_ViewResponse.Beneficiary_MessageToBen = Convert.ToString(row["Beneficiary_MessageToBen"]);
                    _complianceView_ViewResponse.Beneficiary_MessageToAgent = Convert.ToString(row["Beneficiary_MessageToAgent"]);
                    _complianceView_ViewResponse.ModeOfPayment_ID = Convert.ToString(row["ModeOfPayment_ID"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayInCountry"])))
                    {
                        _complianceView_ViewResponse.PayInCountry = Convert.ToInt32(row["PayInCountry"]);
                        PayInCountry = Convert.ToInt32(row["PayInCountry"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayInCountry = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayInCurrency"])))
                    {
                        _complianceView_ViewResponse.PayInCurrency = Convert.ToInt32(row["PayInCurrency"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayInCurrency = null;
                    }
                    _complianceView_ViewResponse.SCCY = Convert.ToString(row["SCCY"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SendAgent"])))
                    {
                        _complianceView_ViewResponse.SendAgent = Convert.ToInt32(row["SendAgent"]);
                        AgentID = Convert.ToInt32(row["SendAgent"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SendAgent = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCountry"])))
                    {
                        _complianceView_ViewResponse.PayOutCountry = Convert.ToInt32(row["PayOutCountry"]);
                        PayOutCountry = Convert.ToInt32(row["PayOutCountry"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutCountry = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCurrency"])))
                    {
                        _complianceView_ViewResponse.PayOutCurrency = Convert.ToInt32(row["PayOutCurrency"]);
                        PayOutCurrency = Convert.ToInt32(row["PayOutCurrency"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutCurrency = null;
                    }
                    _complianceView_ViewResponse.DCCY = Convert.ToString(row["DCCY"]);
                    _complianceView_ViewResponse.DCountry = Convert.ToString(row["DCountry"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RecommendedAgent_ID"])))
                    {
                        _complianceView_ViewResponse.RecommendedAgent_ID = Convert.ToInt32(row["RecommendedAgent_ID"]);
                        RecommendedAgent_ID = Convert.ToInt32(row["RecommendedAgent_ID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RecommendedAgent_ID = null;
                    }
                    _complianceView_ViewResponse.TrTypeID = Convert.ToString(row["TrTypeID"]);
                    _complianceView_ViewResponse.DMode = Convert.ToString(row["DMode"]);
                    _complianceView_ViewResponse.DCity = Convert.ToString(row["DCity"]);
                    _complianceView_ViewResponse.DLocation = Convert.ToString(row["DLocation"]);
                    _complianceView_ViewResponse.DAgent = Convert.ToString(row["DAgent"]);
                    _complianceView_ViewResponse.AgentAdd = Convert.ToString(row["AgentAdd"]);
                    _complianceView_ViewResponse.DPurpose = Convert.ToString(row["DPurpose"]);
                    _complianceView_ViewResponse.PurposeSpecify = Convert.ToString(row["PurposeSpecify"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentRate"])))
                    {
                        _complianceView_ViewResponse.AgentRate = Convert.ToDecimal(row["AgentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentLC_Amount"])))
                    {
                        _complianceView_ViewResponse.AgentLC_Amount = Convert.ToDecimal(row["AgentLC_Amount"]);
                        PayInAmount = Convert.ToDecimal(row["AgentLC_Amount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgentLC_Amount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentFC_Amount"])))
                    {
                        _complianceView_ViewResponse.AgentFC_Amount = Convert.ToDecimal(row["AgentFC_Amount"]);
                        PayOutAmount = Convert.ToDecimal(row["AgentFC_Amount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgentFC_Amount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["BaseToBaseCommissionAmount"])))
                    {
                        _complianceView_ViewResponse.BaseToBaseCommissionAmount = Convert.ToDecimal(row["BaseToBaseCommissionAmount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.BaseToBaseCommissionAmount = null;
                    }
                    _complianceView_ViewResponse.IDNumber = Convert.ToString(row["IDNumber"]);
                    _complianceView_ViewResponse.IDExpDt = Convert.ToString(row["IDExpDt"]);

                    bool _output = false;
                    Agent.AgentSettlementCurrency _get = new Agent.AgentSettlementCurrency(AgentID.ToString(), csCommon.ConnectionString);
                    int _SettlementCurrency = _get.GetSettlementCurrency();

                    Country.Validation _validate =
                        new Country.Validation(Permission.Send, PayInCountry, PayInCurrency, _SettlementCurrency, PayInAmount, csCommon.ConnectionString);
                    _output = _validate.IsIDRequired();
                    _complianceView_ViewResponse.IsIDRequiredForSendingCountry = _output;

                    bool _outputReceivingCountry = false;
                    Agent.AgentSettlementCurrency _get1 = new Agent.AgentSettlementCurrency(RecommendedAgent_ID.ToString(), csCommon.ConnectionString);
                    _SettlementCurrency = _get1.GetSettlementCurrency();

                    Country.Validation _validate1 =
                        new Country.Validation(Permission.Send, PayOutCountry, PayOutCurrency, _SettlementCurrency, PayOutAmount, csCommon.ConnectionString);
                    _outputReceivingCountry = _validate.IsIDRequired();

                    _complianceView_ViewResponse.IsIDRequiredForReceivingCountry = _outputReceivingCountry;

                    if (!string.IsNullOrEmpty(Convert.ToString(row["TrDate"])))
                    {
                        _complianceView_ViewResponse.TrDate = Convert.ToDateTime(row["TrDate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.TrDate = null;
                    }

                    _complianceView_ViewResponse.ManualSuspected = Convert.ToString(row["ManualSuspected"]);
                    _complianceView_ViewResponse.IsArebic = Convert.ToString(row["IsArebic"]);
                    _complianceView_ViewResponse.CourierAddress = Convert.ToString(row["CourierAddress"]);
                    _complianceView_ViewResponse.CourierRemark = Convert.ToString(row["CourierRemark"]);
                    _complianceView_ViewResponse.BankBranch = Convert.ToString(row["BankBranch"]);
                    _complianceView_ViewResponse.BankAddress = Convert.ToString(row["BankAddress"]);
                    _complianceView_ViewResponse.BankName = Convert.ToString(row["BankName"]);
                    _complianceView_ViewResponse.BankAccountNo = Convert.ToString(row["BankName"]);
                    _complianceView_ViewResponse.BankCode = Convert.ToString(row["BankCode"]);
                    _complianceView_ViewResponse.PreviousRemark = Convert.ToString(row["PreviousRemark"]);
                    lstcomplianceView_ViewResponse.Add(_complianceView_ViewResponse);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceView_ViewResponse);
                commonLogDetails.LogToDB("GetComplianceManagementView_BindData", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber}");

                return lstcomplianceView_ViewResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementView_BindData", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }
        }
        
        public List<ComplianceManagementView_BindResponse> GetComplianceManagementView_BindWithoutSBI(string TransactionNumber)
        {
            try
            {
                List<ComplianceManagementView_BindResponse> lstcomplianceView_ViewResponse = new List<ComplianceManagementView_BindResponse>();
                DataTable dt = dal.GetComplianceManagementView_BindWithoutSBI(TransactionNumber);
                int AgentID = 0;
                int PayInCountry = 0;
                int PayInCurrency = 0;
                decimal PayInAmount = 0;
                int PayOutCountry = 0;
                int PayOutCurrency = 0;
                decimal PayOutAmount = 0;
                int RecommendedAgent_ID = 0;
                foreach (DataRow row in dt.Rows)
                {
                    ComplianceManagementView_BindResponse _complianceView_ViewResponse = new ComplianceManagementView_BindResponse();
                    _complianceView_ViewResponse.Customer_Name_M = Convert.ToString(row["Customer_Name_M"]);
                    _complianceView_ViewResponse.Customer_NationalityID = Convert.ToString(row["Customer_NationalityID"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Customer_DOB"])))
                    {
                        _complianceView_ViewResponse.Customer_DOB = Convert.ToDateTime(row["Customer_DOB"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Customer_DOB = null;
                    }

                    _complianceView_ViewResponse.Customer_Address = Convert.ToString(row["Customer_Address"]);
                    _complianceView_ViewResponse.Beneficiary_Name_M = Convert.ToString(row["Beneficiary_Name_M"]);
                    _complianceView_ViewResponse.Beneficiary_NationalityID = Convert.ToString(row["Beneficiary_NationalityID"]);
                    _complianceView_ViewResponse.Beneficiary_Address = Convert.ToString(row["Beneficiary_Address"]);
                    _complianceView_ViewResponse.Customer_Relation = Convert.ToString(row["Customer_Relation"]);
                    _complianceView_ViewResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                    _complianceView_ViewResponse.MemberShipID = Convert.ToString(row["MemberShipID"]);
                    _complianceView_ViewResponse.Customer_Name_F = Convert.ToString(row["Customer_Name_F"]);
                    _complianceView_ViewResponse.Customer_Name_M1 = Convert.ToString(row["Customer_Name_M1"]);
                    _complianceView_ViewResponse.Customer_Name_L = Convert.ToString(row["Customer_Name_L"]);
                    _complianceView_ViewResponse.Customer_Address1 = Convert.ToString(row["Customer_Address1"]);
                    _complianceView_ViewResponse.Customer_Mobile = Convert.ToString(row["Customer_Mobile"]);
                    _complianceView_ViewResponse.Customer_Phone = Convert.ToString(row["Customer_Phone"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Customer_NationalityID1"])))
                    {
                        _complianceView_ViewResponse.Customer_NationalityID1 = Convert.ToInt32(row["Customer_NationalityID1"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Customer_NationalityID1 = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Customer_DOB1"])))
                    {
                        _complianceView_ViewResponse.Customer_DOB1 = Convert.ToDateTime(row["Customer_DOB1"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Customer_DOB1 = null;
                    }

                    _complianceView_ViewResponse.Customer_Relation1 = Convert.ToString(row["Customer_Relation1"]);
                    _complianceView_ViewResponse.Customer_Gender = Convert.ToString(row["Customer_Gender"]);
                    _complianceView_ViewResponse.Customer_Email = Convert.ToString(row["Customer_Email"]);
                    _complianceView_ViewResponse.Customer_MaritalStatus = Convert.ToString(row["Customer_MaritalStatus"]);
                    _complianceView_ViewResponse.Customer_WorkAddress = Convert.ToString(row["Customer_WorkAddress"]);
                    _complianceView_ViewResponse.Customer_PlaceofBirth = Convert.ToString(row["Customer_PlaceofBirth"]);
                    _complianceView_ViewResponse.Beneficiary_Name_F = Convert.ToString(row["Beneficiary_Name_F"]);
                    _complianceView_ViewResponse.Beneficiary_Name_M1 = Convert.ToString(row["Beneficiary_Name_M1"]);
                    _complianceView_ViewResponse.Beneficiary_Name_L = Convert.ToString(row["Beneficiary_Name_L"]);
                    _complianceView_ViewResponse.Beneficiary_Address1 = Convert.ToString(row["Beneficiary_Address1"]);
                    _complianceView_ViewResponse.Beneficiary_Mobile = Convert.ToString(row["Beneficiary_Mobile"]);
                    _complianceView_ViewResponse.Beneficiary_Phone = Convert.ToString(row["Beneficiary_Phone"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Beneficiary_NationalityID1"])))
                    {
                        _complianceView_ViewResponse.Beneficiary_NationalityID1 = Convert.ToInt32(row["Beneficiary_NationalityID1"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Beneficiary_NationalityID1 = null;
                    }
                    _complianceView_ViewResponse.Beneficiary_MessageToBen = Convert.ToString(row["Beneficiary_MessageToBen"]);
                    _complianceView_ViewResponse.Beneficiary_MessageToAgent = Convert.ToString(row["Beneficiary_MessageToAgent"]);
                    _complianceView_ViewResponse.Beneficiary_LandMark = Convert.ToString(row["Beneficiary_LandMark"]);
                    _complianceView_ViewResponse.Beneficiary_Gender = Convert.ToString(row["Beneficiary_Gender"]);
                    _complianceView_ViewResponse.Beneficiary_Email = Convert.ToString(row["Beneficiary_Email"]);
                    _complianceView_ViewResponse.Beneficiary_MaritalStatus = Convert.ToString(row["Beneficiary_MaritalStatus"]);
                    _complianceView_ViewResponse.Beneficiary_WorkAddress = Convert.ToString(row["Beneficiary_WorkAddress"]);
                    _complianceView_ViewResponse.Beneficiary_DeliveryAddress = Convert.ToString(row["Beneficiary_DeliveryAddress"]);
                    _complianceView_ViewResponse.Beneficiary_City = Convert.ToString(row["Beneficiary_City"]);
                    _complianceView_ViewResponse.Beneficiary_Region = Convert.ToString(row["Beneficiary_Region"]);
                    _complianceView_ViewResponse.Beneficiary_ZipCode = Convert.ToString(row["Beneficiary_ZipCode"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Type_ID"])))
                    {
                        _complianceView_ViewResponse.Type_ID = Convert.ToInt32(row["Type_ID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Type_ID = null;
                    }
                    _complianceView_ViewResponse.IDNumber = Convert.ToString(row["IDNumber"]);
                    _complianceView_ViewResponse.IDExpDt = Convert.ToString(row["IDExpDt"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["TrTypeID"])))
                    {
                        _complianceView_ViewResponse.TrTypeID = Convert.ToInt32(row["TrTypeID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.TrTypeID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayInCountry"])))
                    {
                        _complianceView_ViewResponse.PayInCountry = Convert.ToInt32(row["PayInCountry"]);
                        PayInCountry = Convert.ToInt32(row["PayInCountry"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayInCountry = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayInCurrency"])))
                    {
                        _complianceView_ViewResponse.PayInCurrency = Convert.ToInt32(row["PayInCurrency"]);
                        PayInCurrency = Convert.ToInt32(row["PayInCurrency"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayInCurrency = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentBranch_ID"])))
                    {
                        _complianceView_ViewResponse.AgentBranch_ID = Convert.ToInt32(row["AgentBranch_ID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgentBranch_ID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SendingAgentMargin"])))
                    {
                        _complianceView_ViewResponse.SendingAgentMargin = Convert.ToDecimal(row["SendingAgentMargin"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SendingAgentMargin = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCurrency"])))
                    {
                        _complianceView_ViewResponse.PayOutCurrency = Convert.ToInt32(row["PayOutCurrency"]);
                        PayOutCurrency = Convert.ToInt32(row["PayOutCurrency"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutCurrency = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCountry"])))
                    {
                        _complianceView_ViewResponse.PayOutCountry = Convert.ToInt32(row["PayOutCountry"]);
                        PayOutCountry = Convert.ToInt32(row["PayOutCountry"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutCountry = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCityID"])))
                    {
                        _complianceView_ViewResponse.PayOutCityID = Convert.ToInt32(row["PayOutCityID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutCityID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutLocationID"])))
                    {
                        _complianceView_ViewResponse.PayOutLocationID = Convert.ToInt32(row["PayOutLocationID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutLocationID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RecommendedAgent_ID"])))
                    {
                        _complianceView_ViewResponse.RecommendedAgent_ID = Convert.ToInt32(row["RecommendedAgent_ID"]);
                        RecommendedAgent_ID = Convert.ToInt32(row["RecommendedAgent_ID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RecommendedAgent_ID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["BDO_Branch_ID"])))
                    {
                        _complianceView_ViewResponse.BDO_Branch_ID = Convert.ToInt32(row["BDO_Branch_ID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.BDO_Branch_ID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentFC_Amount"])))
                    {
                        _complianceView_ViewResponse.AgentFC_Amount = Convert.ToDecimal(row["AgentFC_Amount"]);
                        PayOutAmount = Convert.ToDecimal(row["AgentFC_Amount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgentFC_Amount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentLC_Amount"])))
                    {
                        _complianceView_ViewResponse.AgentLC_Amount = Convert.ToDecimal(row["AgentLC_Amount"]);
                        PayInAmount = Convert.ToDecimal(row["AgentLC_Amount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgentLC_Amount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentRate"])))
                    {
                        _complianceView_ViewResponse.AgentRate = Convert.ToDecimal(row["AgentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Rate"])))
                    {
                        _complianceView_ViewResponse.Rate = Convert.ToDecimal(row["Rate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Rate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["BaseToBaseCommissionAmount"])))
                    {
                        _complianceView_ViewResponse.BaseToBaseCommissionAmount = Convert.ToDecimal(row["BaseToBaseCommissionAmount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.BaseToBaseCommissionAmount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["ModeOfPayment_ID"])))
                    {
                        _complianceView_ViewResponse.ModeOfPayment_ID = Convert.ToInt32(row["ModeOfPayment_ID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.ModeOfPayment_ID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PurposeOfTransfer"])))
                    {
                        _complianceView_ViewResponse.PurposeOfTransfer = Convert.ToInt32(row["PurposeOfTransfer"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PurposeOfTransfer = null;
                    }
                    _complianceView_ViewResponse.PurposeSpecify = Convert.ToString(row["PurposeSpecify"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayInCommissionType"])))
                    {
                        _complianceView_ViewResponse.PayInCommissionType = Convert.ToInt32(row["PayInCommissionType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayInCommissionType = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayInCurrencyType"])))
                    {
                        _complianceView_ViewResponse.PayInCurrencyType = Convert.ToInt32(row["PayInCurrencyType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayInCurrencyType = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayInCommissionAmount"])))
                    {
                        _complianceView_ViewResponse.PayInCommissionAmount = Convert.ToDecimal(row["PayInCommissionAmount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayInCommissionAmount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SenderPercentComm"])))
                    {
                        _complianceView_ViewResponse.SenderPercentComm = Convert.ToDecimal(row["SenderPercentComm"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SenderPercentComm = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SPercentage"])))
                    {
                        _complianceView_ViewResponse.SPercentage = Convert.ToDecimal(row["SPercentage"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SPercentage = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SMinimumComm"])))
                    {
                        _complianceView_ViewResponse.SMinimumComm = Convert.ToDecimal(row["SMinimumComm"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SMinimumComm = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SMaximumComm"])))
                    {
                        _complianceView_ViewResponse.SMaximumComm = Convert.ToDecimal(row["SMaximumComm"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SMaximumComm = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCommissionType"])))
                    {
                        _complianceView_ViewResponse.PayOutCommissionType = Convert.ToInt32(row["PayOutCommissionType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutCommissionType = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCurrencyType"])))
                    {
                        _complianceView_ViewResponse.PayOutCurrencyType = Convert.ToInt32(row["PayOutCurrencyType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutCurrencyType = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCommissionAmount"])))
                    {
                        _complianceView_ViewResponse.PayOutCommissionAmount = Convert.ToDecimal(row["PayOutCommissionAmount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayOutCommissionAmount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RPercentage"])))
                    {
                        _complianceView_ViewResponse.RPercentage = Convert.ToDecimal(row["RPercentage"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RPercentage = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RMinimumComm"])))
                    {
                        _complianceView_ViewResponse.RMinimumComm = Convert.ToDecimal(row["RMinimumComm"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RMinimumComm = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RMaximumComm"])))
                    {
                        _complianceView_ViewResponse.RMaximumComm = Convert.ToDecimal(row["RMaximumComm"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RMaximumComm = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["TrDate"])))
                    {
                        _complianceView_ViewResponse.TrDate = Convert.ToDateTime(row["TrDate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.TrDate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["TrTm"])))
                    {
                        _complianceView_ViewResponse.TrTm = Convert.ToDateTime(row["TrTm"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.TrTm = null;
                    }

                    _complianceView_ViewResponse.CourierAddress = Convert.ToString(row["CourierAddress"]);
                    _complianceView_ViewResponse.CourierRemark = Convert.ToString(row["CourierRemark"]);
                    _complianceView_ViewResponse.ManualSuspected = Convert.ToBoolean(row["ManualSuspected"]);
                    _complianceView_ViewResponse.SourceOfIncome = Convert.ToString(row["SourceOfIncome"]);
                    _complianceView_ViewResponse.SourceOfFund = Convert.ToString(row["SourceOfFund"]);
                    _complianceView_ViewResponse.ProofOfFund = Convert.ToString(row["ProofOfFund"]);
                    _complianceView_ViewResponse.IsArebic = Convert.ToBoolean(row["IsArebic"]);
                    _complianceView_ViewResponse.BankAccountNo = Convert.ToString(row["BankAccountNo"]);
                    _complianceView_ViewResponse.BankName = Convert.ToString(row["BankName"]);
                    _complianceView_ViewResponse.BankBranch = Convert.ToString(row["BankBranch"]);
                    _complianceView_ViewResponse.BankAddress = Convert.ToString(row["BankAddress"]);
                    _complianceView_ViewResponse.DDNumber = Convert.ToString(row["DDNumber"]);
                    _complianceView_ViewResponse.DDBank = Convert.ToString(row["DDBank"]);
                    _complianceView_ViewResponse.DDBranch = Convert.ToString(row["DDBranch"]);
                    _complianceView_ViewResponse.DDBankAddress = Convert.ToString(row["DDBankAddress"]);
                    _complianceView_ViewResponse.EnteredBy = Convert.ToString(row["EnteredBy"]);
                    _complianceView_ViewResponse.ProcessComplete = Convert.ToBoolean(row["ProcessComplete"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SendAgent"])))
                    {
                        _complianceView_ViewResponse.SendAgent = Convert.ToInt32(row["SendAgent"]);
                        AgentID = Convert.ToInt32(row["SendAgent"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SendAgent = null;
                    }

                    bool _output = false;
                    Agent.AgentSettlementCurrency _get = new Agent.AgentSettlementCurrency(AgentID.ToString(), csCommon.ConnectionString);
                    int _SettlementCurrency = _get.GetSettlementCurrency();

                    Country.Validation _validate =
                        new Country.Validation(Permission.Send, PayInCountry, PayInCurrency, _SettlementCurrency, PayInAmount, csCommon.ConnectionString);
                    _output = _validate.IsIDRequired();
                    _complianceView_ViewResponse.IsIDRequiredForSendingCountry = _output;

                    bool _outputReceivingCountry = false;
                    Agent.AgentSettlementCurrency _get1 = new Agent.AgentSettlementCurrency(RecommendedAgent_ID.ToString(), csCommon.ConnectionString);
                    _SettlementCurrency = _get1.GetSettlementCurrency();

                    Country.Validation _validate1 =
                        new Country.Validation(Permission.Send, PayOutCountry, PayOutCurrency, _SettlementCurrency, PayOutAmount, csCommon.ConnectionString);
                    _outputReceivingCountry = _validate.IsIDRequired();

                    _complianceView_ViewResponse.IsIDRequiredForReceivingCountry = _outputReceivingCountry;

                    if (!string.IsNullOrEmpty(Convert.ToString(row["SenderAgentBaseCCY"])))
                    {
                        _complianceView_ViewResponse.SenderAgentBaseCCY = Convert.ToInt32(row["SenderAgentBaseCCY"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SenderAgentBaseCCY = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Sending_SettlementCurrency"])))
                    {
                        _complianceView_ViewResponse.Sending_SettlementCurrency = Convert.ToInt32(row["Sending_SettlementCurrency"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Sending_SettlementCurrency = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["BaseCountry"])))
                    {
                        _complianceView_ViewResponse.BaseCountry = Convert.ToInt32(row["BaseCountry"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.BaseCountry = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["BaseCurrency"])))
                    {
                        _complianceView_ViewResponse.BaseCurrency = Convert.ToInt32(row["BaseCurrency"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.BaseCurrency = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Ex_Branch_ID"])))
                    {
                        _complianceView_ViewResponse.Ex_Branch_ID = Convert.ToInt32(row["Ex_Branch_ID"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Ex_Branch_ID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SASettelmentRate"])))
                    {
                        _complianceView_ViewResponse.SASettelmentRate = Convert.ToDecimal(row["SASettelmentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SASettelmentRate = null;
                    }
                    _complianceView_ViewResponse.SendToSR1 = Convert.ToBoolean(row["SendToSR1"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentCommissionVariance"])))
                    {
                        _complianceView_ViewResponse.AgentCommissionVariance = Convert.ToDecimal(row["AgentCommissionVariance"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgentCommissionVariance = null;
                    }
                    _complianceView_ViewResponse.Customer_PassportID = Convert.ToString(row["Customer_PassportID"]);
                    _complianceView_ViewResponse.Beneficiary_DOB = Convert.ToString(row["Beneficiary_DOB"]);
                    _complianceView_ViewResponse.PadalaCardNo = Convert.ToString(row["PadalaCardNo"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["EntryInterval"])))
                    {
                        _complianceView_ViewResponse.EntryInterval = Convert.ToInt32(row["EntryInterval"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.EntryInterval = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Receiver_OfferRate"])))
                    {
                        _complianceView_ViewResponse.Receiver_OfferRate = Convert.ToInt32(row["Receiver_OfferRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.Receiver_OfferRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SenderBase_Rate"])))
                    {
                        _complianceView_ViewResponse.SenderBase_Rate = Convert.ToDecimal(row["SenderBase_Rate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SenderBase_Rate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["ReceiverBase_Rate"])))
                    {
                        _complianceView_ViewResponse.ReceiverBase_Rate = Convert.ToDecimal(row["ReceiverBase_Rate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.ReceiverBase_Rate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SA_SC_SRC_SettelmentRate"])))
                    {
                        _complianceView_ViewResponse.SA_SC_SRC_SettelmentRate = Convert.ToDecimal(row["SA_SC_SRC_SettelmentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SA_SC_SRC_SettelmentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SA_STC_SRC_SettelmentRate"])))
                    {
                        _complianceView_ViewResponse.SA_STC_SRC_SettelmentRate = Convert.ToDecimal(row["SA_STC_SRC_SettelmentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SA_STC_SRC_SettelmentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SC_SRC_SettelmentRate"])))
                    {
                        _complianceView_ViewResponse.SC_SRC_SettelmentRate = Convert.ToDecimal(row["SC_SRC_SettelmentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SC_SRC_SettelmentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RA_SC_RC_SRC_SettelmentRate"])))
                    {
                        _complianceView_ViewResponse.RA_SC_RC_SRC_SettelmentRate = Convert.ToDecimal(row["RA_SC_RC_SRC_SettelmentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RA_SC_RC_SRC_SettelmentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RA_STC_SRC_SettelmentRate"])))
                    {
                        _complianceView_ViewResponse.RA_STC_SRC_SettelmentRate = Convert.ToDecimal(row["RA_STC_SRC_SettelmentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RA_STC_SRC_SettelmentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RC_SRC_SettelmentRate"])))
                    {
                        _complianceView_ViewResponse.RC_SRC_SettelmentRate = Convert.ToDecimal(row["RC_SRC_SettelmentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RC_SRC_SettelmentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["BidRate"])))
                    {
                        _complianceView_ViewResponse.BidRate = Convert.ToDecimal(row["BidRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.BidRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["OfferRate"])))
                    {
                        _complianceView_ViewResponse.OfferRate = Convert.ToDecimal(row["OfferRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.OfferRate = null;
                    }
                    _complianceView_ViewResponse.BankCode = Convert.ToString(row["BankCode"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgencyMargin"])))
                    {
                        _complianceView_ViewResponse.AgencyMargin = Convert.ToDecimal(row["AgencyMargin"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.AgencyMargin = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RASettelmentRate"])))
                    {
                        _complianceView_ViewResponse.RASettelmentRate = Convert.ToDecimal(row["RASettelmentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RASettelmentRate = null;
                    }
                    _complianceView_ViewResponse.IFSCType = Convert.ToString(row["IFSCType"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["CostRate"])))
                    {
                        _complianceView_ViewResponse.CostRate = Convert.ToDecimal(row["CostRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.CostRate = null;
                    }
                    _complianceView_ViewResponse.IsCancelReq = Convert.ToBoolean(row["IsCancelReq"]);
                    _complianceView_ViewResponse.CancelRemark = Convert.ToString(row["CancelRemark"]);
                    _complianceView_ViewResponse.IsAutoApprove = Convert.ToBoolean(row["IsAutoApprove"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["PayCommissionType"])))
                    {
                        _complianceView_ViewResponse.PayCommissionType = Convert.ToInt32(row["PayCommissionType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.PayCommissionType = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SPayCommissionType"])))
                    {
                        _complianceView_ViewResponse.SPayCommissionType = Convert.ToInt32(row["SPayCommissionType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SPayCommissionType = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RPayCommissionType"])))
                    {
                        _complianceView_ViewResponse.RPayCommissionType = Convert.ToInt32(row["RPayCommissionType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RPayCommissionType = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["ReceivePercentComm"])))
                    {
                        _complianceView_ViewResponse.ReceivePercentComm = Convert.ToDecimal(row["ReceivePercentComm"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.ReceivePercentComm = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RCommAmtOf"])))
                    {
                        _complianceView_ViewResponse.RCommAmtOf = Convert.ToInt32(row["RCommAmtOf"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RCommAmtOf = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RPayOutCurrencyType"])))
                    {
                        _complianceView_ViewResponse.RPayOutCurrencyType = Convert.ToInt32(row["RPayOutCurrencyType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RPayOutCurrencyType = null;
                    }
                    _complianceView_ViewResponse.IsPaidPushToFTP = Convert.ToBoolean(row["IsPaidPushToFTP"]);
                    _complianceView_ViewResponse.IsDuplicate = Convert.ToBoolean(row["IsDuplicate"]);
                    _complianceView_ViewResponse.IsForPayOut = Convert.ToBoolean(row["IsForPayOut"]);
                    _complianceView_ViewResponse.PayOut_Branch_ID = Convert.ToString(row["PayOut_Branch_ID"]);
                    _complianceView_ViewResponse.PayOut_By = Convert.ToString(row["PayOut_By"]);
                    _complianceView_ViewResponse.IsPaidAtSR = Convert.ToBoolean(row["IsPaidAtSR"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RCommAmtOf"])))
                    {
                        _complianceView_ViewResponse.RCommAmtOf = Convert.ToInt32(row["RCommAmtOf"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RCommAmtOf = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["ReceiverIDType"])))
                    {
                        _complianceView_ViewResponse.ReceiverIDType = Convert.ToInt32(row["ReceiverIDType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.ReceiverIDType = null;
                    }
                    _complianceView_ViewResponse.ReceiverIDNumber = Convert.ToString(row["ReceiverIDNumber"]);
                    _complianceView_ViewResponse.ReceiverIDExpDt = Convert.ToString(row["ReceiverIDExpDt"]);
                    _complianceView_ViewResponse.PaidDate = Convert.ToString(row["PaidDate"]);
                    _complianceView_ViewResponse.ThirdPartyCode = Convert.ToString(row["ThirdPartyCode"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SAIncentive"])))
                    {
                        _complianceView_ViewResponse.SAIncentive = Convert.ToDecimal(row["SAIncentive"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SAIncentive = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SAIncentiveCCY"])))
                    {
                        _complianceView_ViewResponse.SAIncentiveCCY = Convert.ToInt32(row["SAIncentiveCCY"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SAIncentiveCCY = null;
                    }
                    _complianceView_ViewResponse.IsOfac = Convert.ToBoolean(row["IsOfac"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["ActualAgentRate"])))
                    {
                        _complianceView_ViewResponse.ActualAgentRate = Convert.ToDecimal(row["ActualAgentRate"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.ActualAgentRate = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SUBAgentMargin"])))
                    {
                        _complianceView_ViewResponse.SUBAgentMargin = Convert.ToDecimal(row["SUBAgentMargin"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SUBAgentMargin = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SAIncentiveCCY"])))
                    {
                        _complianceView_ViewResponse.SAIncentiveCCY = Convert.ToInt32(row["SAIncentiveCCY"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SAIncentiveCCY = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SUBPayInCommissionType"])))
                    {
                        _complianceView_ViewResponse.SUBPayInCommissionType = Convert.ToInt32(row["SUBPayInCommissionType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SUBPayInCommissionType = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SUBPayInCommissionAmount"])))
                    {
                        _complianceView_ViewResponse.SUBPayInCommissionAmount = Convert.ToDecimal(row["SUBPayInCommissionAmount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SUBPayInCommissionAmount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SUBAgentCommissionVariance"])))
                    {
                        _complianceView_ViewResponse.SUBAgentCommissionVariance = Convert.ToDecimal(row["SUBAgentCommissionVariance"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.SUBAgentCommissionVariance = null;
                    }
                    _complianceView_ViewResponse.Remitter_ZipCode = Convert.ToString(row["Remitter_ZipCode"]);
                    _complianceView_ViewResponse.CancelReqBy = Convert.ToString(row["CancelReqBy"]);
                    _complianceView_ViewResponse.CancelReqDate = Convert.ToString(row["CancelReqDate"]);
                    _complianceView_ViewResponse.CancelledDate = Convert.ToString(row["CancelledDate"]);
                    _complianceView_ViewResponse.RemoveBy = Convert.ToString(row["RemoveBy"]);
                    _complianceView_ViewResponse.DownloadBy = Convert.ToString(row["DownloadBy"]);
                    _complianceView_ViewResponse.DownloadDate = Convert.ToString(row["DownloadDate"]);
                    _complianceView_ViewResponse.Customer_City = Convert.ToString(row["Customer_City"]);
                    _complianceView_ViewResponse.Customer_State = Convert.ToString(row["Customer_State"]);
                    _complianceView_ViewResponse.Customer_Issuer = Convert.ToString(row["Customer_Issuer"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["MembershipType"])))
                    {
                        _complianceView_ViewResponse.MembershipType = Convert.ToInt32(row["MembershipType"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.MembershipType = null;
                    }
                    _complianceView_ViewResponse.IsSendToPayMate = Convert.ToBoolean(row["IsSendToPayMate"]);
                    _complianceView_ViewResponse.PayMatRef_no = Convert.ToString(row["PayMatRef_no"]);
                    _complianceView_ViewResponse.ROtherType_ID = Convert.ToString(row["ROtherType_ID"]);
                    _complianceView_ViewResponse.BOtherType_ID = Convert.ToString(row["BOtherType_ID"]);
                    _complianceView_ViewResponse.IsCTAHold = Convert.ToBoolean(row["IsCTAHold"]);
                    _complianceView_ViewResponse.IsCTAVarification = Convert.ToBoolean(row["IsCTAVarification"]);
                    _complianceView_ViewResponse.IsReleaseAtPartner = Convert.ToBoolean(row["IsReleaseAtPartner"]);
                    _complianceView_ViewResponse.SAIsCTAHold = Convert.ToBoolean(row["SAIsCTAHold"]);
                    _complianceView_ViewResponse.ActualRecommendedBranchID = Convert.ToString(row["ActualRecommendedBranchID"]);
                    _complianceView_ViewResponse.IsEmailSent = Convert.ToBoolean(row["IsEmailSent"]);
                    _complianceView_ViewResponse.StudentName = Convert.ToString(row["StudentName"]);
                    _complianceView_ViewResponse.StudentID = Convert.ToString(row["StudentID"]);
                    _complianceView_ViewResponse.StudReferenceNO = Convert.ToString(row["StudReferenceNO"]);
                    _complianceView_ViewResponse.StudentEnrollNO = Convert.ToString(row["StudentEnrollNO"]);
                    _complianceView_ViewResponse.BeneficiaryNo = Convert.ToString(row["StudentEnrollNO"]);
                    _complianceView_ViewResponse.CustomerAccountNumber = Convert.ToString(row["CustomerAccountNumber"]);
                    _complianceView_ViewResponse.BeneficiaryBankID = Convert.ToString(row["BeneficiaryBankID"]);

                    if (!string.IsNullOrEmpty(Convert.ToString(row["IsSendToMQ"])))
                    {
                        _complianceView_ViewResponse.IsSendToMQ = Convert.ToBoolean(row["IsSendToMQ"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.IsSendToMQ = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["IsPPSsuccess"])))
                    {
                        _complianceView_ViewResponse.IsPPSsuccess = Convert.ToBoolean(row["IsPPSsuccess"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.IsPPSsuccess = null;
                    }


                    _complianceView_ViewResponse.IsICSsuccess = Convert.ToString(row["IsICSsuccess"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["VATAmount"])))
                    {
                        _complianceView_ViewResponse.VATAmount = Convert.ToDecimal(row["VATAmount"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.VATAmount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["VATPerCentage"])))
                    {
                        _complianceView_ViewResponse.VATPerCentage = Convert.ToDecimal(row["VATPerCentage"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.VATPerCentage = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["CommIncVAT"])))
                    {
                        _complianceView_ViewResponse.CommIncVAT = Convert.ToDecimal(row["CommIncVAT"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.CommIncVAT = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["RFixComm"])))
                    {
                        _complianceView_ViewResponse.RFixComm = Convert.ToDecimal(row["RFixComm"]);
                    }
                    else
                    {
                        _complianceView_ViewResponse.RFixComm = null;
                    }
                    _complianceView_ViewResponse.IsVostroProcess = Convert.ToString(row["IsVostroProcess"]);
                    _complianceView_ViewResponse.ChannelTxnNumber = Convert.ToString(row["ChannelTxnNumber"]);
                    _complianceView_ViewResponse.IsPurge = Convert.ToString(row["IsPurge"]);
                    _complianceView_ViewResponse.HostRespCode = Convert.ToString(row["HostRespCode"]);
                    _complianceView_ViewResponse.PaymentDetails = Convert.ToString(row["PaymentDetails"]);
                    _complianceView_ViewResponse.SCCY = Convert.ToString(row["SCCY"]);
                    _complianceView_ViewResponse.DCCY = Convert.ToString(row["DCCY"]);
                    _complianceView_ViewResponse.DCountry = Convert.ToString(row["DCountry"]);
                    _complianceView_ViewResponse.DMode = Convert.ToString(row["DMode"]);
                    _complianceView_ViewResponse.DCity = Convert.ToString(row["DCity"]);
                    _complianceView_ViewResponse.DLocation = Convert.ToString(row["DLocation"]);
                    _complianceView_ViewResponse.DAgent = Convert.ToString(row["DAgent"]);
                    _complianceView_ViewResponse.AgentAdd = Convert.ToString(row["AgentAdd"]);
                    _complianceView_ViewResponse.DPurpose = Convert.ToString(row["DPurpose"]);
                    lstcomplianceView_ViewResponse.Add(_complianceView_ViewResponse);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceView_ViewResponse);
                commonLogDetails.LogToDB("GetComplianceManagementView_BindWithoutSBI", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber}");

                return lstcomplianceView_ViewResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementView_BindWithoutSBI", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }
        }

        public List<ComplianceManagementView_ShowDetail> GetComplianceManagementView_ComplianceShowDetail(string TransactionNumber, string SearchType)
        {
            try
            {
                List<ComplianceManagementView_ShowDetail> lstcomplianceView_ComplianceShowDetail = new List<ComplianceManagementView_ShowDetail>();
                DataTable dt = dal.GetComplianceManagementView_ComplianceShowDetail(TransactionNumber, SearchType);
                string str = JsonConvert.SerializeObject(dt);

                foreach (DataRow row in dt.Rows)
                {
                    ComplianceManagementView_ShowDetail _complianceView_ComplianceShowDetail = new ComplianceManagementView_ShowDetail();
                    _complianceView_ComplianceShowDetail.UID = Convert.ToString(row["UID"]);
                    _complianceView_ComplianceShowDetail.Remark = Convert.ToString(row["Remark"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Per"])))
                    {
                        _complianceView_ComplianceShowDetail.Per = Convert.ToDecimal(row["Per"]);
                    }
                    else
                    {
                        _complianceView_ComplianceShowDetail.Per = null;
                    }
                    _complianceView_ComplianceShowDetail.Name = Convert.ToString(row["Name"]);
                    _complianceView_ComplianceShowDetail.Aliases = Convert.ToString(row["Aliases"]);
                    _complianceView_ComplianceShowDetail.Remarks = Convert.ToString(row["Remarks"]);
                    _complianceView_ComplianceShowDetail.Address = Convert.ToString(row["Address"]);
                    lstcomplianceView_ComplianceShowDetail.Add(_complianceView_ComplianceShowDetail);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceView_ComplianceShowDetail);
                commonLogDetails.LogToDB("GetComplianceManagementView_ComplianceShowDetail", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber},SearchType: {SearchType}");

                return lstcomplianceView_ComplianceShowDetail;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetComplianceManagementView_ComplianceShowDetail", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber},SearchType: {SearchType}");
                throw ex;
            }
        }

        public bool ComplianceManagementView_OnHold(string TransactionNumber, string Remark, string UserID)
        {
            try
            {
                    bool AgentWiseCommission = false;
                    AgentWiseCommission = dal.ComplianceManagementView_OnHold(TransactionNumber, Remark, UserID);

                commonLogDetails.LogToDB("ComplianceManagementView_OnHold", UserID, "Success", "true", $"TransactionNumber: {TransactionNumber},Remark: {Remark},UserID: {UserID}");

                return AgentWiseCommission;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ComplianceManagementView_OnHold", UserID, ex.ToString(), "Flase", $"TransactionNumber: {TransactionNumber},Remark: {Remark},UserID: {UserID}");
                throw ex;
            }
        }

        public bool ComplianceManagementView_UpdateCustBEN(string TransactionNumber, string IsApprove, string sType, string Remark, string UserID, string CustomerBeneficiaryNo)
        {
            try
            {
                bool ComplianceManagement = false;
                ComplianceManagement = dal.ComplianceManagementView_UpdateCustBEN(TransactionNumber, IsApprove, sType, Remark, UserID, CustomerBeneficiaryNo);
                commonLogDetails.LogToDB("ComplianceManagementView_UpdateCustBEN", UserID, "Success", "true", $"TransactionNumber: {TransactionNumber},IsApprove: {IsApprove},sType : {sType},Remark: {Remark},UserID: {UserID},CustomerBeneficiaryNo: {CustomerBeneficiaryNo}");
                return ComplianceManagement;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ComplianceManagementView_UpdateCustBEN", UserID, ex.ToString(), "Flase", $"TransactionNumber: {TransactionNumber},IsApprove: {IsApprove},sType : {sType},Remark: {Remark},UserID: {UserID},CustomerBeneficiaryNo: {CustomerBeneficiaryNo}");
                throw ex;
            }
        }

        public bool ComplianceManagementView_Approve(string TransactionNumber, string Remark, string UserID)
        {
            try
            {
                bool ComplianceManagement = false;
                ComplianceManagement = dal.ComplianceManagementView_Approve(TransactionNumber, Remark, UserID);

                commonLogDetails.LogToDB("ComplianceManagementView_Approve", UserID, "Success", "true", $"TransactionNumber: {TransactionNumber},Remark: {Remark},UserID: {UserID}");

                return ComplianceManagement;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ComplianceManagementView_Approve", UserID, ex.ToString(), "Flase", $"TransactionNumber: {TransactionNumber},Remark: {Remark},UserID: {UserID}");
                throw ex;
            }
        }

        public bool TransactionPrefix(string TransactionNumber)
        {
            try
            {
                bool ComplianceManagementTxnPrefix = dal.GetComplianceManagementTxnPrefix(TransactionNumber);
                commonLogDetails.LogToDB("TransactionPrefix", "N/A", "Success", "true", $"TransactionNumber: {TransactionNumber}");
                return ComplianceManagementTxnPrefix;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("TransactionPrefix", "N/A", ex.ToString(), "Flase", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }
        }

        public List<RejectResponse>Reject(string TransactionNumber, string UserID, string IsMGTxn, string IsMTOSuccess, string RejectReason, string OrgMsgID)
        {
            try
            {
                List<RejectResponse> lstcomplianceView_Reject = new List<RejectResponse>();
                RejectResponse _complianceView_Reject = new RejectResponse();
                string TransNo = TransactionNumber;
                // string _strSuccessFlag = "0";
                string IsMGCancel = "N";
                // bool StrFlag = false;
                #region MGCancel


                if (IsMGTxn == "Y")
                {
                    if (IsMTOSuccess == "Y")
                    {
                        string MGCancel_msg_ = "";

                        csMG _csMG = new csMG();

                        csMGCancelLog objcsMGCancelLog = new csMGCancelLog();

                        DetailLookupResponse resp = null;

                        objcsMGCancelLog.TxnNumber = TransNo;
                        objcsMGCancelLog.CancelUser = UserID;

                        objcsMGCancelLog.RequestType = CanRequestType.Request;
                        objcsMGCancelLog.LogToDB();

                        /////////////////////////////////////////////////////

                        string MG_referenceNumber = "";



                        var paramObj = new { Txn_No = TransNo };

                        MG_referenceNumber = _csMG.get_tbl_data("usp_Get_MG_RefNumber", paramObj).Tables[0].Rows[0]["MG_refno"].ToString();



                        /////////////////////////////////////////////////////


                        string dtLookUp_resp = _csMG.MG_detailLookup(MG_referenceNumber, TransNo, 0);

                        if (!dtLookUp_resp.Split('|')[0].Equals("NA"))
                        {

                            resp = JsonConvert.DeserializeObject<DetailLookupResponse>(dtLookUp_resp);

                            if (resp.transactionStatus.ToString() == "AVAIL" ||
                                resp.transactionStatus.ToString() == "AFR" ||
                                resp.transactionStatus.ToString() == "PRCSS")
                            {



                                MGCancel_msg_ = _csMG.MG_CancelTransaction(MG_referenceNumber, TransNo, resp,
                                    "WRONG_SERVICE", "Y");



                                if (MGCancel_msg_.Split('|')[0] == "0")
                                {
                                    throw new Exception("MG_Error : " + MGCancel_msg_.Split('|')[1]);
                                }
                                IsMGCancel = "Y";

                            }
                            else if (resp.transactionStatus.ToString() == "CANCL" || resp.transactionStatus.ToString() == "REFND")
                            {
                                IsMGCancel = "Y";
                            }
                            else
                            {

                                _complianceView_Reject.Message = "MG_Error : This transaction cannot be cancelled.";
                                throw new Exception("MG_Error : This transaction cannot be cancelled.");


                            }

                        }
                        else
                        {

                            _complianceView_Reject.Message = "MG_Error : " + dtLookUp_resp.Split('|')[1];

                            throw new Exception("MG_Error : " + dtLookUp_resp.Split('|')[1]);



                        }
                    }
                    else
                    {
                        IsMGCancel = "Y";
                    }

                }
                else
                {
                    IsMGCancel = "Y";
                }

                #endregion

                if (IsMGCancel == "Y")
                {
                    #region ICS PPS REQUEST

                    #region GetCustomerType
                    DataTable dt = new DataTable();
                    dt = dal.GetCustomerType(TransactionNumber);
                    #endregion


                    if (dt.Rows[0]["CutomerType"].ToString() == "1")
                    {
                        #region PPS
                        PPSRequest objPPSRequest = new PPSRequest();
                        objPPSRequest.CancelType = CancelType.ComplianceBlockCancel;
                        objPPSRequest.ReferenceNo = TransNo;
                        objPPSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                        objPPSRequest.IsReverse = false;
                        objPPSRequest.CancelMessage = RejectReason;
                        objPPSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                        objPPSRequest.CancelRequstedUser = UserID;
                        if (objPPSRequest.SentToPPS())
                        {
                            _complianceView_Reject.strSuccessFlag = "1";
                        }
                        else
                        {
                            _complianceView_Reject.strSuccessFlag = "0";
                            _complianceView_Reject.Message = objPPSRequest.Description;

                        }
                        #endregion
                    }
                    else
                    {
                        #region ICS
                        if (!string.IsNullOrEmpty(OrgMsgID))
                        {
                            ICSDFRequest objICSDoubtFulRequest = new ICSDFRequest();
                            objICSDoubtFulRequest.CancelType = CancelType.ComplianceBlockCancel;
                            objICSDoubtFulRequest.OriginalMsgID = OrgMsgID;
                            objICSDoubtFulRequest.ReferenceNo = TransNo;
                            objICSDoubtFulRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                            objICSDoubtFulRequest.IsReverse = false;
                            objICSDoubtFulRequest.CancelMessage = RejectReason;
                            objICSDoubtFulRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                            objICSDoubtFulRequest.CancelRequstedUser = UserID;

                            if (objICSDoubtFulRequest.SendDoubtfulRequest())
                            {
                                _complianceView_Reject.strSuccessFlag = "1";
                            }
                            else
                            {
                                _complianceView_Reject.strSuccessFlag = "0";
                                _complianceView_Reject.Message = objICSDoubtFulRequest.Description;
                            }

                        }
                        else
                        {
                            ICSRequest objICSRequest = new ICSRequest();
                            objICSRequest.CancelType = CancelType.ComplianceBlockCancel;
                            objICSRequest.ReferenceNo = TransNo;
                            objICSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                            objICSRequest.IsReverse = false;
                            objICSRequest.CancelMessage = RejectReason;
                            objICSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                            objICSRequest.CancelRequstedUser = UserID;

                            if (objICSRequest.SentToICS())
                            {
                                _complianceView_Reject.strSuccessFlag = "1";

                            }
                            else
                            {
                                _complianceView_Reject.strSuccessFlag = "0";
                                _complianceView_Reject.Message = objICSRequest.Description;

                                if (objICSRequest.Description.Contains("Could not read message"))
                                {
                                    string _scriptErr = "frmViewblocktransaction.aspx?trn=&msg=Transaction number " + TransNo + " is NOT Rejected.";
                                    _complianceView_Reject.Message = _scriptErr;


                                }
                            }
                        }
                        #endregion
                    }
                    #endregion

                }
                lstcomplianceView_Reject.Add(_complianceView_Reject);

                string result = JsonConvert.SerializeObject(lstcomplianceView_Reject);
                commonLogDetails.LogToDB("Reject", UserID, "Success", result, $"TransactionNumber: {TransactionNumber},IsMGTxn: {IsMGTxn}, IsMTOSuccess:{IsMTOSuccess}, RejectReason:{RejectReason}, OrgMsgID : {OrgMsgID}");

                return lstcomplianceView_Reject;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("Reject", UserID, ex.ToString(), "Flase", $"TransactionNumber: {TransactionNumber},IsMGTxn: {IsMGTxn}, IsMTOSuccess:{IsMTOSuccess}, RejectReason:{RejectReason}, OrgMsgID : {OrgMsgID}");
                throw ex;
            }
        }
    }
}