﻿using MainRemit;
using MyDatabase;
using Newtonsoft.Json;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Request;
using SAIB_Web_Api.Models.Response;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;


namespace SAIB_Web_Api.BusinessManager
{
    public class TransactionCancelPaidManager
    {
        DAL dal = new DAL();
        CommonLogDetails commonLogDetails = new CommonLogDetails();

        public List<AgentList> GetCancelPaidTransactionAgentAccount(int CountryID)
        {
            try
            {
                DataTable dt = dal.GetCancelPaidTransactionAgentAccount(CountryID, Permission.Send);

                List<AgentList> lstAgentRequest = new List<AgentList>();

                foreach (DataRow row in dt.Rows)
                {
                    AgentList agentTypeList = new AgentList();
                    agentTypeList.Agent_ID = Convert.ToInt32(row["Agent_ID"]);
                    agentTypeList.Agent_Name = row["Agent_Name"].ToString();
                    lstAgentRequest.Add(agentTypeList);

                }

                string result = JsonConvert.SerializeObject(lstAgentRequest);
                commonLogDetails.LogToDB("GetCancelPaidTransactionAgentAccount", "N/A", "Success", result, $"CountryID: {CountryID}");

                return lstAgentRequest;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetCancelPaidTransactionAgentAccount", "N/A", ex.ToString(), "No Response", $"Form: {CountryID}");
                throw ex;
            }

        }

        public List<TransactionAgentBranch> GetCancelPaidTransactionAgentBranch(int AgentID)
        {
            try
            {
                DataTable dt = dal.GetCancelPaidTransactionAgentBranch(AgentID);

                List<TransactionAgentBranch> lstAgentBranch = new List<TransactionAgentBranch>();

                foreach (DataRow row in dt.Rows)
                {
                    TransactionAgentBranch agentBranchResponse = new TransactionAgentBranch();
                    agentBranchResponse.ID = Convert.ToInt32(row["ID"]);
                    agentBranchResponse.Name = row["Name"].ToString();
                    lstAgentBranch.Add(agentBranchResponse);

                }

                string result = JsonConvert.SerializeObject(lstAgentBranch);
                commonLogDetails.LogToDB("GetCancelPaidTransactionAgentBranch", "N/A", "Success", result, $"AgentID: {AgentID}");

                return lstAgentBranch;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetCancelPaidTransactionAgentBranch", "N/A", ex.ToString(), "No Response", $"AgentID: {AgentID}");
                throw ex;
            }

        }

        public List<TransactionCancelPaidResponse> GetCancelPaidTransactionAllRecord(int AgentID, int SubGroupID, int AgentBranchID, int CancelledType, int StatusID, string StartDate, string EndDate)
        {
            try
            {
                DataTable dt = dal.GetCancelPaidTransactionAllRecord(AgentID, SubGroupID, AgentBranchID, CancelledType, StatusID, StartDate, EndDate);
                List<TransactionCancelPaidResponse> lsttransactionResponse = new List<TransactionCancelPaidResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    TransactionCancelPaidResponse transactionResponse = new TransactionCancelPaidResponse();
                    transactionResponse.Agent_Name = Convert.ToString(row["Agent_Name"]);
                    transactionResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                    transactionResponse.IssueDate = Convert.ToString(row["IssueDate"]);
                    transactionResponse.CurrencyShortName = Convert.ToString(row["CurrencyShortName"]);
                    transactionResponse.CancelReqBy = Convert.ToString(row["CancelReqBy"]);
                    transactionResponse.CancelReqDate = Convert.ToString(row["CancelReqDate"]);
                    transactionResponse.CancelRemark = Convert.ToString(row["CancelRemark"]);
                    transactionResponse.CancelledBy = Convert.ToString(row["CancelledBy"]);
                    transactionResponse.CancelDate = Convert.ToString(row["CancelDate"]);
                    transactionResponse.CurrentStatus = Convert.ToString(row["CurrentStatus"]);
                    transactionResponse.hLink = Convert.ToString(row["hLink"]);
                    transactionResponse.ObjectVisible = Convert.ToString(row["ObjectVisible"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Ex_Branch_ID"])))
                    {
                        transactionResponse.Ex_Branch_ID = Convert.ToInt32(row["Ex_Branch_ID"]);
                    }
                    else
                    {
                        transactionResponse.Ex_Branch_ID = null;
                    }
                    transactionResponse.App_ID = Convert.ToString(row["App_ID"]);
                    transactionResponse.Reference_No = Convert.ToString(row["Reference_No"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["TrStatusID"])))
                    {
                        transactionResponse.TrStatusID = Convert.ToInt32(row["TrStatusID"]);
                    }
                    else
                    {
                        transactionResponse.TrStatusID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["IsShowRemoveOption"])))
                    {
                        transactionResponse.IsShowRemoveOption = Convert.ToInt32(row["IsShowRemoveOption"]);
                    }
                    else
                    {
                        transactionResponse.IsShowRemoveOption = null;
                    }

                    lsttransactionResponse.Add(transactionResponse);

                }

                string result = JsonConvert.SerializeObject(lsttransactionResponse);
                commonLogDetails.LogToDB("GetCancelPaidTransactionAllRecord", "N/A", "Success", result, $"AgentID: {AgentID},SubGroupID :{SubGroupID},AgentBranchID:{AgentBranchID},CancelledType:{CancelledType},StatusID:{StatusID},StartDate:{StartDate},EndDate:{EndDate}");

                return lsttransactionResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetCancelPaidTransactionAllRecord", "N/A", ex.ToString(), "No Response", $"AgentID: {AgentID},SubGroupID :{SubGroupID},AgentBranchID:{AgentBranchID},CancelledType:{CancelledType},StatusID:{StatusID},StartDate:{StartDate},EndDate:{EndDate}");
                throw ex;
            }

        }

        public List<TransactionCancelPaidResponse> GetCancelPaidTransactionByTransactionNumber(int AgentID, int SubGroupID, string TransactionNumber)
        {
            try
            {
                DataTable dt = dal.GetCancelPaidTransactionByTransactionNumber(AgentID, SubGroupID, TransactionNumber);
                List<TransactionCancelPaidResponse> lsttransactionResponse = new List<TransactionCancelPaidResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    TransactionCancelPaidResponse transactionResponse = new TransactionCancelPaidResponse();
                    transactionResponse.Agent_Name = Convert.ToString(row["Agent_Name"]);
                    transactionResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                    transactionResponse.IssueDate = Convert.ToString(row["IssueDate"]);
                    transactionResponse.CurrencyShortName = Convert.ToString(row["CurrencyShortName"]);
                    transactionResponse.CancelReqBy = Convert.ToString(row["CancelReqBy"]);
                    transactionResponse.CancelReqDate = Convert.ToString(row["CancelReqDate"]);
                    transactionResponse.CancelRemark = Convert.ToString(row["CancelRemark"]);
                    transactionResponse.CancelledBy = Convert.ToString(row["CancelledBy"]);
                    transactionResponse.CancelDate = Convert.ToString(row["CancelDate"]);
                    transactionResponse.CurrentStatus = Convert.ToString(row["CurrentStatus"]);
                    transactionResponse.hLink = Convert.ToString(row["hLink"]);
                    transactionResponse.ObjectVisible = Convert.ToString(row["ObjectVisible"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Ex_Branch_ID"])))
                    {
                        transactionResponse.Ex_Branch_ID = Convert.ToInt32(row["Ex_Branch_ID"]);
                    }
                    else
                    {
                        transactionResponse.Ex_Branch_ID = null;
                    }
                    transactionResponse.App_ID = Convert.ToString(row["App_ID"]);
                    transactionResponse.Reference_No = Convert.ToString(row["Reference_No"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["TrStatusID"])))
                    {
                        transactionResponse.TrStatusID = Convert.ToInt32(row["TrStatusID"]);
                    }
                    else
                    {
                        transactionResponse.TrStatusID = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["IsShowRemoveOption"])))
                    {
                        transactionResponse.IsShowRemoveOption = Convert.ToInt32(row["IsShowRemoveOption"]);
                    }
                    else
                    {
                        transactionResponse.IsShowRemoveOption = null;
                    }

                    lsttransactionResponse.Add(transactionResponse);

                }

                string result = JsonConvert.SerializeObject(lsttransactionResponse);
                commonLogDetails.LogToDB("GetCancelPaidTransactionByTransactionNumber", "N/A", "Success", result, $"AgentID: {AgentID},SubGroupID :{SubGroupID},TransactionNumber:{TransactionNumber}");

                return lsttransactionResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetCancelPaidTransactionByTransactionNumber", "N/A", ex.ToString(), "No Response", $"AgentID: {AgentID},SubGroupID :{SubGroupID},TransactionNumber:{TransactionNumber}");
                throw ex;
            }

        }

        public List<TransactionReport> GetTransactionReport(string TransactionNumber)
        {
            try
            {
                DataTable dt = dal.GetTransactionReport(TransactionNumber);

                List<TransactionReport> lstTransactionReport = new List<TransactionReport>();
                TransactionReport transactionReportResponse = new TransactionReport();
                if (dt.Rows.Count > 0)
                {
                    foreach (DataRow row in dt.Rows)
                    {

                        transactionReportResponse.IsDuplicate = false;
                        transactionReportResponse.Agent_Name = Convert.ToString(row["Agent_Name"]);
                        transactionReportResponse.Agent_Add = Convert.ToString(row["Agent_Add"]);
                        transactionReportResponse.Ph = Convert.ToString(row["Ph"]);
                        transactionReportResponse.Fax = Convert.ToString(row["Fax"]);
                        transactionReportResponse.AgentBranch_Email = Convert.ToString(row["AgentBranch_Email"]);
                        transactionReportResponse.Reference_No = Convert.ToString(row["Reference_No"]);
                        transactionReportResponse.Random_No = Convert.ToString(row["Random_No"]);
                        transactionReportResponse.App_No = Convert.ToString(row["App_No"]);
                        transactionReportResponse.PurposeOfTransfer_Name = Convert.ToString(row["PurposeOfTransfer_Name"]);
                        transactionReportResponse.RemitterName = Convert.ToString(row["RemitterName"]);
                        transactionReportResponse.RemitterContactNo = Convert.ToString(row["RemitterContactNo"]);
                        transactionReportResponse.RemitterAddress = Convert.ToString(row["RemitterAddress"]);
                        transactionReportResponse.RemitterOther = Convert.ToString(row["RemitterOther"]);
                        transactionReportResponse.BeneficiaryName = Convert.ToString(row["BeneficiaryName"]);
                        transactionReportResponse.BeneficiaryAddress = Convert.ToString(row["BeneficiaryAddress"]);
                        transactionReportResponse.BeneficiaryContactNo = Convert.ToString(row["BeneficiaryContactNo"]);
                        transactionReportResponse.BeneficiaryMessage = Convert.ToString(row["BeneficiaryMessage"]);
                        transactionReportResponse.PayOutAgentName = Convert.ToString(row["PayOutAgentName"]);
                        transactionReportResponse.PayOutAgentAddress = Convert.ToString(row["PayOutAgentAddress"]);
                        transactionReportResponse.PayOutPhone = Convert.ToString(row["PayOutPhone"]);
                        transactionReportResponse.PayOutMessage = Convert.ToString(row["PayOutMessage"]);
                        if (!string.IsNullOrEmpty(Convert.ToString(row["LocalCurrency"])))
                        {
                            transactionReportResponse.LocalCurrency = Convert.ToDecimal(row["LocalCurrency"]);
                        }
                        else
                        {
                            transactionReportResponse.LocalCurrency = null;
                        }
                        if (!string.IsNullOrEmpty(Convert.ToString(row["ForeignCurrency"])))
                        {
                            transactionReportResponse.ForeignCurrency = Convert.ToDecimal(row["ForeignCurrency"]);
                        }
                        else
                        {
                            transactionReportResponse.ForeignCurrency = null;
                        }
                        if (!string.IsNullOrEmpty(Convert.ToString(row["CommissionCharge"])))
                        {
                            transactionReportResponse.CommissionCharge = Convert.ToDecimal(row["CommissionCharge"]);
                        }
                        else
                        {
                            transactionReportResponse.CommissionCharge = null;
                        }
                        if (!string.IsNullOrEmpty(Convert.ToString(row["VATAmount"])))
                        {
                            transactionReportResponse.VATAmount = Convert.ToDecimal(row["VATAmount"]);
                        }
                        else
                        {
                            transactionReportResponse.VATAmount = null;
                        }
                        transactionReportResponse.VATPerentage = Convert.ToString(row["VATPerentage"]);
                        if (!string.IsNullOrEmpty(Convert.ToString(row["ExchangeRate"])))
                        {
                            transactionReportResponse.ExchangeRate = Convert.ToDecimal(row["ExchangeRate"]);
                        }
                        else
                        {
                            transactionReportResponse.ExchangeRate = null;
                        }
                        if (!string.IsNullOrEmpty(Convert.ToString(row["TotalPayable"])))
                        {
                            transactionReportResponse.TotalPayable = Convert.ToDecimal(row["TotalPayable"]);
                        }
                        else
                        {
                            transactionReportResponse.TotalPayable = null;
                        }
                        transactionReportResponse.Tr_Display = Convert.ToString(row["Tr_Display"]);
                        transactionReportResponse.TrDate = Convert.ToString(row["TrDate"]);
                        transactionReportResponse.PayInCurrency = Convert.ToString(row["PayInCurrency"]);
                        transactionReportResponse.PayOutCurrency = Convert.ToString(row["PayOutCurrency"]);
                        if (!string.IsNullOrEmpty(Convert.ToString(row["TrTypeID"])))
                        {
                            transactionReportResponse.TrTypeID = Convert.ToInt32(row["TrTypeID"]);
                        }
                        else
                        {
                            transactionReportResponse.TrTypeID = null;
                        }
                        transactionReportResponse.ShortName = Convert.ToString(row["ShortName"]);
                        if (!string.IsNullOrEmpty(Convert.ToString(row["AgentLC_Amount"])))
                        {
                            transactionReportResponse.AgentLC_Amount = Convert.ToDecimal(row["AgentLC_Amount"]);
                        }
                        else
                        {
                            transactionReportResponse.AgentLC_Amount = null;
                        }
                        transactionReportResponse.BankName = Convert.ToString(row["BankName"]);
                        transactionReportResponse.BankAccountNo = Convert.ToString(row["BankAccountNo"]);
                        transactionReportResponse.BankBranch = Convert.ToString(row["BankBranch"]);
                        transactionReportResponse.BankAddress = Convert.ToString(row["BankAddress"]);
                        transactionReportResponse.BankCode = Convert.ToString(row["BankCode"]);
                        transactionReportResponse.CardNo = Convert.ToString(row["CardNo"]);
                        if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutAgent"])))
                        {
                            transactionReportResponse.PayOutAgent = Convert.ToInt32(row["PayOutAgent"]);
                        }
                        else
                        {
                            transactionReportResponse.PayOutAgent = null;
                        }
                        if (!string.IsNullOrEmpty(Convert.ToString(row["PayInCountry"])))
                        {
                            transactionReportResponse.PayInCountry = Convert.ToInt32(row["PayInCountry"]);
                        }
                        else
                        {
                            transactionReportResponse.PayInCountry = null;
                        }
                        if (!string.IsNullOrEmpty(Convert.ToString(row["PayInAgent"])))
                        {
                            transactionReportResponse.PayInAgent = Convert.ToInt32(row["PayInAgent"]);
                        }
                        else
                        {
                            transactionReportResponse.PayInAgent = null;
                        }
                        transactionReportResponse.EnteredBy = Convert.ToString(row["EnteredBy"]);
                        transactionReportResponse.CustomerEmail = Convert.ToString(row["CustomerEmail"]);
                        transactionReportResponse.MembershipType = Convert.ToString(row["MembershipType"]);
                        if (!string.IsNullOrEmpty(Convert.ToString(row["PayOutCountry"])))
                        {
                            transactionReportResponse.PayOutCountry = Convert.ToInt32(row["PayOutCountry"]);
                        }
                        else
                        {
                            transactionReportResponse.PayOutCountry = null;
                        }
                        transactionReportResponse.StudentName = Convert.ToString(row["StudentName"]);
                        transactionReportResponse.StudentDetails = Convert.ToString(row["StudentDetails"]);

                        lstTransactionReport.Add(transactionReportResponse);

                    }
                }
                else
                {
                    transactionReportResponse.IsDuplicate = true;
                    lstTransactionReport.Add(transactionReportResponse);
                }

                string result = JsonConvert.SerializeObject(lstTransactionReport);
                commonLogDetails.LogToDB("GetTransactionReport", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber}");
                return lstTransactionReport;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetTransactionReport", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }

        }

        public bool CancelPaidTransactionCancel(TransactionCancelPaidRequest transactionCancelPaidRequest)
        {
            try
            {
                int _StatusID = 0;

                TrMaster.GetTrMaster _GetTr = new TrMaster.GetTrMaster(csCommon.GetConnectionString);
                _GetTr.Transaction_No = transactionCancelPaidRequest.TransactionNumber; 
                _GetTr.GetData_ForCancel();
                _StatusID = _GetTr.Data.TrStatusID;

                if (transactionCancelPaidRequest.TrStatusID == 0)
                {
                    // Delete Request
                    csQueryBuilder _query = new csQueryBuilder();
                    _query.TableName = "UpdateStatus_ViewCancelTrxn";
                    _query.QryType = csQueryBuilder.QueryType.Procedure;
                    _query.ProcedureType = csQueryBuilder.ProcType.Select;
                    _query.Add("@TransactionNumber", SqlDbType.NVarChar, transactionCancelPaidRequest.TransactionNumber);
                    _query.Add("@AppID", SqlDbType.NVarChar, transactionCancelPaidRequest.AppID);
                    _query.Add("@StatusID", SqlDbType.Int, "0");
                    _query.Add("@UserID", SqlDbType.Int, transactionCancelPaidRequest.UserID.ToString());
                    _query.Add("@Date", SqlDbType.DateTime, DateTime.Now.ToShortDateString());
                    _query.Add("@Time", SqlDbType.DateTime, DateTime.Now.ToShortTimeString());
                    _query.Run();
                    csDatabase MyDB = new csDatabase(csCommon.ConnectionString);
                    MyDB.ExecuteNonQuery(_query.MyCmd);
                }
                else
                {
                    
                   

                    if (transactionCancelPaidRequest.Remark == null || transactionCancelPaidRequest.Remark == "")
                    {
                        transactionCancelPaidRequest.Remark = "Transaction Cancellation Requested";
                    }

                    csQueryBuilder _Query = new csQueryBuilder();
                    _Query.TableName = "spCancellation_MakerChecker";
                    _Query.QryType = csQueryBuilder.QueryType.Procedure;
                    _Query.ViewType = csQueryBuilder.VType.Process;
                    _Query.ProcedureType = csQueryBuilder.ProcType.Insert;
                    _Query.Add("@TransactionNumber", SqlDbType.NVarChar, transactionCancelPaidRequest.TransactionNumber);
                    _Query.Add("@TrStatusID", SqlDbType.Int, transactionCancelPaidRequest.TrStatusID.ToString());
                    _Query.Add("@UserID", SqlDbType.NVarChar, transactionCancelPaidRequest.UserID);
                    _Query.Add("@Remark", SqlDbType.NVarChar, transactionCancelPaidRequest.Remark);
                    _Query.Run();

                    csDatabase _MyDB = new csDatabase(csCommon.ConnectionString);
                    _MyDB.ExecuteNonQuery(_Query.MyCmd);

                }

                commonLogDetails.LogToDB("CancelPaidTransactionCancel", "N/A", "Success", "True", $"TransactionNumber: {transactionCancelPaidRequest.TransactionNumber},TransactionNumber: {transactionCancelPaidRequest.TrStatusID}");
                return true;
            }
            catch(Exception ex)
            {
                commonLogDetails.LogToDB("CancelPaidTransactionCancel", "N/A", ex.ToString(), "Flase", $"TransactionNumber: {transactionCancelPaidRequest.TransactionNumber},TransactionNumber: {transactionCancelPaidRequest.TrStatusID}");
                throw ex;
            }
        }
    }
}