﻿using MainRemit;
using MyDatabase;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Request;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using static MainRemit.Transaction.WebService;

namespace SAIB_Web_Api.BusinessManager
{
    public class TrnCancelRequestManager
    {
        DAL dal = new DAL();
        CommonLogDetails commonLogDetails = new CommonLogDetails();
        public bool chkTrxnType(string TrxnNo)
        {
            bool isMGTrxn = false;
            string _trxnPrifix = string.Empty;

            try
            {
                isMGTrxn = dal.GetComplianceManagementTxnPrefix(TrxnNo);
                commonLogDetails.LogToDB("chkTrxnType", "N/A", "Success", "True", $"TransactionNumber: {TrxnNo}");
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("chkTrxnType", "N/A", ex.Message, "Flase", $"TransactionNumber: {TrxnNo}");
                throw new Exception("Error: " + ex.Message);
            }

            return isMGTrxn;
        }
                

        public bool ValidUser(int UserGroup_Id, int UserGroup)
        {
            
            //=====Here UserGroup_Id and UserGroup are assigned values=====//

            if ((UserGroup_Id == 1 && UserGroup == 1) ||
                (UserGroup_Id == 7 && UserGroup == 1) ||
                (UserGroup_Id == 3 && UserGroup == 1) ||
                (UserGroup_Id == 3 && (uint)UserGroup == 8) ||
                (UserGroup_Id == 3 && (uint)UserGroup == 10) ||
                (UserGroup_Id == 2 && (uint)UserGroup == 8) ||
                (UserGroup_Id == 2 && (uint)UserGroup == 10))
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        public bool UpdateCancelTransactionStatus(TrnCancelRequest_Request trnCancelprop)
        {
            try
            {

                bool validUser = ValidUser(trnCancelprop.UserGroup, trnCancelprop.SubUserGroup_Id);

                Boolean trxnType = chkTrxnType(trnCancelprop.SRTRNo);

                if (trxnType == false)
                {
                    if (validUser)
                    {
                        CancelRequest _Cancel = new CancelRequest(trnCancelprop.SRTRNo, trnCancelprop.txtRemarks, trnCancelprop.UserID.ToString(),
                        validUser, trnCancelprop.UserGroup, trnCancelprop.Agent_Branch_ID, trnCancelprop.SubUserGroup_Id, csCommon.ConnectionString);
                        bool IsSuccess = _Cancel.Request();
                        if (IsSuccess)
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else
                    {
                        throw new Exception("Only Sending agent and Back Office user is authorized to send the cancellation request.");
                    }
                }
                else
                {
                    Boolean isCanceled = Mg_Cancel_Trxn(trnCancelprop.SRTRNo, trnCancelprop.TrStatusID, trnCancelprop.txtRemarks, trnCancelprop.UserID);

                    trnCancelprop.SRTRNo = "";
                    trnCancelprop.txtRemarks = "";

                    if (isCanceled == true)
                    {

                        throw new Exception("Cancellation request for Transactio No. " + trnCancelprop.SRTRNo + " has been processed.");

                    }
                }

                commonLogDetails.LogToDB("UpdateCancelTransactionStatus", "N/A", "Success", "True", $"TransactionNumber: {trnCancelprop.SRTRNo},UserGroup:{trnCancelprop.UserGroup}, SubUserGroup_Id: {trnCancelprop.SubUserGroup_Id}");
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("UpdateCancelTransactionStatus", "N/A", ex.Message, "Flase", $"TransactionNumber: {trnCancelprop.SRTRNo}");
                throw new Exception("Unexpected error: "+ ex.Message);
            }
            return true;
        }


        public Boolean Mg_Cancel_Trxn(string Trxn, int TrStatusID, string txtRemarks, int UserID)
        {
            Boolean isCrossCheck = false;
            Boolean isCancelReq = false;

            try
            {
                isCrossCheck = MG_CrossCheckTransaction(Trxn);

                if (isCrossCheck == true)
                {
                    using (SqlConnection con = new SqlConnection(csCommon.ConnectionString))
                    {
                        using (SqlCommand cmd = new SqlCommand("sp_MG_CancelRequest"))
                        {
                            cmd.Connection = con;
                            cmd.CommandType = CommandType.StoredProcedure;
                            cmd.Parameters.AddWithValue("@ViewType", 0);
                            cmd.Parameters.AddWithValue("@ProcedureType", 2);
                            cmd.Parameters.AddWithValue("@TransactionNumber", Trxn);
                            cmd.Parameters.AddWithValue("@ReqStatus", TrStatusID);
                            cmd.Parameters.AddWithValue("@Remarks", txtRemarks);
                            cmd.Parameters.AddWithValue("@RequestedBy", UserID);

                            con.Open();
                            cmd.ExecuteNonQuery();
                            con.Close();
                        }
                    }

                    isCancelReq = true;
                }

                commonLogDetails.LogToDB("Mg_Cancel_Trxn", "N/A", "Success", "True", $"TransactionNumber: {Trxn},TrStatusID:{TrStatusID}, txtRemarks: {txtRemarks},UserID:{UserID}");
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("Mg_Cancel_Trxn", "N/A", ex.Message , "Flase", $"TransactionNumber: {Trxn},TrStatusID:{TrStatusID}, txtRemarks: {txtRemarks},UserID:{UserID}");
                throw new Exception("Error: " + ex.Message);
            }

            return isCancelReq;
        }


        public Boolean MG_CrossCheckTransaction(string Trxn)
        {
            bool _output = false;
            try
            {
                //Cross_Check_Transaction_Status
                using (SqlConnection con = new SqlConnection(csCommon.ConnectionString))
                {
                    using (SqlCommand cmd = new SqlCommand("sp_MG_CrossCheck_CancelRequest_Status"))
                    {
                        cmd.Connection = con;
                        cmd.CommandType = CommandType.StoredProcedure;
                        cmd.Parameters.AddWithValue("@ViewType", 0);
                        cmd.Parameters.AddWithValue("@ProcedureType", 0);
                        cmd.Parameters.AddWithValue("@TransactionNumber", Trxn);

                        con.Open();
                        cmd.ExecuteNonQuery();
                        con.Close();

                        _output = true;
                    }
                }

                commonLogDetails.LogToDB("MG_CrossCheckTransaction", "N/A", "Success", "True", $"TransactionNumber: {Trxn}");
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("MG_CrossCheckTransaction", "N/A", "Unexpected error: Agent data not found." + ex.Message, "Flase", $"TransactionNumber: {Trxn}");
                throw new Exception("Unexpected error: Agent data not found." + ex.Message);
            }
            return _output;
        }
                

        public class CancelRequest
        {
            string _ConnectionString = string.Empty;
            string _TransactionNumber = string.Empty;
            string _Remark = string.Empty;
            string _UserId = string.Empty;
            int _Agent_ID = 0;
            int _Agent_Branch_ID = 0;
            int _UserGroup = 0;
            int _Group_Id = 0;
            int _SubUserGroup_Id = 0;
            bool _IsHO = false;
            bool _IsValidUser = false;            

            public CancelRequest(string TransactionNumber, string Remark, string UserId, bool IsValidUser, 
                                    int UserGroup, int Agent_Branch_ID, int SubUserGroup_Id, string ConnectionString)
            {
                _ConnectionString = ConnectionString;
                _TransactionNumber = TransactionNumber;
                _Remark = Remark;
                _UserId = UserId;
                _IsValidUser = IsValidUser;
                _UserGroup = UserGroup;
                _Agent_Branch_ID = Agent_Branch_ID;
                _SubUserGroup_Id = SubUserGroup_Id;
            }

            public bool Request()
            {
                bool _output = false;
                int _PayOutAgent = 0;
                bool _IsPartnerServiceSuccess = false;
                DataTable _MyDT = new DataTable();
                csQueryBuilder _query;
                csDatabase MyDB;
                try
                {
                    //int _Agent = 0;
                    string _UserName = string.Empty;
                    if (_IsValidUser && _UserGroup == 1)
                    {
                        _query = new csQueryBuilder();
                        _query.TableName = "spUserDetails_CancelRequest";
                        _query.QryType = csQueryBuilder.QueryType.Procedure;
                        _query.ProcedureType = csQueryBuilder.ProcType.Select;
                        _query.ViewType = csQueryBuilder.VType.Process;
                        _query.Add("@TransactionNumber", SqlDbType.NVarChar, _TransactionNumber);
                        _query.Run();

                        MyDB = new csDatabase(_ConnectionString);
                        _MyDT = MyDB.Return_DataTable(_query.MyCmd);
                    }
                    else
                    {
                        _query = new csQueryBuilder();
                        _query.TableName = "spUserDetails_CancelRequest";
                        _query.QryType = csQueryBuilder.QueryType.Procedure;
                        _query.ProcedureType = csQueryBuilder.ProcType.Select;
                        _query.ViewType = csQueryBuilder.VType.Process;
                        _query.Add("@TransactionNumber", SqlDbType.NVarChar, _TransactionNumber);
                        _query.Add("@Userid", SqlDbType.NVarChar, _UserId);
                        _query.Add("@BranchID", SqlDbType.NVarChar, _Agent_Branch_ID.ToString());
                        _query.Run();
                        MyDB = new csDatabase(_ConnectionString);
                        _MyDT = MyDB.Return_DataTable(_query.MyCmd);
                    }

                    if (_MyDT.Rows.Count > 0)
                    {
                        _PayOutAgent = Convert.ToInt32(_MyDT.Rows[0]["RecommendedAgent_ID"].ToString());
                        _UserName = _MyDT.Rows[0]["User_Name"].ToString();
                        _Agent_ID = Convert.ToInt32(_MyDT.Rows[0]["Agent_ID"].ToString());
                        _Agent_Branch_ID = Convert.ToInt32(_MyDT.Rows[0]["Agent_Branch_ID"].ToString());
                        _Group_Id = Convert.ToInt32(_MyDT.Rows[0]["Group_Id"].ToString());
                        _IsHO = Convert.ToBoolean(_MyDT.Rows[0]["IsHO"].ToString());
                    }
                    else
                    {
                        throw new Exception("Transaction not found.");
                    }                    

                    if (CrossCheckTransaction())
                    {

                        try
                        {
                            _IsPartnerServiceSuccess = true;
                            if (_IsPartnerServiceSuccess)
                            {
                                Transaction.TransferTempTable _TempTable =
                                new Transaction.TransferTempTable(_ConnectionString);
                                _TempTable.TransactionNumber = _TransactionNumber;
                                _TempTable.CancelRemark = _Remark;
                                _TempTable.EnteredBy = _UserId;
                                _TempTable.TrDate = DateTime.Now;
                                _TempTable.TrTm = DateTime.Now;
                                _TempTable.UpdateCancelRequestComplete();

                                _output = true;

                                string _Message = "Cancel Request send successfully.";
                                Transaction.TempTableLog _TempTableLog = new Transaction.TempTableLog(_ConnectionString);
                                _TempTableLog.TransactionNumber = _TransactionNumber;
                                _TempTableLog.Code = "604";
                                _TempTableLog.ErrorMessage = _Message;
                                _TempTableLog.Add();
                                _TempTableLog = null;
                            }
                        }
                        catch (Exception ex)
                        {
                            _output = false;
                            throw new Exception("Error: " +ex.Message);
                        }

                    }
                }
                catch (Exception ex)
                {
                    _output = false;
                    string _Message = ex.Message;
                    Transaction.TempTableLog _TempTableLog = new Transaction.TempTableLog(_ConnectionString);
                    _TempTableLog.TransactionNumber = _TransactionNumber;
                    _TempTableLog.Code = "602";
                    _TempTableLog.ErrorMessage = _Message;
                    _TempTableLog.Add();
                    _TempTableLog = null;
                }
                return _output;
            }

            private bool IsValidUser()
            {
                bool _output = false;
                try
                {
                    if (_IsHO)
                    {
                        using (Transaction.TransferTempTable _TempTable =
                        new Transaction.TransferTempTable(_ConnectionString))
                        {
                            _TempTable.TransactionNumber = _TransactionNumber;
                            _TempTable.Agent_ID = _Agent_ID;
                            _output = _TempTable.IsValidAgent();
                        }
                    }
                    else
                    {
                        using (Transaction.TransferTempTable _TempTable =
                        new Transaction.TransferTempTable(_ConnectionString))
                        {
                            _TempTable.TransactionNumber = _TransactionNumber;
                            _TempTable.AgentBranch_ID = _Agent_Branch_ID;
                            _output = _TempTable.IsValidBranch();
                        }
                    }
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
                return _output;
            }

            public bool CrossCheckTransaction()
            {
                bool _output = false;
                try
                {
                    if (IsValidUser())
                    {
                        using (Transaction.TransferTempTable _TempTable = new Transaction.TransferTempTable(_ConnectionString))
                        {
                            _TempTable.TransactionNumber = _TransactionNumber;
                            if (_TempTable.IsAccountingProcessComplete())
                            {
                                csQueryBuilder _query = new csQueryBuilder();
                                _query.TableName = "sp_CrossCheck_CancelRequest_Status";
                                _query.QryType = csQueryBuilder.QueryType.Procedure;
                                _query.ProcedureType = csQueryBuilder.ProcType.Select;
                                _query.ViewType = csQueryBuilder.VType.View;
                                _query.Add("@TransactionNumber", SqlDbType.NVarChar, _TransactionNumber);
                                _query.Run();

                                try
                                {
                                    csDatabase MyDB = new csDatabase(_ConnectionString);
                                    DataSet MyDS = MyDB.Return_DataSet(_query.MyCmd);
                                    _output = true;
                                }
                                catch (Exception ex)
                                {
                                    throw new Exception("Error: " + ex.Message); 
                                }
                            }
                            else
                            {
                                _output = true;
                            }
                        }
                    }
                    else
                    {                        
                        throw new Exception("Transaction not found");
                    }
                }
                catch (Exception ex)
                {
                    throw new Exception("Error: " + ex.Message);
                }
                return _output;
            }

            public bool IsCancelReqSendToSR1(int AgentID)
            {
                bool _output = false;
                try
                {
                    csQueryBuilder _query = new csQueryBuilder();
                    _query.TableName = "spIsCancelReqSendToSR1";
                    _query.QryType = csQueryBuilder.QueryType.Procedure;
                    _query.ProcedureType = csQueryBuilder.ProcType.Select;
                    _query.ViewType = csQueryBuilder.VType.View;
                    _query.Add("@AgentID", SqlDbType.Int, AgentID.ToString());
                    _query.Run();

                    MyDatabase.csDatabase MyDB = new csDatabase(_ConnectionString);
                    string _value = MyDB.Return_SingleField(_query.MyCmd, "IsCancelReqSendToSR1");

                    _output = (string.IsNullOrEmpty(_value)) ? false : bool.Parse(_value);
                }
                catch (Exception ex)
                {
                    throw new Exception("Error: " + ex.Message);
                }
                return _output;
            }
           
        }


    }
}