﻿using Newtonsoft.Json;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Request;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace SAIB_Web_Api.BusinessManager
{
    public class TrnViewCancelRequestStatusManager
    {
        DAL dal = new DAL();
        CommonLogDetails commonLogDetails = new CommonLogDetails();

        //===== Agent Country List [frmViewCancelRequestStatus.aspx]======//
        public List<AgentCountryList> GetAgentCountryList(int UserID, int Agent_ID, int Agent_Country_ID)
        {

            DataTable dt = dal.ViewCancelGetCountryList(UserID, Agent_ID, Agent_Country_ID);

            //string str = JsonConvert.SerializeObject(dt);

            List<AgentCountryList> lstddlCountry = new List<AgentCountryList>();

            foreach (DataRow row in dt.Rows)
            {
                AgentCountryList _countryResponse = new AgentCountryList();
                _countryResponse.CountryID = Convert.ToInt32(row["CountryID"]);
                _countryResponse.CountryName = row["CountryName"].ToString();
                lstddlCountry.Add(_countryResponse);
            }

            return lstddlCountry;
        }

        //===== Agent List [frmViewCancelRequestStatus.aspx]======//
        public List<CancelAgentList> GetAgentList(int UserID, int _Country_ID)
        {

            DataTable dt = dal.ViewCancelGetAgentList(UserID, _Country_ID);

            string str = JsonConvert.SerializeObject(dt);

            List<CancelAgentList> lstddlAgents = new List<CancelAgentList>();

            foreach (DataRow row in dt.Rows)
            {
                CancelAgentList _ddlAgentsResponse = new CancelAgentList();
                _ddlAgentsResponse.Agent_ID = Convert.ToInt32(row["Agent_ID"]);
                _ddlAgentsResponse.Agent_Name = row["Agent_Name"].ToString();
                lstddlAgents.Add(_ddlAgentsResponse);
            }

            return lstddlAgents;
        }


        //===== Agent Branch List [frmViewCancelRequestStatus.aspx]======//
        public List<CancelAgentBranchList> GetAgentBranchList(int _ddlAgentsID)
        {

            DataTable dt = dal.ViewCancelGetAgentBranchList(_ddlAgentsID);

            string str = JsonConvert.SerializeObject(dt);

            List<CancelAgentBranchList> lstddlAgentBranch = new List<CancelAgentBranchList>();

            foreach (DataRow row in dt.Rows)
            {
                CancelAgentBranchList _ddlAgentBranchResponse = new CancelAgentBranchList();
                _ddlAgentBranchResponse.ID = Convert.ToInt32(row["ID"]);
                _ddlAgentBranchResponse.Name = row["Name"].ToString();
                lstddlAgentBranch.Add(_ddlAgentBranchResponse);
            }

            return lstddlAgentBranch;
        }


        //===== Search And Fill Grid Record [frmViewCancelRequestStatus.aspx]======//
        public List<FillGridBySearch> GetAllRecordByFilter(SearchProp searchProp)
        {
            DataTable dt = dal.ViewCancelGetSearchResult(searchProp);

            List<FillGridBySearch> lstStopPaymentRequest = new List<FillGridBySearch>();

            foreach (DataRow row in dt.Rows)
            {
                FillGridBySearch trxnStatus = new FillGridBySearch();

                trxnStatus.Agent_Name = row["Agent_Name"].ToString();
                trxnStatus.TransactionNumber = row["TransactionNumber"].ToString();
                trxnStatus.IssueDate = row["IssueDate"].ToString();
                trxnStatus.CurrencyShortName = row["CurrencyShortName"].ToString();
                trxnStatus.CorrespondentBank = row["CorrespondentBank"].ToString();
                trxnStatus.PayoutBank = row["PayoutBank"].ToString();
                trxnStatus.CancelReqBy = row["CancelReqBy"];
                trxnStatus.CancelReqDate = row["CancelReqDate"].ToString();
                trxnStatus.CancelRemark = row["CancelRemark"].ToString();
                trxnStatus.CancelledBy = row["CancelledBy"];
                trxnStatus.CancelDate = row["CancelDate"];
                trxnStatus.CurrentStatus = row["CurrentStatus"].ToString();
                trxnStatus.hLink = row["hLink"].ToString();
                trxnStatus.ObjectVisible = row["ObjectVisible"].ToString();
                trxnStatus.Ex_Branch_ID = Convert.ToInt32(row["Ex_Branch_ID"]);
                trxnStatus.App_ID = row["App_ID"].ToString();
                trxnStatus.Reference_No = row["Reference_No"].ToString();
                trxnStatus.TrStatusID = Convert.ToInt32(row["TrStatusID"]);
                trxnStatus.IsShowRemoveOption = Convert.ToInt32(row["IsShowRemoveOption"]);
                trxnStatus.SendTransAmt = Convert.ToDouble(row["SendTransAmt"]);
                trxnStatus.USDAmount = Convert.ToDouble(row["USDAmount"]);

                lstStopPaymentRequest.Add(trxnStatus);
            }

            return lstStopPaymentRequest;
        }


        //===== Cancel/Delete/Move  Transaction Status in/From GridView [frmViewCancelRequestStatus.aspx]======//
        public void GetCancelTransaction(CancilationProp cancilationProp)
        {
            try
            {
                dal.ViewCancelTrnStatus_Cancel(cancilationProp);

                string result = JsonConvert.SerializeObject(cancilationProp);
                commonLogDetails.LogToDB("GetCancelTransaction", "N/A", "Success", "true", result);
            }
            catch(Exception ex)
            {
                string request = JsonConvert.SerializeObject(cancilationProp);
                commonLogDetails.LogToDB("GetCancelTransaction", "N/A", ex.ToString(), "Flase", request);
                throw ex;
            }
            

            //return true;
        }


        //===== Agent Branch List [frmViewCancelRequestStatus.aspx]======//
        public List<PrintLog> PrintLog(string transaction)
        {

            DataTable dt = dal.PrintLog(transaction);

            string str = JsonConvert.SerializeObject(dt);

            List<PrintLog> lstPrintLog = new List<PrintLog>();

            foreach (DataRow row in dt.Rows)
            {
                PrintLog _printLogResponse = new PrintLog();
                _printLogResponse.LogID = Convert.ToInt32(row["LogID"]);
                _printLogResponse.SRTRNo = row["SRTRNo"].ToString();
                _printLogResponse.ActionName = row["ActionName"].ToString();
                _printLogResponse.SentDate = row["SentDate"].ToString();
                _printLogResponse.PrevValue = row["PrevValue"].ToString();
                _printLogResponse.UpdatedValue = row["UpdatedValue"].ToString();
                _printLogResponse.Remarks = row["Remarks"].ToString();
                _printLogResponse.ActionDate = row["ActionDate"].ToString();
                _printLogResponse.ActionTime = row["ActionTime"].ToString();
                _printLogResponse.ActionBy = row["ActionBy"].ToString();
                lstPrintLog.Add(_printLogResponse);
            }

            return lstPrintLog;
        }

    }
}