﻿using MainRemit;
using MoneyGramService.com.moneygram.extws;
using Newtonsoft.Json;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Request;
using SAIB_Web_Api.Models.Response;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;

namespace SAIB_Web_Api.BusinessManager
{
    public class ViewComplainceHoldListManager
    {
        DAL dal = new DAL();
        string Message = string.Empty;
        CommonLogDetails commonLogDetails = new CommonLogDetails();
        public List<ViewComplainceHoldListResponse> GetViewComplainceHoldListAllRecord(int TopRecords, string TransactionNumber, string Name)
        {

            try
            {
                DataTable dt = dal.GetViewComplainceHoldListAllRecord(TopRecords, TransactionNumber, Name);

                List<ViewComplainceHoldListResponse> lstViewComplainceHoldListResponse = new List<ViewComplainceHoldListResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    ViewComplainceHoldListResponse _viewComplainceHoldListResponse = new ViewComplainceHoldListResponse();
                    _viewComplainceHoldListResponse.Pref = Convert.ToString(row["Pref"]);
                    _viewComplainceHoldListResponse.TransactionNumber = Convert.ToString(row["Transaction Number"]);
                    _viewComplainceHoldListResponse.Status = Convert.ToString(row["Status"]);
                    _viewComplainceHoldListResponse.Date = Convert.ToString(row["Date"]);
                    _viewComplainceHoldListResponse.RemitterName = Convert.ToString(row["Remitter Name"]);
                    _viewComplainceHoldListResponse.BeneficiaryName = Convert.ToString(row["Beneficiary Name"]);
                    _viewComplainceHoldListResponse.Remark = Convert.ToString(row["Remark"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentFC_Amount"])))
                    {
                        _viewComplainceHoldListResponse.AgentFC_Amount = Convert.ToDecimal(row["AgentFC_Amount"]);
                    }
                    else
                    {
                        _viewComplainceHoldListResponse.AgentFC_Amount = null;
                    }
                    if (!string.IsNullOrEmpty(Convert.ToString(row["AgentLC_Amount"])))
                    {
                        _viewComplainceHoldListResponse.AgentLC_Amount = Convert.ToDecimal(row["AgentLC_Amount"]);
                    }
                    else
                    {
                        _viewComplainceHoldListResponse.AgentLC_Amount = null;
                    }
                    _viewComplainceHoldListResponse.hid = Convert.ToString(row["hid"]);
                    _viewComplainceHoldListResponse.hViewLink = Convert.ToString(row["hViewLink"]);
                    _viewComplainceHoldListResponse.Loglink = Convert.ToString(row["Loglink"]);
                    _viewComplainceHoldListResponse.ComplianceReason = Convert.ToString(row["ComplianceReason"]);
                    _viewComplainceHoldListResponse.PurposeOfTransfer = Convert.ToString(row["PurposeOfTransfer"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["SpecifyPOT"])))
                    {
                        _viewComplainceHoldListResponse.SpecifyPOT = Convert.ToInt32(row["SpecifyPOT"]);
                    }
                    else
                    {
                        _viewComplainceHoldListResponse.SpecifyPOT = null;
                    }
                    _viewComplainceHoldListResponse.Hlink = Convert.ToString(row["Hlink"]);
                    _viewComplainceHoldListResponse.AgentName = Convert.ToString(row["AgentName"]);
                    _viewComplainceHoldListResponse.PaymentMode = Convert.ToString(row["PaymentMode"]);

                    lstViewComplainceHoldListResponse.Add(_viewComplainceHoldListResponse);
                }

                string result = JsonConvert.SerializeObject(lstViewComplainceHoldListResponse);
                commonLogDetails.LogToDB("GetViewComplainceHoldListAllRecord", "N/A", "Success", result, $"TopRecords: {TopRecords}, TransactionNumber: {TransactionNumber}, Name: {Name}");

                return lstViewComplainceHoldListResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetViewComplainceHoldListAllRecord", "N/A", ex.ToString(), "No Response", $"TopRecords: {TopRecords}, TransactionNumber: {TransactionNumber}, Name: {Name}");
                throw ex;
            }
        }

        public List<ViewComplainceHoldListViewComplainsesResponse> GetViewComplainceHoldListViewComplaice(string TransactionNumber)
        {

            try
            {
                DataTable dt = dal.GetViewComplainceHoldListViewComplaice(TransactionNumber);

                List<ViewComplainceHoldListViewComplainsesResponse> lstViewComplainceHoldListResponse = new List<ViewComplainceHoldListViewComplainsesResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    ViewComplainceHoldListViewComplainsesResponse _viewComplainceHoldListResponse = new ViewComplainceHoldListViewComplainsesResponse();
                    _viewComplainceHoldListResponse.TransactionNumber = Convert.ToString(row["TransactionNumber"]);
                    _viewComplainceHoldListResponse.Remarks = Convert.ToString(row["Remarks"]);
                    lstViewComplainceHoldListResponse.Add(_viewComplainceHoldListResponse);
                }

                string result = JsonConvert.SerializeObject(lstViewComplainceHoldListResponse);
                commonLogDetails.LogToDB("GetViewComplainceHoldListViewComplaice", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber}");

                return lstViewComplainceHoldListResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetViewComplainceHoldListViewComplaice", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }
        }

        public List<TransactionStatusLog> GetViewComplainceHoldListLog(string TransactionNumber)
        {
            try
            {
                DataTable dt = dal.GetTransactionStatusLog(TransactionNumber);
                List<TransactionStatusLog> lstTransactionStatus = new List<TransactionStatusLog>();

                foreach (DataRow row in dt.Rows)
                {
                    TransactionStatusLog _transactionStatusResponse = new TransactionStatusLog();
                    _transactionStatusResponse.LogID = Convert.ToInt32(row["LogID"]);
                    _transactionStatusResponse.SRTRNo = Convert.ToString(row["SRTRNo"]);
                    _transactionStatusResponse.ActionName = Convert.ToString(row["ActionName"]);
                    _transactionStatusResponse.SentDate = Convert.ToString(row["SentDate"]);
                    _transactionStatusResponse.PrevValue = Convert.ToString(row["PrevValue"]);
                    _transactionStatusResponse.UpdatedValue = Convert.ToString(row["UpdatedValue"]);
                    _transactionStatusResponse.Remarks = Convert.ToString(row["Remarks"]);
                    _transactionStatusResponse.ActionDate = Convert.ToString(row["ActionDate"]);
                    _transactionStatusResponse.ActionTime = Convert.ToString(row["ActionTime"]);
                    _transactionStatusResponse.ActionBy = Convert.ToString(row["ActionBy"]);
                    lstTransactionStatus.Add(_transactionStatusResponse);
                }

                string result = JsonConvert.SerializeObject(lstTransactionStatus);
                commonLogDetails.LogToDB("GetViewComplainceHoldListLog", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber}");

                return lstTransactionStatus;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetViewComplainceHoldListLog", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber}");
                throw ex;
            }
        }

        public List<ViewComplainceHoldListViewDetailResponse> GetViewComplainceHoldListView(string TransactionNumber, string showOFAC)
        {
            try
            {
                Boolean chkTrxnType = dal.GetComplianceManagementTxnPrefix(TransactionNumber);
                DataTable dtRequired = new DataTable();
                DataTable dtView = new DataTable();
                string SelectList = CustomerDetails.SelectList.SRTRNo.ToString();
                List<ViewComplainceHoldListViewDetailResponse> lstViewComplainceHoldListResponse = new List<ViewComplainceHoldListViewDetailResponse>();
                // ViewComplainceHoldListViewDetailResponse _viewComplainceHoldListResponse = new ViewComplainceHoldListViewDetailResponse();
                if (chkTrxnType)
                {

                    dtRequired = dal.GetViewComplainceHoldListGetRequired(TransactionNumber);
                    foreach (DataRow row in dtRequired.Rows)
                    {
                        ViewComplainceHoldListGetRequiredResponse ViewComplainceHoldListGetRequiredResponse = new ViewComplainceHoldListGetRequiredResponse
                        {
                            RemIDName = Convert.ToString(row["RemIDName"]),
                            RemNatIDName = Convert.ToString(row["RemNatIDName"]),
                            BenNatIDName = Convert.ToString(row["BenNatIDName"]),
                            BenCustName = Convert.ToString(row["BenCustName"]),
                            OrgMsgID = Convert.ToString(row["OrgMsgID"]),
                            PreviousRemark = Convert.ToString(row["PreviousRemark"]),
                            ISCustInCompliance = Convert.ToString(row["ISCustInCompliance"]),
                            IsBenInCompliance = Convert.ToString(row["IsBenInCompliance"]),
                            ISCustApprove = Convert.ToString(row["ISCustApprove"]),
                            IsBenApprove = Convert.ToString(row["IsBenApprove"]),
                            CustNumber = Convert.ToString(row["CustNumber"]),
                            BenNo = Convert.ToString(row["BenNo"]),
                            CustRemark = Convert.ToString(row["CustRemark"]),
                            BenRemark = Convert.ToString(row["BenRemark"]),
                            IsMGTxn = Convert.ToString(row["IsMGTxn"]),
                            TxnTime = Convert.ToString(row["TxnTime"]),
                            MGWaitMin = Convert.ToString(row["MGWaitMin"]),
                            TRPayMode = Convert.ToString(row["TRPayMode"]),
                            IsMTOSuccess = Convert.ToString(row["IsMTOSuccess"]),
                            PartnerCode = Convert.ToString(row["PartnerCode"]),
                            CustType = Convert.ToString(row["CustType"]),

                        };
                        ViewComplainceHoldListViewDetailResponse _viewComplainceHoldListResponse = new ViewComplainceHoldListViewDetailResponse
                        {
                            ViewComplainceHoldListGetRequiredResponse = new List<ViewComplainceHoldListGetRequiredResponse> { ViewComplainceHoldListGetRequiredResponse },
                            ViewComplainceHoldListViewResponse = new List<ViewComplainceHoldListViewResponse>()
                        };

                        lstViewComplainceHoldListResponse.Add(_viewComplainceHoldListResponse);
                    }

                    dtView = dal.GetViewComplainceHoldListView(TransactionNumber);
                    foreach (DataRow row in dtView.Rows)
                    {
                        ViewComplainceHoldListViewResponse ViewComplainceHoldListViewResponse = new ViewComplainceHoldListViewResponse
                        {
                            TransactionNumber = Convert.ToString(row["TransactionNumber"]),
                            MemberShipID = Convert.ToString(row["MemberShipID"]),
                            Customer_Name_F = Convert.ToString(row["Customer_Name_F"]),
                            Customer_Name_M = Convert.ToString(row["Customer_Name_M"]),
                            Customer_Name_L = Convert.ToString(row["Customer_Name_L"]),
                            Customer_Address = Convert.ToString(row["Customer_Address"]),
                            Customer_Mobile = Convert.ToString(row["Customer_Mobile"]),
                            Customer_Phone = Convert.ToString(row["Customer_Phone"]),
                            Customer_NationalityID = Convert.ToString(row["Customer_NationalityID"]),
                            Customer_Relation = Convert.ToString(row["Customer_Relation"]),
                            Customer_DOB = Convert.ToString(row["Customer_DOB"]),
                            Customer_PlaceofBirth = Convert.ToString(row["Customer_PlaceofBirth"]),
                            Beneficiary_Name_F = Convert.ToString(row["Beneficiary_Name_F"]),
                            Beneficiary_Name_M = Convert.ToString(row["Beneficiary_Name_M"]),
                            Beneficiary_Name_L = Convert.ToString(row["Beneficiary_Name_L"]),
                            Beneficiary_Address = Convert.ToString(row["Beneficiary_Address"]),
                            Beneficiary_LandMark = Convert.ToString(row["Beneficiary_LandMark"]),
                            Beneficiary_ZipCode = Convert.ToString(row["Beneficiary_ZipCode"]),
                            Beneficiary_Mobile = Convert.ToString(row["Beneficiary_Mobile"]),
                            Beneficiary_Phone = Convert.ToString(row["Beneficiary_Phone"]),
                            Beneficiary_NationalityID = Convert.ToString(row["Beneficiary_NationalityID"]),
                            Beneficiary_MessageToBen = Convert.ToString(row["Beneficiary_MessageToBen"]),
                            Beneficiary_MessageToAgent = Convert.ToString(row["Beneficiary_MessageToAgent"]),
                            ModeOfPayment_ID = Convert.ToString(row["ModeOfPayment_ID"]),
                            PayInCountry = Convert.ToString(row["PayInCountry"]),
                            PayInCurrency = Convert.ToString(row["PayInCurrency"]),
                            SCCY = Convert.ToString(row["SCCY"]),
                            SendAgent = Convert.ToString(row["SendAgent"]),
                            PayOutCountry = Convert.ToString(row["PayOutCountry"]),
                            PayOutCurrency = Convert.ToString(row["PayOutCurrency"]),
                            DCCY = Convert.ToString(row["DCCY"]),
                            DCountry = Convert.ToString(row["DCountry"]),
                            RecommendedAgent_ID = Convert.ToString(row["RecommendedAgent_ID"]),
                            TrTypeID = Convert.ToString(row["TrTypeID"]),
                            DMode = Convert.ToString(row["DMode"]),
                            DCity = Convert.ToString(row["DCity"]),
                            DLocation = Convert.ToString(row["DLocation"]),
                            DAgent = Convert.ToString(row["DAgent"]),
                            AgentAdd = Convert.ToString(row["AgentAdd"]),
                            DPurpose = Convert.ToString(row["DPurpose"]),
                            PurposeSpecify = Convert.ToString(row["PurposeSpecify"]),
                            AgentRate = Convert.ToString(row["AgentRate"]),
                            AgentLC_Amount = Convert.ToString(row["AgentLC_Amount"]),
                            AgentFC_Amount = Convert.ToString(row["AgentFC_Amount"]),
                            BaseToBaseCommissionAmount = Convert.ToString(row["BaseToBaseCommissionAmount"]),
                            IDNumber = Convert.ToString(row["IDNumber"]),
                            IDExpDt = Convert.ToString(row["IDExpDt"]),
                            TrDate = Convert.ToString(row["TrDate"]),
                            ManualSuspected = Convert.ToString(row["ManualSuspected"]),
                            IsArebic = Convert.ToString(row["IsArebic"]),
                            CourierAddress = Convert.ToString(row["CourierAddress"]),
                            CourierRemark = Convert.ToString(row["CourierRemark"]),
                            BankBranch = Convert.ToString(row["BankBranch"]),
                            BankAddress = Convert.ToString(row["BankAddress"]),
                            BankName = Convert.ToString(row["BankName"]),
                            BankAccountNo = Convert.ToString(row["BankAccountNo"]),
                            BankCode = Convert.ToString(row["BankCode"]),
                        };

                        if (lstViewComplainceHoldListResponse.Count > 0)
                        {
                            lstViewComplainceHoldListResponse[lstViewComplainceHoldListResponse.Count - 1].ViewComplainceHoldListViewResponse.Add(ViewComplainceHoldListViewResponse);
                        }
                    }


                }
                else
                {
                    Transaction.TransferTempTable.PreviousTransactions _PreviousTransactions =
                    new Transaction.TransferTempTable.PreviousTransactions(SelectList, TransactionNumber
                    , csCommon.GetConnectionString);
                    _PreviousTransactions.Search();

                    if (_PreviousTransactions.ViewPreviousTransaction.Tables[0].Rows.Count == 1)
                    {
                        dtRequired = dal.GetViewComplainceHoldListGetRequired(TransactionNumber);
                        foreach (DataRow row in dtRequired.Rows)
                        {
                            ViewComplainceHoldListGetRequiredResponse ViewComplainceHoldListGetRequiredResponse = new ViewComplainceHoldListGetRequiredResponse
                            {
                                RemIDName = Convert.ToString(row["RemIDName"]),
                                RemNatIDName = Convert.ToString(row["RemNatIDName"]),
                                BenNatIDName = Convert.ToString(row["BenNatIDName"]),
                                BenCustName = Convert.ToString(row["BenCustName"]),
                                OrgMsgID = Convert.ToString(row["OrgMsgID"]),
                                PreviousRemark = Convert.ToString(row["PreviousRemark"]),
                                ISCustInCompliance = Convert.ToString(row["ISCustInCompliance"]),
                                IsBenInCompliance = Convert.ToString(row["IsBenInCompliance"]),
                                ISCustApprove = Convert.ToString(row["ISCustApprove"]),
                                IsBenApprove = Convert.ToString(row["IsBenApprove"]),
                                CustNumber = Convert.ToString(row["CustNumber"]),
                                BenNo = Convert.ToString(row["BenNo"]),
                                CustRemark = Convert.ToString(row["CustRemark"]),
                                BenRemark = Convert.ToString(row["BenRemark"]),
                                IsMGTxn = Convert.ToString(row["IsMGTxn"]),
                                TxnTime = Convert.ToString(row["TxnTime"]),
                                MGWaitMin = Convert.ToString(row["MGWaitMin"]),
                                TRPayMode = Convert.ToString(row["TRPayMode"]),
                                IsMTOSuccess = Convert.ToString(row["IsMTOSuccess"]),
                                PartnerCode = Convert.ToString(row["PartnerCode"]),
                                CustType = Convert.ToString(row["CustType"]),

                            };
                            ViewComplainceHoldListViewDetailResponse _viewComplainceHoldListResponse = new ViewComplainceHoldListViewDetailResponse
                            {
                                ViewComplainceHoldListGetRequiredResponse = new List<ViewComplainceHoldListGetRequiredResponse> { ViewComplainceHoldListGetRequiredResponse },
                                ViewComplainceHoldListViewResponse = new List<ViewComplainceHoldListViewResponse>()
                            };

                            lstViewComplainceHoldListResponse.Add(_viewComplainceHoldListResponse);
                        }

                        DataRow _Record = _PreviousTransactions.ViewPreviousTransaction.Tables[0].Rows[0];
                        if (_Record != null)
                        {
                            ViewComplainceHoldListViewResponse ViewComplainceHoldListViewResponse = new ViewComplainceHoldListViewResponse
                            {
                                TransactionNumber = Convert.ToString(_Record["TransactionNumber"]),
                                MemberShipID = Convert.ToString(_Record["MemberShipID"]),
                                Customer_Name_F = Convert.ToString(_Record["Customer_Name_F"]),
                                Customer_Name_M = Convert.ToString(_Record["Customer_Name_M"]),
                                Customer_Name_L = Convert.ToString(_Record["Customer_Name_L"]),
                                Customer_Address = Convert.ToString(_Record["Customer_Address"]),
                                Customer_Mobile = Convert.ToString(_Record["Customer_Mobile"]),
                                Customer_Phone = Convert.ToString(_Record["Customer_Phone"]),
                                Customer_NationalityID = Convert.ToString(_Record["Customer_NationalityID"]),
                                Customer_Relation = Convert.ToString(_Record["Customer_Relation"]),
                                Customer_DOB = Convert.ToString(_Record["Customer_DOB"]),
                                Customer_PlaceofBirth = Convert.ToString(_Record["Customer_PlaceofBirth"]),
                                Beneficiary_Name_F = Convert.ToString(_Record["Beneficiary_Name_F"]),
                                Beneficiary_Name_M = Convert.ToString(_Record["Beneficiary_Name_M"]),
                                Beneficiary_Name_L = Convert.ToString(_Record["Beneficiary_Name_L"]),
                                Beneficiary_Address = Convert.ToString(_Record["Beneficiary_Address"]),
                                Beneficiary_LandMark = Convert.ToString(_Record["Beneficiary_LandMark"]),
                                Beneficiary_ZipCode = Convert.ToString(_Record["Beneficiary_ZipCode"]),
                                Beneficiary_Mobile = Convert.ToString(_Record["Beneficiary_Mobile"]),
                                Beneficiary_Phone = Convert.ToString(_Record["Beneficiary_Phone"]),
                                Beneficiary_NationalityID = Convert.ToString(_Record["Beneficiary_NationalityID"]),
                                Beneficiary_MessageToBen = Convert.ToString(_Record["Beneficiary_MessageToBen"]),
                                Beneficiary_MessageToAgent = Convert.ToString(_Record["Beneficiary_MessageToAgent"]),
                                ModeOfPayment_ID = Convert.ToString(_Record["ModeOfPayment_ID"]),
                                PayInCountry = Convert.ToString(_Record["PayInCountry"]),
                                PayInCurrency = Convert.ToString(_Record["PayInCurrency"]),
                                SCCY = Convert.ToString(_Record["SCCY"]),
                                SendAgent = Convert.ToString(_Record["SendAgent"]),
                                PayOutCountry = Convert.ToString(_Record["PayOutCountry"]),
                                PayOutCurrency = Convert.ToString(_Record["PayOutCurrency"]),
                                DCCY = Convert.ToString(_Record["DCCY"]),
                                DCountry = Convert.ToString(_Record["DCountry"]),
                                RecommendedAgent_ID = Convert.ToString(_Record["RecommendedAgent_ID"]),
                                TrTypeID = Convert.ToString(_Record["TrTypeID"]),
                                DMode = Convert.ToString(_Record["DMode"]),
                                DCity = Convert.ToString(_Record["DCity"]),
                                DLocation = Convert.ToString(_Record["DLocation"]),
                                DAgent = Convert.ToString(_Record["DAgent"]),
                                AgentAdd = Convert.ToString(_Record["AgentAdd"]),
                                DPurpose = Convert.ToString(_Record["DPurpose"]),
                                PurposeSpecify = Convert.ToString(_Record["PurposeSpecify"]),
                                AgentRate = Convert.ToString(_Record["AgentRate"]),
                                AgentLC_Amount = Convert.ToString(_Record["AgentLC_Amount"]),
                                AgentFC_Amount = Convert.ToString(_Record["AgentFC_Amount"]),
                                BaseToBaseCommissionAmount = Convert.ToString(_Record["BaseToBaseCommissionAmount"]),
                                IDNumber = Convert.ToString(_Record["IDNumber"]),
                                IDExpDt = Convert.ToString(_Record["IDExpDt"]),
                                TrDate = Convert.ToString(_Record["TrDate"]),
                                ManualSuspected = Convert.ToString(_Record["ManualSuspected"]),
                                IsArebic = Convert.ToString(_Record["IsArebic"]),
                                CourierAddress = Convert.ToString(_Record["CourierAddress"]),
                                CourierRemark = Convert.ToString(_Record["CourierRemark"]),
                                BankBranch = Convert.ToString(_Record["BankBranch"]),
                                BankAddress = Convert.ToString(_Record["BankAddress"]),
                                BankName = Convert.ToString(_Record["BankName"]),
                                BankAccountNo = Convert.ToString(_Record["BankAccountNo"]),
                                BankCode = Convert.ToString(_Record["BankCode"]),
                            };
                            if (lstViewComplainceHoldListResponse.Count > 0)
                            {
                                lstViewComplainceHoldListResponse[lstViewComplainceHoldListResponse.Count - 1].ViewComplainceHoldListViewResponse.Add(ViewComplainceHoldListViewResponse);
                            }
                        }

                    }
                }

                string result = JsonConvert.SerializeObject(lstViewComplainceHoldListResponse);
                commonLogDetails.LogToDB("GetViewComplainceHoldListView", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber},showOFAC:{showOFAC}");
                return lstViewComplainceHoldListResponse;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetViewComplainceHoldListView", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber},showOFAC:{showOFAC}");
                throw ex;
            }
        }

        public List<ComplianceManagementView_ShowDetail> GetViewComplainceHoldListShowDetail(string TransactionNumber, string SearchType)
        {
            try
            {
                List<ComplianceManagementView_ShowDetail> lstcomplianceView_ComplianceShowDetail = new List<ComplianceManagementView_ShowDetail>();
                DataTable dt = dal.GetComplianceManagementView_ComplianceShowDetail(TransactionNumber, SearchType);
                string str = JsonConvert.SerializeObject(dt);

                foreach (DataRow row in dt.Rows)
                {
                    ComplianceManagementView_ShowDetail _complianceView_ComplianceShowDetail = new ComplianceManagementView_ShowDetail();
                    _complianceView_ComplianceShowDetail.UID = Convert.ToString(row["UID"]);
                    _complianceView_ComplianceShowDetail.Remark = Convert.ToString(row["Remark"]);
                    if (!string.IsNullOrEmpty(Convert.ToString(row["Per"])))
                    {
                        _complianceView_ComplianceShowDetail.Per = Convert.ToDecimal(row["Per"]);
                    }
                    else
                    {
                        _complianceView_ComplianceShowDetail.Per = null;
                    }
                    _complianceView_ComplianceShowDetail.Name = Convert.ToString(row["Name"]);
                    _complianceView_ComplianceShowDetail.Aliases = Convert.ToString(row["Aliases"]);
                    _complianceView_ComplianceShowDetail.Remarks = Convert.ToString(row["Remarks"]);
                    _complianceView_ComplianceShowDetail.Address = Convert.ToString(row["Address"]);
                    lstcomplianceView_ComplianceShowDetail.Add(_complianceView_ComplianceShowDetail);
                }

                string result = JsonConvert.SerializeObject(lstcomplianceView_ComplianceShowDetail);
                commonLogDetails.LogToDB("GetViewComplainceHoldListShowDetail", "N/A", "Success", result, $"TransactionNumber: {TransactionNumber},SearchType:{SearchType}");

                return lstcomplianceView_ComplianceShowDetail;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetViewComplainceHoldListShowDetail", "N/A", ex.ToString(), "No Response", $"TransactionNumber: {TransactionNumber},SearchType:{SearchType}");
                throw ex;
            }
        }

        public List<RejectResponse> Reject(viewComplainceHoldListRequest viewComplainceHoldListRequest)
        {
            try
            {
                List<RejectResponse> lstcomplianceView_Reject = new List<RejectResponse>();
                RejectResponse _complianceView_Reject = new RejectResponse();
                string TransNo = viewComplainceHoldListRequest.TransactionNumber;
                // string _strSuccessFlag = "0";
                string IsMGCancel = "N";
                // bool StrFlag = false;
                #region MGCancel


                if (viewComplainceHoldListRequest.IsMGTxn == "Y")
                {
                    if (viewComplainceHoldListRequest.IsMTOSuccess == "Y")
                    {
                        string MGCancel_msg_ = "";

                        csMG _csMG = new csMG();

                        csMGCancelLog objcsMGCancelLog = new csMGCancelLog();

                        DetailLookupResponse resp = null;

                        objcsMGCancelLog.TxnNumber = TransNo;
                        objcsMGCancelLog.CancelUser = viewComplainceHoldListRequest.UserID;

                        objcsMGCancelLog.RequestType = CanRequestType.Request;
                        objcsMGCancelLog.LogToDB();

                        /////////////////////////////////////////////////////

                        string MG_referenceNumber = "";



                        var paramObj = new { Txn_No = TransNo };

                        MG_referenceNumber = _csMG.get_tbl_data("usp_Get_MG_RefNumber", paramObj).Tables[0].Rows[0]["MG_refno"].ToString();



                        /////////////////////////////////////////////////////


                        string dtLookUp_resp = _csMG.MG_detailLookup(MG_referenceNumber, TransNo, 0);

                        if (!dtLookUp_resp.Split('|')[0].Equals("NA"))
                        {

                            resp = JsonConvert.DeserializeObject<DetailLookupResponse>(dtLookUp_resp);

                            if (resp.transactionStatus.ToString() == "AVAIL" ||
                                resp.transactionStatus.ToString() == "AFR" ||
                                resp.transactionStatus.ToString() == "PRCSS")
                            {



                                MGCancel_msg_ = _csMG.MG_CancelTransaction(MG_referenceNumber, TransNo, resp,
                                    "WRONG_SERVICE", "Y");



                                if (MGCancel_msg_.Split('|')[0] == "0")
                                {
                                    throw new Exception("MG_Error : " + MGCancel_msg_.Split('|')[1]);
                                }
                                IsMGCancel = "Y";

                            }
                            else if (resp.transactionStatus.ToString() == "CANCL" || resp.transactionStatus.ToString() == "REFND")
                            {
                                IsMGCancel = "Y";
                            }
                            else
                            {

                                _complianceView_Reject.Message = "MG_Error : This transaction cannot be cancelled.";
                                throw new Exception("MG_Error : This transaction cannot be cancelled.");


                            }

                        }
                        else
                        {

                            _complianceView_Reject.Message = "MG_Error : " + dtLookUp_resp.Split('|')[1];

                            throw new Exception("MG_Error : " + dtLookUp_resp.Split('|')[1]);



                        }
                    }
                    else
                    {
                        IsMGCancel = "Y";
                    }

                }
                else
                {
                    IsMGCancel = "Y";
                }

                #endregion

                if (IsMGCancel == "Y")
                {
                    #region ICS PPS REQUEST

                    #region GetCustomerType
                    DataTable dt = new DataTable();
                    dt = dal.GetCustomerType(viewComplainceHoldListRequest.TransactionNumber);
                    #endregion


                    if (dt.Rows[0]["CutomerType"].ToString() == "1")
                    {
                        #region PPS
                        PPSRequest objPPSRequest = new PPSRequest();
                        objPPSRequest.CancelType = CancelType.ComplianceBlockCancel;
                        objPPSRequest.ReferenceNo = TransNo;
                        objPPSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                        objPPSRequest.IsReverse = false;
                        objPPSRequest.CancelMessage = viewComplainceHoldListRequest.RejectReason;
                        objPPSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                        objPPSRequest.CancelRequstedUser = viewComplainceHoldListRequest.UserID;
                        if (objPPSRequest.SentToPPS())
                        {
                            _complianceView_Reject.strSuccessFlag = "1";
                        }
                        else
                        {
                            _complianceView_Reject.strSuccessFlag = "0";
                            _complianceView_Reject.Message = objPPSRequest.Description;

                        }
                        #endregion
                    }
                    else
                    {
                        #region ICS
                        if (!string.IsNullOrEmpty(viewComplainceHoldListRequest.OrgMsgID))
                        {
                            ICSDFRequest objICSDoubtFulRequest = new ICSDFRequest();
                            objICSDoubtFulRequest.CancelType = CancelType.ComplianceBlockCancel;
                            objICSDoubtFulRequest.OriginalMsgID = viewComplainceHoldListRequest.OrgMsgID;
                            objICSDoubtFulRequest.ReferenceNo = TransNo;
                            objICSDoubtFulRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                            objICSDoubtFulRequest.IsReverse = false;
                            objICSDoubtFulRequest.CancelMessage = viewComplainceHoldListRequest.RejectReason;
                            objICSDoubtFulRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                            objICSDoubtFulRequest.CancelRequstedUser = viewComplainceHoldListRequest.UserID;

                            if (objICSDoubtFulRequest.SendDoubtfulRequest())
                            {
                                _complianceView_Reject.strSuccessFlag = "1";
                            }
                            else
                            {
                                _complianceView_Reject.strSuccessFlag = "0";
                                _complianceView_Reject.Message = objICSDoubtFulRequest.Description;
                            }

                        }
                        else
                        {
                            ICSRequest objICSRequest = new ICSRequest();
                            objICSRequest.CancelType = CancelType.ComplianceBlockCancel;
                            objICSRequest.ReferenceNo = TransNo;
                            objICSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                            objICSRequest.IsReverse = false;
                            objICSRequest.CancelMessage = viewComplainceHoldListRequest.RejectReason;
                            objICSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                            objICSRequest.CancelRequstedUser = viewComplainceHoldListRequest.UserID;

                            if (objICSRequest.SentToICS())
                            {
                                _complianceView_Reject.strSuccessFlag = "1";

                            }
                            else
                            {
                                _complianceView_Reject.strSuccessFlag = "0";
                                _complianceView_Reject.Message = objICSRequest.Description;

                                if (objICSRequest.Description.Contains("Could not read message"))
                                {
                                    string _scriptErr = "frmViewblocktransaction.aspx?trn=&msg=Transaction number " + TransNo + " is NOT Rejected.";
                                    _complianceView_Reject.Message = _scriptErr;


                                }
                            }
                        }
                        #endregion
                    }
                    #endregion

                }
                lstcomplianceView_Reject.Add(_complianceView_Reject);

                string result = JsonConvert.SerializeObject(lstcomplianceView_Reject);
                string strRequest = JsonConvert.SerializeObject(viewComplainceHoldListRequest);
                commonLogDetails.LogToDB("Reject", "N/A", "Success", result, strRequest);

                return lstcomplianceView_Reject;
            }
            catch (Exception ex)
            {
                string strRequest = JsonConvert.SerializeObject(viewComplainceHoldListRequest);
                commonLogDetails.LogToDB("Reject", "N/A", ex.ToString(), "No Response", strRequest);
                throw ex;
            }
        }

        public bool ComplianceManagementView_ApproveCustomer(viewComplainceHoldListCustomerApproveRequest viewComplainceHoldListCustomerApproveRequest)
        {
            try
            {
                bool ComplianceManagement = false;
                ComplianceManagement = dal.ComplianceManagementView_UpdateCustBEN(viewComplainceHoldListCustomerApproveRequest.TransactionNumber, "A", "C", viewComplainceHoldListCustomerApproveRequest.Remark, viewComplainceHoldListCustomerApproveRequest.UserID, viewComplainceHoldListCustomerApproveRequest.CustomerBeneficiaryNo);
                commonLogDetails.LogToDB("ComplianceManagementView_ApproveCustomer", viewComplainceHoldListCustomerApproveRequest.UserID, "Success", "true", $"TransactionNumber: {viewComplainceHoldListCustomerApproveRequest.TransactionNumber},CustomerBeneficiaryNo:{viewComplainceHoldListCustomerApproveRequest.CustomerBeneficiaryNo}");
                return ComplianceManagement;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ComplianceManagementView_ApproveCustomer", viewComplainceHoldListCustomerApproveRequest.UserID,ex.ToString(), "Flase", $"TransactionNumber: {viewComplainceHoldListCustomerApproveRequest.TransactionNumber},CustomerBeneficiaryNo:{viewComplainceHoldListCustomerApproveRequest.CustomerBeneficiaryNo}");
                throw ex;
            }
        }

        public bool ComplianceManagementView_ApproveBeneficiary(viewComplainceHoldListCustomerBeneficiaryRequest viewComplainceHoldListCustomerBeneficiaryRequest)
        {
            try
            {
                string IsBenApprove = "N";
                bool ComplianceManagement = false;
                if (viewComplainceHoldListCustomerBeneficiaryRequest.CustStatus == "Y")
                {

                    if (viewComplainceHoldListCustomerBeneficiaryRequest.CustApprove == "Y")
                    {
                        ComplianceManagement = dal.ComplianceManagementView_UpdateCustBEN(viewComplainceHoldListCustomerBeneficiaryRequest.TransactionNumber, "A", "B", viewComplainceHoldListCustomerBeneficiaryRequest.Remark, viewComplainceHoldListCustomerBeneficiaryRequest.UserID, viewComplainceHoldListCustomerBeneficiaryRequest.CustomerBeneficiaryNo);
                        IsBenApprove = "Y";
                    }
                    else
                    {
                        throw new Exception("Please Approve Remitter First.");
                    }
                }
                else
                {
                    ComplianceManagement = dal.ComplianceManagementView_UpdateCustBEN(viewComplainceHoldListCustomerBeneficiaryRequest.TransactionNumber, "A", "B", viewComplainceHoldListCustomerBeneficiaryRequest.Remark, viewComplainceHoldListCustomerBeneficiaryRequest.UserID, viewComplainceHoldListCustomerBeneficiaryRequest.CustomerBeneficiaryNo);
                    IsBenApprove = "Y";
                }
                if (IsBenApprove == "Y")
                {
                    if (ValidateTxn(viewComplainceHoldListCustomerBeneficiaryRequest.CustStatus, viewComplainceHoldListCustomerBeneficiaryRequest.CustApprove, viewComplainceHoldListCustomerBeneficiaryRequest.BENStatus, viewComplainceHoldListCustomerBeneficiaryRequest.BENApprove, viewComplainceHoldListCustomerBeneficiaryRequest.IsMGTxn, viewComplainceHoldListCustomerBeneficiaryRequest.TxnTime, viewComplainceHoldListCustomerBeneficiaryRequest.MGWaitMin))
                    {
                        ComplianceManagement = dal.ComplianceManagementView_Approve(viewComplainceHoldListCustomerBeneficiaryRequest.TransactionNumber, viewComplainceHoldListCustomerBeneficiaryRequest.Remark, viewComplainceHoldListCustomerBeneficiaryRequest.UserID);
                    }
                    else
                    {
                        if (viewComplainceHoldListCustomerBeneficiaryRequest.IsMGTxn == "Y")
                        {
                            if (viewComplainceHoldListCustomerBeneficiaryRequest.TxnExpired == "Y")
                            {
                                ComplianceManagement = true;
                                string Remark = viewComplainceHoldListCustomerBeneficiaryRequest.Remark;
                                string TransNo = viewComplainceHoldListCustomerBeneficiaryRequest.TransactionNumber;
                                string IsMGCancel = "N";
                                #region MGCancel


                                if (viewComplainceHoldListCustomerBeneficiaryRequest.IsMGTxn == "Y")
                                {
                                    if (viewComplainceHoldListCustomerBeneficiaryRequest.IsMTOSuccess == "Y")
                                    {
                                        string MGCancel_msg_ = "";

                                        csMG _csMG = new csMG();

                                        csMGCancelLog objcsMGCancelLog = new csMGCancelLog();

                                        DetailLookupResponse resp = null;

                                        objcsMGCancelLog.TxnNumber = TransNo;
                                        objcsMGCancelLog.CancelUser = viewComplainceHoldListCustomerBeneficiaryRequest.UserID;

                                        objcsMGCancelLog.RequestType = CanRequestType.Request;
                                        objcsMGCancelLog.LogToDB();

                                        /////////////////////////////////////////////////////

                                        string MG_referenceNumber = "";



                                        var paramObj = new { Txn_No = TransNo };

                                        MG_referenceNumber = _csMG.get_tbl_data("usp_Get_MG_RefNumber", paramObj).Tables[0].Rows[0]["MG_refno"].ToString();



                                        /////////////////////////////////////////////////////


                                        string dtLookUp_resp = _csMG.MG_detailLookup(MG_referenceNumber, TransNo, 0);

                                        if (!dtLookUp_resp.Split('|')[0].Equals("NA"))
                                        {

                                            resp = JsonConvert.DeserializeObject<DetailLookupResponse>(dtLookUp_resp);

                                            if (resp.transactionStatus.ToString() == "AVAIL" ||
                                                resp.transactionStatus.ToString() == "AFR" ||
                                                resp.transactionStatus.ToString() == "PRCSS")
                                            {



                                                MGCancel_msg_ = _csMG.MG_CancelTransaction(MG_referenceNumber, TransNo, resp,
                                                    "WRONG_SERVICE", "Y");



                                                if (MGCancel_msg_.Split('|')[0] == "0")
                                                {
                                                    throw new Exception("MG_Error : " + MGCancel_msg_.Split('|')[1]);
                                                }
                                                IsMGCancel = "Y";

                                            }
                                            else if (resp.transactionStatus.ToString() == "CANCL" || resp.transactionStatus.ToString() == "REFND")
                                            {
                                                IsMGCancel = "Y";
                                            }
                                            else
                                            {
                                                throw new Exception("MG_Error : This transaction cannot be cancelled.");

                                            }

                                        }
                                        else
                                        {

                                            throw new Exception("MG_Error : " + dtLookUp_resp.Split('|')[1]);

                                        }
                                    }
                                    else
                                    {
                                        IsMGCancel = "Y";
                                    }

                                }
                                else
                                {
                                    IsMGCancel = "Y";
                                }

                                #endregion

                                if (IsMGCancel == "Y")
                                {
                                    #region ICS PPS REQUEST

                                    #region GetCustomerType
                                    DataTable dt = new DataTable();
                                    dt = dal.GetCustomerType(viewComplainceHoldListCustomerBeneficiaryRequest.TransactionNumber);
                                    #endregion


                                    if (dt.Rows[0]["CutomerType"].ToString() == "1")
                                    {
                                        #region PPS
                                        PPSRequest objPPSRequest = new PPSRequest();
                                        objPPSRequest.CancelType = CancelType.ComplianceBlockCancel;
                                        objPPSRequest.ReferenceNo = TransNo;
                                        objPPSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                                        objPPSRequest.IsReverse = false;
                                        objPPSRequest.CancelMessage = Remark;
                                        objPPSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                                        objPPSRequest.CancelRequstedUser = viewComplainceHoldListCustomerBeneficiaryRequest.UserID;
                                        if (objPPSRequest.SentToPPS())
                                        {
                                           // _complianceView_Reject.strSuccessFlag = "1";
                                        }
                                        else
                                        {
                                            //_complianceView_Reject.strSuccessFlag = "0";
                                            //_complianceView_Reject.Message = objPPSRequest.Description;

                                        }
                                        #endregion
                                    }
                                    else
                                    {
                                        #region ICS
                                        if (!string.IsNullOrEmpty(viewComplainceHoldListCustomerBeneficiaryRequest.OrgMsgID))
                                        {
                                            ICSDFRequest objICSDoubtFulRequest = new ICSDFRequest();
                                            objICSDoubtFulRequest.CancelType = CancelType.ComplianceBlockCancel;
                                            objICSDoubtFulRequest.OriginalMsgID = viewComplainceHoldListCustomerBeneficiaryRequest.OrgMsgID;
                                            objICSDoubtFulRequest.ReferenceNo = TransNo;
                                            objICSDoubtFulRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                                            objICSDoubtFulRequest.IsReverse = false;
                                            objICSDoubtFulRequest.CancelMessage = Remark;
                                            objICSDoubtFulRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                                            objICSDoubtFulRequest.CancelRequstedUser = viewComplainceHoldListCustomerBeneficiaryRequest.UserID;

                                            if (objICSDoubtFulRequest.SendDoubtfulRequest())
                                            {
                                                //_complianceView_Reject.strSuccessFlag = "1";
                                            }
                                            else
                                            {
                                                //_complianceView_Reject.strSuccessFlag = "0";
                                                //_complianceView_Reject.Message = objICSDoubtFulRequest.Description;
                                            }

                                        }
                                        else
                                        {
                                            ICSRequest objICSRequest = new ICSRequest();
                                            objICSRequest.CancelType = CancelType.ComplianceBlockCancel;
                                            objICSRequest.ReferenceNo = TransNo;
                                            objICSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                                            objICSRequest.IsReverse = false;
                                            objICSRequest.CancelMessage = Remark;
                                            objICSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                                            objICSRequest.CancelRequstedUser = viewComplainceHoldListCustomerBeneficiaryRequest.UserID;

                                            if (objICSRequest.SentToICS())
                                            {
                                               // _complianceView_Reject.strSuccessFlag = "1";

                                            }
                                            else
                                            {
                                                //_complianceView_Reject.strSuccessFlag = "0";
                                                //_complianceView_Reject.Message = objICSRequest.Description;

                                                if (objICSRequest.Description.Contains("Could not read message"))
                                                {
                                                    string _scriptErr = "frmViewblocktransaction.aspx?trn=&msg=Transaction number " + TransNo + " is NOT Rejected.";
                                                   // _complianceView_Reject.Message = _scriptErr;


                                                }
                                            }
                                        }
                                        #endregion
                                    }
                                    #endregion

                                }
                            }
                        }
                    }
                }
                commonLogDetails.LogToDB("ComplianceManagementView_ApproveBeneficiary", "N/A", "Success", "true", $"IsBenApprove: {IsBenApprove},CustStatus:{viewComplainceHoldListCustomerBeneficiaryRequest.CustStatus},CustApprove:{viewComplainceHoldListCustomerBeneficiaryRequest.CustApprove},BENStatus:{viewComplainceHoldListCustomerBeneficiaryRequest.BENStatus},BENApprove:{viewComplainceHoldListCustomerBeneficiaryRequest.BENApprove},TxnTime:{viewComplainceHoldListCustomerBeneficiaryRequest.TxnTime},MGWaitMin:{viewComplainceHoldListCustomerBeneficiaryRequest.MGWaitMin}");
                return ComplianceManagement;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ComplianceManagementView_ApproveBeneficiary", "N/A", ex.ToString(), "Flase", $"CustStatus:{viewComplainceHoldListCustomerBeneficiaryRequest.CustStatus},CustApprove:{viewComplainceHoldListCustomerBeneficiaryRequest.CustApprove},BENStatus:{viewComplainceHoldListCustomerBeneficiaryRequest.BENStatus},BENApprove:{viewComplainceHoldListCustomerBeneficiaryRequest.BENApprove},TxnTime:{viewComplainceHoldListCustomerBeneficiaryRequest.TxnTime},MGWaitMin:{viewComplainceHoldListCustomerBeneficiaryRequest.MGWaitMin}");
                throw ex;
            }
        }

        public List<RejectResponse> ViewComplainceHoldListRejectCustomer(viewComplainceHoldListCustomerRejectRequest viewComplainceHoldListCustomerRejectRequest)
        {
            try
            {
                dal.ComplianceManagementView_UpdateCustBEN(viewComplainceHoldListCustomerRejectRequest.TransactionNumber, "R", "C", viewComplainceHoldListCustomerRejectRequest.Remark, viewComplainceHoldListCustomerRejectRequest.UserID, viewComplainceHoldListCustomerRejectRequest.CustomerBeneficiaryNo);
                List<RejectResponse> lstcomplianceView_Reject = new List<RejectResponse>();
                RejectResponse _complianceView_Reject = new RejectResponse();
                string TransNo = viewComplainceHoldListCustomerRejectRequest.TransactionNumber;
                string IsMGCancel = "N";
                #region MGCancel


                if (viewComplainceHoldListCustomerRejectRequest.IsMGTxn == "Y")
                {
                    if (viewComplainceHoldListCustomerRejectRequest.IsMTOSuccess == "Y")
                    {
                        string MGCancel_msg_ = "";

                        csMG _csMG = new csMG();

                        csMGCancelLog objcsMGCancelLog = new csMGCancelLog();

                        DetailLookupResponse resp = null;

                        objcsMGCancelLog.TxnNumber = TransNo;
                        objcsMGCancelLog.CancelUser = viewComplainceHoldListCustomerRejectRequest.UserID;

                        objcsMGCancelLog.RequestType = CanRequestType.Request;
                        objcsMGCancelLog.LogToDB();

                        /////////////////////////////////////////////////////

                        string MG_referenceNumber = "";



                        var paramObj = new { Txn_No = TransNo };

                        MG_referenceNumber = _csMG.get_tbl_data("usp_Get_MG_RefNumber", paramObj).Tables[0].Rows[0]["MG_refno"].ToString();



                        /////////////////////////////////////////////////////


                        string dtLookUp_resp = _csMG.MG_detailLookup(MG_referenceNumber, TransNo, 0);

                        if (!dtLookUp_resp.Split('|')[0].Equals("NA"))
                        {

                            resp = JsonConvert.DeserializeObject<DetailLookupResponse>(dtLookUp_resp);

                            if (resp.transactionStatus.ToString() == "AVAIL" ||
                                resp.transactionStatus.ToString() == "AFR" ||
                                resp.transactionStatus.ToString() == "PRCSS")
                            {



                                MGCancel_msg_ = _csMG.MG_CancelTransaction(MG_referenceNumber, TransNo, resp,
                                    "WRONG_SERVICE", "Y");



                                if (MGCancel_msg_.Split('|')[0] == "0")
                                {
                                    throw new Exception("MG_Error : " + MGCancel_msg_.Split('|')[1]);
                                }
                                IsMGCancel = "Y";

                            }
                            else if (resp.transactionStatus.ToString() == "CANCL" || resp.transactionStatus.ToString() == "REFND")
                            {
                                IsMGCancel = "Y";
                            }
                            else
                            {

                                _complianceView_Reject.Message = "MG_Error : This transaction cannot be cancelled.";
                                throw new Exception("MG_Error : This transaction cannot be cancelled.");


                            }

                        }
                        else
                        {

                            _complianceView_Reject.Message = "MG_Error : " + dtLookUp_resp.Split('|')[1];

                            throw new Exception("MG_Error : " + dtLookUp_resp.Split('|')[1]);



                        }
                    }
                    else
                    {
                        IsMGCancel = "Y";
                    }

                }
                else
                {
                    IsMGCancel = "Y";
                }

                #endregion

                if (IsMGCancel == "Y")
                {
                    #region ICS PPS REQUEST

                    #region GetCustomerType
                    DataTable dt = new DataTable();
                    dt = dal.GetCustomerType(viewComplainceHoldListCustomerRejectRequest.TransactionNumber);
                    #endregion


                    if (dt.Rows[0]["CutomerType"].ToString() == "1")
                    {
                        #region PPS
                        PPSRequest objPPSRequest = new PPSRequest();
                        objPPSRequest.CancelType = CancelType.ComplianceBlockCancel;
                        objPPSRequest.ReferenceNo = TransNo;
                        objPPSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                        objPPSRequest.IsReverse = false;
                        objPPSRequest.CancelMessage = viewComplainceHoldListCustomerRejectRequest.RejectReason;
                        objPPSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                        objPPSRequest.CancelRequstedUser = viewComplainceHoldListCustomerRejectRequest.UserID;
                        if (objPPSRequest.SentToPPS())
                        {
                            _complianceView_Reject.strSuccessFlag = "1";
                        }
                        else
                        {
                            _complianceView_Reject.strSuccessFlag = "0";
                            _complianceView_Reject.Message = objPPSRequest.Description;

                        }
                        #endregion
                    }
                    else
                    {
                        #region ICS
                        if (!string.IsNullOrEmpty(viewComplainceHoldListCustomerRejectRequest.OrgMsgID))
                        {
                            ICSDFRequest objICSDoubtFulRequest = new ICSDFRequest();
                            objICSDoubtFulRequest.CancelType = CancelType.ComplianceBlockCancel;
                            objICSDoubtFulRequest.OriginalMsgID = viewComplainceHoldListCustomerRejectRequest.OrgMsgID;
                            objICSDoubtFulRequest.ReferenceNo = TransNo;
                            objICSDoubtFulRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                            objICSDoubtFulRequest.IsReverse = false;
                            objICSDoubtFulRequest.CancelMessage = viewComplainceHoldListCustomerRejectRequest.RejectReason;
                            objICSDoubtFulRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                            objICSDoubtFulRequest.CancelRequstedUser = viewComplainceHoldListCustomerRejectRequest.UserID;

                            if (objICSDoubtFulRequest.SendDoubtfulRequest())
                            {
                                _complianceView_Reject.strSuccessFlag = "1";
                            }
                            else
                            {
                                _complianceView_Reject.strSuccessFlag = "0";
                                _complianceView_Reject.Message = objICSDoubtFulRequest.Description;
                            }

                        }
                        else
                        {
                            ICSRequest objICSRequest = new ICSRequest();
                            objICSRequest.CancelType = CancelType.ComplianceBlockCancel;
                            objICSRequest.ReferenceNo = TransNo;
                            objICSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                            objICSRequest.IsReverse = false;
                            objICSRequest.CancelMessage = viewComplainceHoldListCustomerRejectRequest.RejectReason;
                            objICSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                            objICSRequest.CancelRequstedUser = viewComplainceHoldListCustomerRejectRequest.UserID;

                            if (objICSRequest.SentToICS())
                            {
                                _complianceView_Reject.strSuccessFlag = "1";

                            }
                            else
                            {
                                _complianceView_Reject.strSuccessFlag = "0";
                                _complianceView_Reject.Message = objICSRequest.Description;

                                if (objICSRequest.Description.Contains("Could not read message"))
                                {
                                    string _scriptErr = "frmViewblocktransaction.aspx?trn=&msg=Transaction number " + TransNo + " is NOT Rejected.";
                                    _complianceView_Reject.Message = _scriptErr;


                                }
                            }
                        }
                        #endregion
                    }
                    #endregion

                }
                lstcomplianceView_Reject.Add(_complianceView_Reject);


                string result = JsonConvert.SerializeObject(lstcomplianceView_Reject);
                commonLogDetails.LogToDB("ViewComplainceHoldListRejectCustomer", "N/A", "Success", result, $"TransactionNumber:{viewComplainceHoldListCustomerRejectRequest.TransactionNumber},Remarks:{viewComplainceHoldListCustomerRejectRequest.Remark},User ID:{viewComplainceHoldListCustomerRejectRequest.UserID},CustomerBeneficiaryNo:{viewComplainceHoldListCustomerRejectRequest.CustomerBeneficiaryNo}");


                return lstcomplianceView_Reject;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ViewComplainceHoldListRejectCustomer", "N/A", ex.ToString(), "No Response", $"TransactionNumber:{viewComplainceHoldListCustomerRejectRequest.TransactionNumber},Remarks:{viewComplainceHoldListCustomerRejectRequest.Remark},User ID:{viewComplainceHoldListCustomerRejectRequest.UserID},CustomerBeneficiaryNo:{viewComplainceHoldListCustomerRejectRequest.CustomerBeneficiaryNo}");
                throw ex;
            }
        }

        public List<RejectResponse> ViewComplainceHoldListRejectBeneficiary(viewComplainceHoldListCustomerRejectRequest viewComplainceHoldListCustomerRejectRequest)
        {
            try
            {
                dal.ComplianceManagementView_UpdateCustBEN(viewComplainceHoldListCustomerRejectRequest.TransactionNumber, "R", "B", viewComplainceHoldListCustomerRejectRequest.Remark, viewComplainceHoldListCustomerRejectRequest.UserID, viewComplainceHoldListCustomerRejectRequest.CustomerBeneficiaryNo);
                List<RejectResponse> lstcomplianceView_Reject = new List<RejectResponse>();
                RejectResponse _complianceView_Reject = new RejectResponse();
                string TransNo = viewComplainceHoldListCustomerRejectRequest.TransactionNumber;
                string IsMGCancel = "N";
                #region MGCancel


                if (viewComplainceHoldListCustomerRejectRequest.IsMGTxn == "Y")
                {
                    if (viewComplainceHoldListCustomerRejectRequest.IsMTOSuccess == "Y")
                    {
                        string MGCancel_msg_ = "";

                        csMG _csMG = new csMG();

                        csMGCancelLog objcsMGCancelLog = new csMGCancelLog();

                        DetailLookupResponse resp = null;

                        objcsMGCancelLog.TxnNumber = TransNo;
                        objcsMGCancelLog.CancelUser = viewComplainceHoldListCustomerRejectRequest.UserID;

                        objcsMGCancelLog.RequestType = CanRequestType.Request;
                        objcsMGCancelLog.LogToDB();

                        /////////////////////////////////////////////////////

                        string MG_referenceNumber = "";



                        var paramObj = new { Txn_No = TransNo };

                        MG_referenceNumber = _csMG.get_tbl_data("usp_Get_MG_RefNumber", paramObj).Tables[0].Rows[0]["MG_refno"].ToString();



                        /////////////////////////////////////////////////////


                        string dtLookUp_resp = _csMG.MG_detailLookup(MG_referenceNumber, TransNo, 0);

                        if (!dtLookUp_resp.Split('|')[0].Equals("NA"))
                        {

                            resp = JsonConvert.DeserializeObject<DetailLookupResponse>(dtLookUp_resp);

                            if (resp.transactionStatus.ToString() == "AVAIL" ||
                                resp.transactionStatus.ToString() == "AFR" ||
                                resp.transactionStatus.ToString() == "PRCSS")
                            {



                                MGCancel_msg_ = _csMG.MG_CancelTransaction(MG_referenceNumber, TransNo, resp,
                                    "WRONG_SERVICE", "Y");



                                if (MGCancel_msg_.Split('|')[0] == "0")
                                {
                                    throw new Exception("MG_Error : " + MGCancel_msg_.Split('|')[1]);
                                }
                                IsMGCancel = "Y";

                            }
                            else if (resp.transactionStatus.ToString() == "CANCL" || resp.transactionStatus.ToString() == "REFND")
                            {
                                IsMGCancel = "Y";
                            }
                            else
                            {

                                _complianceView_Reject.Message = "MG_Error : This transaction cannot be cancelled.";
                                throw new Exception("MG_Error : This transaction cannot be cancelled.");


                            }

                        }
                        else
                        {

                            _complianceView_Reject.Message = "MG_Error : " + dtLookUp_resp.Split('|')[1];

                            throw new Exception("MG_Error : " + dtLookUp_resp.Split('|')[1]);



                        }
                    }
                    else
                    {
                        IsMGCancel = "Y";
                    }

                }
                else
                {
                    IsMGCancel = "Y";
                }

                #endregion

                if (IsMGCancel == "Y")
                {
                    #region ICS PPS REQUEST

                    #region GetCustomerType
                    DataTable dt = new DataTable();
                    dt = dal.GetCustomerType(viewComplainceHoldListCustomerRejectRequest.TransactionNumber);
                    #endregion


                    if (dt.Rows[0]["CutomerType"].ToString() == "1")
                    {
                        #region PPS
                        PPSRequest objPPSRequest = new PPSRequest();
                        objPPSRequest.CancelType = CancelType.ComplianceBlockCancel;
                        objPPSRequest.ReferenceNo = TransNo;
                        objPPSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                        objPPSRequest.IsReverse = false;
                        objPPSRequest.CancelMessage = viewComplainceHoldListCustomerRejectRequest.RejectReason;
                        objPPSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                        objPPSRequest.CancelRequstedUser = viewComplainceHoldListCustomerRejectRequest.UserID;
                        if (objPPSRequest.SentToPPS())
                        {
                            _complianceView_Reject.strSuccessFlag = "1";
                        }
                        else
                        {
                            _complianceView_Reject.strSuccessFlag = "0";
                            _complianceView_Reject.Message = objPPSRequest.Description;

                        }
                        #endregion
                    }
                    else
                    {
                        #region ICS
                        if (!string.IsNullOrEmpty(viewComplainceHoldListCustomerRejectRequest.OrgMsgID))
                        {
                            ICSDFRequest objICSDoubtFulRequest = new ICSDFRequest();
                            objICSDoubtFulRequest.CancelType = CancelType.ComplianceBlockCancel;
                            objICSDoubtFulRequest.OriginalMsgID = viewComplainceHoldListCustomerRejectRequest.OrgMsgID;
                            objICSDoubtFulRequest.ReferenceNo = TransNo;
                            objICSDoubtFulRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                            objICSDoubtFulRequest.IsReverse = false;
                            objICSDoubtFulRequest.CancelMessage = viewComplainceHoldListCustomerRejectRequest.RejectReason;
                            objICSDoubtFulRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                            objICSDoubtFulRequest.CancelRequstedUser = viewComplainceHoldListCustomerRejectRequest.UserID;

                            if (objICSDoubtFulRequest.SendDoubtfulRequest())
                            {
                                _complianceView_Reject.strSuccessFlag = "1";
                            }
                            else
                            {
                                _complianceView_Reject.strSuccessFlag = "0";
                                _complianceView_Reject.Message = objICSDoubtFulRequest.Description;
                            }

                        }
                        else
                        {
                            ICSRequest objICSRequest = new ICSRequest();
                            objICSRequest.CancelType = CancelType.ComplianceBlockCancel;
                            objICSRequest.ReferenceNo = TransNo;
                            objICSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                            objICSRequest.IsReverse = false;
                            objICSRequest.CancelMessage = viewComplainceHoldListCustomerRejectRequest.RejectReason;
                            objICSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                            objICSRequest.CancelRequstedUser = viewComplainceHoldListCustomerRejectRequest.UserID;

                            if (objICSRequest.SentToICS())
                            {
                                _complianceView_Reject.strSuccessFlag = "1";

                            }
                            else
                            {
                                _complianceView_Reject.strSuccessFlag = "0";
                                _complianceView_Reject.Message = objICSRequest.Description;

                                if (objICSRequest.Description.Contains("Could not read message"))
                                {
                                    string _scriptErr = "frmViewblocktransaction.aspx?trn=&msg=Transaction number " + TransNo + " is NOT Rejected.";
                                    _complianceView_Reject.Message = _scriptErr;


                                }
                            }
                        }
                        #endregion
                    }
                    #endregion

                }
                lstcomplianceView_Reject.Add(_complianceView_Reject);

                string result = JsonConvert.SerializeObject(lstcomplianceView_Reject);
                commonLogDetails.LogToDB("ViewComplainceHoldListRejectBeneficiary", "N/A", "Success", result, $"TransactionNumber:{viewComplainceHoldListCustomerRejectRequest.TransactionNumber},Remarks:{viewComplainceHoldListCustomerRejectRequest.Remark},User ID:{viewComplainceHoldListCustomerRejectRequest.UserID},CustomerBeneficiaryNo:{viewComplainceHoldListCustomerRejectRequest.CustomerBeneficiaryNo}");

                return lstcomplianceView_Reject;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ViewComplainceHoldListRejectBeneficiary", "N/A", ex.ToString(), "No Response", $"TransactionNumber:{viewComplainceHoldListCustomerRejectRequest.TransactionNumber},Remarks:{viewComplainceHoldListCustomerRejectRequest.Remark},User ID:{viewComplainceHoldListCustomerRejectRequest.UserID},CustomerBeneficiaryNo:{viewComplainceHoldListCustomerRejectRequest.CustomerBeneficiaryNo}");
                throw;
            }
        }

        public List<RejectResponse> ViewComplainceHoldListRelease(viewComplainceHoldListApprove viewComplainceHoldListApprove)
        {
            try
            {
                List<RejectResponse> lstcomplianceView_Reject = new List<RejectResponse>();
                RejectResponse _complianceView_Reject = new RejectResponse();
                if (ValidateTxn(viewComplainceHoldListApprove.CustStatus, viewComplainceHoldListApprove.CustApprove, viewComplainceHoldListApprove.BENStatus, viewComplainceHoldListApprove.BENApprove, viewComplainceHoldListApprove.IsMGTxn, viewComplainceHoldListApprove.TxnTime, viewComplainceHoldListApprove.MGWaitMin))
                {
                    bool ComplianceManagement = false;
                    ComplianceManagement = dal.ComplianceManagementView_Approve(viewComplainceHoldListApprove.TransactionNumber, viewComplainceHoldListApprove.Remark, viewComplainceHoldListApprove.UserID);
                    if (ComplianceManagement)
                    {
                        _complianceView_Reject.Message = "frmviewcomplainceholdtransaction.aspx? trn = &msg = Transaction number " + viewComplainceHoldListApprove.TransactionNumber + " is approved.";
                    }
                }
                else
                {
                    if (viewComplainceHoldListApprove.IsMGTxn == "Y")
                    {
                        if (viewComplainceHoldListApprove.TxnExpired == "Y")
                        {
                            string Remark = "Time limit expired from MoneyGram. Transaction Rejected.";
                            string TransNo = viewComplainceHoldListApprove.TransactionNumber;
                            string IsMGCancel = "N";
                            #region MGCancel


                            if (viewComplainceHoldListApprove.IsMGTxn == "Y")
                            {
                                if (viewComplainceHoldListApprove.IsMTOSuccess == "Y")
                                {
                                    string MGCancel_msg_ = "";

                                    csMG _csMG = new csMG();

                                    csMGCancelLog objcsMGCancelLog = new csMGCancelLog();

                                    DetailLookupResponse resp = null;

                                    objcsMGCancelLog.TxnNumber = TransNo;
                                    objcsMGCancelLog.CancelUser = viewComplainceHoldListApprove.UserID;

                                    objcsMGCancelLog.RequestType = CanRequestType.Request;
                                    objcsMGCancelLog.LogToDB();

                                    /////////////////////////////////////////////////////

                                    string MG_referenceNumber = "";



                                    var paramObj = new { Txn_No = TransNo };

                                    MG_referenceNumber = _csMG.get_tbl_data("usp_Get_MG_RefNumber", paramObj).Tables[0].Rows[0]["MG_refno"].ToString();



                                    /////////////////////////////////////////////////////


                                    string dtLookUp_resp = _csMG.MG_detailLookup(MG_referenceNumber, TransNo, 0);

                                    if (!dtLookUp_resp.Split('|')[0].Equals("NA"))
                                    {

                                        resp = JsonConvert.DeserializeObject<DetailLookupResponse>(dtLookUp_resp);

                                        if (resp.transactionStatus.ToString() == "AVAIL" ||
                                            resp.transactionStatus.ToString() == "AFR" ||
                                            resp.transactionStatus.ToString() == "PRCSS")
                                        {



                                            MGCancel_msg_ = _csMG.MG_CancelTransaction(MG_referenceNumber, TransNo, resp,
                                                "WRONG_SERVICE", "Y");



                                            if (MGCancel_msg_.Split('|')[0] == "0")
                                            {
                                                throw new Exception("MG_Error : " + MGCancel_msg_.Split('|')[1]);
                                            }
                                            IsMGCancel = "Y";

                                        }
                                        else if (resp.transactionStatus.ToString() == "CANCL" || resp.transactionStatus.ToString() == "REFND")
                                        {
                                            IsMGCancel = "Y";
                                        }
                                        else
                                        {
                                            throw new Exception("MG_Error : This transaction cannot be cancelled.");

                                        }

                                    }
                                    else
                                    {

                                        throw new Exception("MG_Error : " + dtLookUp_resp.Split('|')[1]);

                                    }
                                }
                                else
                                {
                                    IsMGCancel = "Y";
                                }

                            }
                            else
                            {
                                IsMGCancel = "Y";
                            }

                            #endregion

                            if (IsMGCancel == "Y")
                            {
                                #region ICS PPS REQUEST

                                #region GetCustomerType
                                DataTable dt = new DataTable();
                                dt = dal.GetCustomerType(viewComplainceHoldListApprove.TransactionNumber);
                                #endregion


                                if (dt.Rows[0]["CutomerType"].ToString() == "1")
                                {
                                    #region PPS
                                    PPSRequest objPPSRequest = new PPSRequest();
                                    objPPSRequest.CancelType = CancelType.ComplianceBlockCancel;
                                    objPPSRequest.ReferenceNo = TransNo;
                                    objPPSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                                    objPPSRequest.IsReverse = false;
                                    objPPSRequest.CancelMessage = Remark;
                                    objPPSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                                    objPPSRequest.CancelRequstedUser = viewComplainceHoldListApprove.UserID;
                                    if (objPPSRequest.SentToPPS())
                                    {
                                        _complianceView_Reject.strSuccessFlag = "1";
                                    }
                                    else
                                    {
                                        _complianceView_Reject.strSuccessFlag = "0";
                                        _complianceView_Reject.Message = objPPSRequest.Description;

                                    }
                                    #endregion
                                }
                                else
                                {
                                    #region ICS
                                    if (!string.IsNullOrEmpty(viewComplainceHoldListApprove.OrgMsgID))
                                    {
                                        ICSDFRequest objICSDoubtFulRequest = new ICSDFRequest();
                                        objICSDoubtFulRequest.CancelType = CancelType.ComplianceBlockCancel;
                                        objICSDoubtFulRequest.OriginalMsgID = viewComplainceHoldListApprove.OrgMsgID;
                                        objICSDoubtFulRequest.ReferenceNo = TransNo;
                                        objICSDoubtFulRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                                        objICSDoubtFulRequest.IsReverse = false;
                                        objICSDoubtFulRequest.CancelMessage = Remark;
                                        objICSDoubtFulRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                                        objICSDoubtFulRequest.CancelRequstedUser = viewComplainceHoldListApprove.UserID;

                                        if (objICSDoubtFulRequest.SendDoubtfulRequest())
                                        {
                                            _complianceView_Reject.strSuccessFlag = "1";
                                        }
                                        else
                                        {
                                            _complianceView_Reject.strSuccessFlag = "0";
                                            _complianceView_Reject.Message = objICSDoubtFulRequest.Description;
                                        }

                                    }
                                    else
                                    {
                                        ICSRequest objICSRequest = new ICSRequest();
                                        objICSRequest.CancelType = CancelType.ComplianceBlockCancel;
                                        objICSRequest.ReferenceNo = TransNo;
                                        objICSRequest.PartnerCode = Convert.ToInt32(dt.Rows[0]["PartnerCode"]);
                                        objICSRequest.IsReverse = false;
                                        objICSRequest.CancelMessage = Remark;
                                        objICSRequest.CustType = Convert.ToString(dt.Rows[0]["CutomerType"]);
                                        objICSRequest.CancelRequstedUser = viewComplainceHoldListApprove.UserID;

                                        if (objICSRequest.SentToICS())
                                        {
                                            _complianceView_Reject.strSuccessFlag = "1";

                                        }
                                        else
                                        {
                                            _complianceView_Reject.strSuccessFlag = "0";
                                            _complianceView_Reject.Message = objICSRequest.Description;

                                            if (objICSRequest.Description.Contains("Could not read message"))
                                            {
                                                string _scriptErr = "frmViewblocktransaction.aspx?trn=&msg=Transaction number " + TransNo + " is NOT Rejected.";
                                                _complianceView_Reject.Message = _scriptErr;


                                            }
                                        }
                                    }
                                    #endregion
                                }
                                #endregion

                            }
                        }
                    }
                    if (string.IsNullOrEmpty(_complianceView_Reject.Message))
                    {
                        _complianceView_Reject.Message = Message;
                    }
                }
                lstcomplianceView_Reject.Add(_complianceView_Reject);

                string result = JsonConvert.SerializeObject(lstcomplianceView_Reject);
                commonLogDetails.LogToDB("ViewComplainceHoldListRelease", "N/A", "Success", result, $"TransactionNumber:{viewComplainceHoldListApprove.TransactionNumber},Remarks:{viewComplainceHoldListApprove.Remark},User ID:{viewComplainceHoldListApprove.UserID}");

                return lstcomplianceView_Reject;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("ViewComplainceHoldListRelease", "N/A", ex.ToString(), "No Response", $"TransactionNumber:{viewComplainceHoldListApprove.TransactionNumber},Remarks:{viewComplainceHoldListApprove.Remark},User ID:{viewComplainceHoldListApprove.UserID}");
                throw;
            }
        }

        private bool ValidateTxn(string CustStatus, string CustApprove, string BENStatus, string BENApprove, string IsMGTxn, string TxnTime, string MGWaitMin)
        {
            bool IsValid = true;

            if (Convert.ToString(CustStatus) == "Y" && Convert.ToString(CustApprove) == "N")
            {
                IsValid = false;
                 Message = "Please Approve Remitter First.";
            }

            if (IsValid && Convert.ToString(BENStatus) == "Y" && Convert.ToString(BENApprove) == "N")
            {
                IsValid = false;
                Message = "Please Approve Beneficiary First.";
            }


            if (IsValid && Convert.ToString(IsMGTxn) == "Y")
            {
                DateTime txntime = Convert.ToDateTime(TxnTime);
                if (DateTime.Now.Subtract(txntime).TotalMinutes > Convert.ToInt32(MGWaitMin))
                {
                    IsValid = false;
                    Message = "Time limit expired from MoneyGram. Transaction Rejected.";
                }
            }
            return IsValid;
        }
    }
}