﻿using MainRemit;
using MyControls;
using Newtonsoft.Json;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Request;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI.WebControls;

namespace SAIB_Web_Api.BusinessManager
{
    public class ViewStopPaymentManager
    {
        DAL dal = new DAL();
        CommonLogDetails commonLogDetails = new CommonLogDetails();

        public List<TransactionStatusResponse> GetStatusList()
        {
            try
            {
                DataTable dt = dal.SelectStatusList();

                List<TransactionStatusResponse> lstTransactionStatus = new List<TransactionStatusResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    TransactionStatusResponse _statusListResponse = new TransactionStatusResponse();
                    _statusListResponse.TrStatusID = Convert.ToInt32(row["TrStatusID"]);
                    _statusListResponse.Tr_Status_Name = row["Tr_Status_Name"].ToString();
                    lstTransactionStatus.Add(_statusListResponse);
                }

                string result = JsonConvert.SerializeObject(lstTransactionStatus);
                commonLogDetails.LogToDB("GetStatusList", "N/A", "Success", result, "No Request");

                return lstTransactionStatus;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetStatusList", "N/A", ex.ToString(), "No Response", "No Request");
                throw ex;
            }

        }


        public List<TransactionStatusResponse> GetAllStatusList(string Form)
        {
            try
            {
                DataTable dt = dal.SelectTransactionStatusList(Form);

                List<TransactionStatusResponse> lstAllStatus = new List<TransactionStatusResponse>();

                foreach (DataRow row in dt.Rows)
                {
                    TransactionStatusResponse _statusListResponse = new TransactionStatusResponse();
                    _statusListResponse.TrStatusID = Convert.ToInt32(row["TrStatusID"]);
                    _statusListResponse.Tr_Status_Name = row["Tr_Status_Name"].ToString();
                    lstAllStatus.Add(_statusListResponse);
                }

                string result = JsonConvert.SerializeObject(lstAllStatus);
                commonLogDetails.LogToDB("GetAllStatusList", "N/A", "Success", result, $"Form: {Form}");

                return lstAllStatus;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetAllStatusList", "N/A", ex.ToString(), "No Response", $"Form: {Form}");
                throw ex;
            }

        }


        public List<StopPayment_AgentType> GetAgentTypeList(int _AgentId, int _AgentGroupID)
        {

            try
            {
                DataTable dt = dal.SelectAgentTypeList(_AgentId, _AgentGroupID);

                List<StopPayment_AgentType> lstAgentType = new List<StopPayment_AgentType>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_AgentType _agentTypeResponse = new StopPayment_AgentType();
                    _agentTypeResponse.Group_Id = Convert.ToInt32(row["Group_Id"]);
                    _agentTypeResponse.Group_Name = row["Group_Name"].ToString();
                    lstAgentType.Add(_agentTypeResponse);
                }

                string result = JsonConvert.SerializeObject(lstAgentType);
                commonLogDetails.LogToDB("GetAgentTypeList", "N/A", "Success", result, $"_AgentId: {_AgentId},_AgentGroupID: {_AgentGroupID}");

                return lstAgentType;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetAgentTypeList", "N/A", ex.ToString(), "No Response", $"_AgentId: {_AgentId},_AgentGroupID: {_AgentGroupID}");
                throw ex;
            }
        }


        public List<StopPayment_TransferType> GetTransferTypeList(int _Agent_ID, int _Group)
        {
            try
            {
                DataTable dt = dal.SelectTransferTypeList(_Agent_ID, _Group);

                List<StopPayment_TransferType> lstTransferType = new List<StopPayment_TransferType>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_TransferType _transferTypeResponse = new StopPayment_TransferType();
                    _transferTypeResponse.TrTypeID = Convert.ToInt32(row["TrTypeID"]);
                    _transferTypeResponse.Tr_Description = row["Tr_Description"].ToString();
                    lstTransferType.Add(_transferTypeResponse);
                }

                string result = JsonConvert.SerializeObject(lstTransferType);
                commonLogDetails.LogToDB("GetTransferTypeList", "N/A", "Success", result, $"_AgentId: {_Agent_ID},_AgentGroupID: {_Group}");

                return lstTransferType;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetTransferTypeList", "N/A", ex.ToString(), "No Response", $"_AgentId: {_Agent_ID},_AgentGroupID: {_Group}");
                throw ex;
            }

        }


        public List<StopPayment_CountryList> GetPayInCountryList(Permission _MyType)
        {

            try
            {
                DataTable dt = dal.SelectSendCountryList(_MyType);

                List<StopPayment_CountryList> lstCountryType = new List<StopPayment_CountryList>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_CountryList _countryTypeResponse = new StopPayment_CountryList();
                    _countryTypeResponse.CountryID = Convert.ToInt32(row["CountryID"]);
                    _countryTypeResponse.CountryName = row["CountryName"].ToString();
                    lstCountryType.Add(_countryTypeResponse);
                }

                string result = JsonConvert.SerializeObject(lstCountryType);
                commonLogDetails.LogToDB("GetPayInCountryList", "N/A", "Success", result, $"MyType: {_MyType}");

                return lstCountryType;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetPayInCountryList", "N/A", ex.ToString(), "No Response", $"MyType: {_MyType}");
                throw ex;
            }
        }


        public List<StopPayment_CountryList> GetPayOutCountryList(Permission _MyType, bool _AsPerPermission, int _CountryID)
        {

            try
            {
                DataTable dt = dal.SelectDestCountryList(_MyType, _AsPerPermission, _CountryID);

                List<StopPayment_CountryList> lstPayoutCountryType = new List<StopPayment_CountryList>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_CountryList _payOutCountryResponse = new StopPayment_CountryList();
                    _payOutCountryResponse.CountryID = Convert.ToInt32(row["CountryID"]);
                    _payOutCountryResponse.CountryName = row["CountryName"].ToString();
                    lstPayoutCountryType.Add(_payOutCountryResponse);
                }

                string result = JsonConvert.SerializeObject(lstPayoutCountryType);
                commonLogDetails.LogToDB("GetPayOutCountryList", "N/A", "Success", result, $"MyType: {_MyType},AsPerPermission: {_AsPerPermission},CountryID: {_CountryID}");

                return lstPayoutCountryType;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetPayOutCountryList", "N/A", ex.Message, "No Response", $"MyType: {_MyType},AsPerPermission: {_AsPerPermission},CountryID: {_CountryID}");
                throw ex;
            }
        }

        public List<StopPayment_PayInCurrencyList> GetPayInCurrencyList(int _CountryID)
        {

            try
            {
                DataTable dt = dal.SelectPayInCurrencyList(_CountryID);

                List<StopPayment_PayInCurrencyList> lstPayInCurrencyType = new List<StopPayment_PayInCurrencyList>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_PayInCurrencyList _payInCurrencyResponse = new StopPayment_PayInCurrencyList();
                    _payInCurrencyResponse.Currency_Id = Convert.ToInt32(row["Currency_Id"]);
                    _payInCurrencyResponse.CurrencyShortName = row["CurrencyShortName"].ToString();
                    lstPayInCurrencyType.Add(_payInCurrencyResponse);
                }

                string result = JsonConvert.SerializeObject(lstPayInCurrencyType);
                commonLogDetails.LogToDB("GetPayInCurrencyList", "N/A", "Success", result, $"CountryID: {_CountryID}");

                return lstPayInCurrencyType;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetPayInCurrencyList", "N/A", ex.ToString(), "No Response", $"CountryID: {_CountryID}");
                throw ex;
            }
        }

        public List<StopPayment_PayInCurrencyList> GetPayOutCurrencyList(int _CountryID)
        {

            try
            {
                DataTable dt = dal.SelectPayOutCurrencyList(_CountryID);

                List<StopPayment_PayInCurrencyList> lstPayoutCountryType = new List<StopPayment_PayInCurrencyList>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_PayInCurrencyList _payOutCountryResponse = new StopPayment_PayInCurrencyList();
                    _payOutCountryResponse.Currency_Id = Convert.ToInt32(row["Currency_Id"]);
                    _payOutCountryResponse.CurrencyShortName = row["CurrencyShortName"].ToString();
                    lstPayoutCountryType.Add(_payOutCountryResponse);
                }

                string result = JsonConvert.SerializeObject(lstPayoutCountryType);
                commonLogDetails.LogToDB("GetPayOutCurrencyList", "N/A", "Success", result, $"CountryID: {_CountryID}");

                return lstPayoutCountryType;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetPayOutCurrencyList", "N/A", ex.Message, "no Response", $"CountryID: {_CountryID}");
                throw ex;
            }
        }


        public List<StopPayment_AgentList> GetAgentList(Permission _Type, int _Agent_ID, int _TargetCountryID)
        {

            try
            {
                DataTable dt = dal.SelectAgentList(_Type, _Agent_ID, _TargetCountryID);

                List<StopPayment_AgentList> lstAgent = new List<StopPayment_AgentList>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_AgentList _agentListResponse = new StopPayment_AgentList();
                    _agentListResponse.Agent_ID = Convert.ToInt32(row["Agent_ID"]);
                    _agentListResponse.Agent_Name = row["Agent_Name"].ToString();
                    lstAgent.Add(_agentListResponse);
                }

                string result = JsonConvert.SerializeObject(lstAgent);
                commonLogDetails.LogToDB("GetAgentList", "N/A", "Success", result, $"Type: {_Type},Agent_ID: {_Agent_ID},TargetCountryID: {_TargetCountryID}");

                return lstAgent;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetAgentList", "N/A", ex.ToString(), "No Response", $"Type: {_Type},Agent_ID: {_Agent_ID},TargetCountryID: {_TargetCountryID}");
                throw ex;
            }
        }


        public List<StopPayment_Agent_BranchList> GetAgentBranchList(int _Agent_ID)
        {

            try
            {
                DataTable dt = dal.SelectAgentBranchList(_Agent_ID);

                List<StopPayment_Agent_BranchList> lstAgentBranch = new List<StopPayment_Agent_BranchList>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_Agent_BranchList _agenBranchtListResponse = new StopPayment_Agent_BranchList();
                    _agenBranchtListResponse.AgentBranch_ID = Convert.ToInt32(row["AgentBranch_ID"]);
                    _agenBranchtListResponse.AgentBranch_Name = row["AgentBranch_Name"].ToString();
                    lstAgentBranch.Add(_agenBranchtListResponse);
                }

                string result = JsonConvert.SerializeObject(lstAgentBranch);
                commonLogDetails.LogToDB("GetAgentBranchList", "N/A", "Success", result, $"Agent_ID: {_Agent_ID}");

                return lstAgentBranch;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetAgentBranchList", "N/A", ex.ToString(), "No Response", $"Agent_ID: {_Agent_ID}");
                throw ex;
            }
        }


        public List<StopPayment_AgentBranchUserList> GetUserList(int _Agent_ID, int _Agent_Branch_ID)
        {

            try
            {
                DataTable dt = dal.SelectUserList(_Agent_ID, _Agent_Branch_ID);

                List<StopPayment_AgentBranchUserList> lstUser = new List<StopPayment_AgentBranchUserList>();

                foreach (DataRow row in dt.Rows)
                {
                    StopPayment_AgentBranchUserList _agenUserListResponse = new StopPayment_AgentBranchUserList();
                    _agenUserListResponse.Agent_Branch_ID = Convert.ToInt32(row["Agent_Branch_ID"]);
                    _agenUserListResponse.Agent_ID = Convert.ToInt32(row["Agent_ID"]);
                    _agenUserListResponse.UserId = row["UserId"].ToString();
                    _agenUserListResponse.User_Name = row["User_Name"].ToString();
                    lstUser.Add(_agenUserListResponse);
                }

                string result = JsonConvert.SerializeObject(lstUser);
                commonLogDetails.LogToDB("GetUserList", "N/A", "Success", result, $"Agent_ID: {_Agent_ID},Agent_Branch_ID: {_Agent_Branch_ID}");

                return lstUser;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetUserList", "N/A", ex.ToString(), "No Response", $"Agent_ID: {_Agent_ID},Agent_Branch_ID: {_Agent_Branch_ID}");
                throw ex;
            }
        }


        public List<StopPayment_FillGrid> GetAllRecordByFilter(TransactionSearchCriteria transactionSearch)
        {
            try
            {
                DataTable dt = dal.GetAllRecordBySearch(transactionSearch);

                List<StopPayment_FillGrid> lstStopPaymentRequest = new List<StopPayment_FillGrid>();

                foreach (DataRow row in dt.Rows)
                {

                    //Search.Process _process = new Search.Process(csCommon.ConnectionString);
                    StopPayment_FillGrid trxnStatus = new StopPayment_FillGrid();

                    //trxnStatus.SrNo = Convert.ToInt32(row["SrNo"]);
                    trxnStatus.SRTRNo = row["SRTRNo"].ToString();
                    trxnStatus.Ex_Branch_ID = Convert.ToInt32(row["Ex_Branch_ID"]);
                    trxnStatus.App_ID = row["App_ID"].ToString();
                    trxnStatus.Date = row["Date"].ToString();
                    trxnStatus.TrTypeID = Convert.ToInt32(row["TrTypeID"]);
                    trxnStatus.Tr_Status_Name = row["Tr_Status_Name"].ToString();
                    trxnStatus.PayAgent = Convert.ToInt32(row["PayAgent"]);
                    trxnStatus.TrStatusID = Convert.ToInt32(row["TrStatusID"]);
                    trxnStatus.Customer_Name_F = row["Customer_Name_F"].ToString();
                    trxnStatus.Customer_Name_L = row["Customer_Name_L"].ToString();
                    trxnStatus.Beneficiary_Name_F = row["Beneficiary_Name_F"].ToString();
                    trxnStatus.Beneficiary_Name_L = row["Beneficiary_Name_L"].ToString();
                    trxnStatus.PayCountryID = Convert.ToInt32(row["PayCountryID"]);
                    trxnStatus.CountryID = Convert.ToInt32(row["CountryID"]);
                    trxnStatus.Agent_ID = Convert.ToInt32(row["Agent_ID"]);
                    trxnStatus.Tr_Sequance = Convert.ToInt32(row["Tr_Sequance"]);
                    trxnStatus.UserId = row["UserId"].ToString();
                    trxnStatus.Agent_Branch_ID = Convert.ToInt32(row["Agent_Branch_ID"]);
                    trxnStatus.LoginCountryID = Convert.ToInt32(row["LoginCountryID"]);
                    trxnStatus.LoginCityID = Convert.ToInt32(row["LoginCityID"]);
                    trxnStatus.LoginLocationID = Convert.ToInt32(row["LoginLocationID"]);
                    trxnStatus.Reference_No = row["LoginLocationID"].ToString();
                    trxnStatus.Remark = row["Remark"].ToString();
                    trxnStatus.Show = row["Show"].ToString();
                    trxnStatus.hLink = row["hLink"].ToString();
                    trxnStatus.Tr_Description = row["Tr_Description"].ToString();

                    lstStopPaymentRequest.Add(trxnStatus);

                }

                string result = JsonConvert.SerializeObject(lstStopPaymentRequest);
                commonLogDetails.LogToDB("GetAllRecordByFilter", "N/A", "Success", result, $"TransactionSearch: {transactionSearch}");

                return lstStopPaymentRequest;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("GetAllRecordByFilter", "N/A", ex.ToString(), "No Response", $"TransactionSearch: {transactionSearch}");
                throw ex;
            }

        }


        //================For UPDATE STATUS================//
        public bool Update_TransactionStatus(StopPayment_UpdateTxn stopPaymentUpdateTxn)
        {
            try
            {
                bool updateSuccess = dal.UpdateTransactionStatus(stopPaymentUpdateTxn);

                string Request = JsonConvert.SerializeObject(stopPaymentUpdateTxn);
                commonLogDetails.LogToDB("Update_TransactionStatus", "N/A", "Success", "True", Request);

                return updateSuccess;
            }
            catch (Exception ex)
            {
                string Request = JsonConvert.SerializeObject(stopPaymentUpdateTxn);
                commonLogDetails.LogToDB("Update_TransactionStatus", "N/A", ex.ToString(), "Flase", Request);
                throw ex;
            }
        }


        //=================DISPLAY COMPLETE DETAIL================//
        public List<StopPayment_AllDataByTxnNo_Add> Display_TransactionDetails(string _AppID, string _Branch, string _RefNo)
        {
            try
            {
                List<StopPayment_AllDataByTxnNo_Add> lstUser = new List<StopPayment_AllDataByTxnNo_Add>();

                Transaction.GetTransaction _get = new Transaction.GetTransaction(csCommon.GetConnectionString);
                _get.Ex_Branch_ID = int.Parse(_Branch);
                _get.App_ID = _AppID;
                _get.ReferenceNo = _RefNo;
                _get.Get();

                if (_get.IsDataExist)
                {
                    StopPayment_AllDataByTxnNo_Add _item = new StopPayment_AllDataByTxnNo_Add();
                    _item.DestinationCountry = _get.TrData.DestinationCountry;
                    _item.DestinationPayementMode = _get.TrData.DestinationPayementMode;
                    _item.DestinationCity = _get.TrData.DestinationCity;
                    _item.DestinationLocation = _get.TrData.DestinationLocation;
                    _item.RecommendedAgent = _get.TrData.RecommendedAgent;
                    _item.AgentAddress = _get.TrData.AgentAddress;
                    _item.PurposeofTransfer = _get.TrData.PurposeofTransfer;
                    _item.hidPayOutCountry = _get.TrData.PayOutCountry.ToString();
                    _item.hidPayOutCCYID = _get.TrData.PayOUTCurrency.ToString();
                    _item.hidTrTypeID = _get.TrData.TrTypeID.ToString();
                    _item.ExchangeRate = _get.TrDetailsData.ExchangeRate;
                    _item.PayInAmount = _get.TrDetailsData.PayInAmount;
                    _item.PayOutAmount = _get.TrDetailsData.PayOutAmount;
                    _item.CommissionCharge = _get.TrDetailsData.UnpaidCommAmount;
                    _item.lblCommissionCurrency = _get.TrDetailsData.CommCurrencyName.ToString();
                    _item.TotalPayable = _get.TrDetailsData.PayOutAmount;
                    _item.BankAccountNo = _get.TrDetailsData.BankAccountNo;
                    _item.BankName = _get.TrDetailsData.BankName;
                    _item.BankBranch = _get.TrDetailsData.BankBranch;
                    _item.BankAddress = _get.TrDetailsData.BankAddress;

                    _item.lblPayInCurrency = _get.TrData.PayInCurrency.ToString();
                    _item.lblPayOutCurrency = _get.TrData.PayOutCurrency.ToString();
                    _item.lblPaybleCurrency = _get.TrData.PayInCurrency.ToString();

                    _item.TrDate = _get.TrDetailsData.TrDate;
                    _item.hidTr_Display = _get.TrDetailsData.Tr_Display;

                    _item.hidCustID = _get.CustomrData.Customer_Id.ToString();
                    _item.Customer_Name_F = _get.CustomrData.Customer_Name_F;
                    _item.Customer_Name_L = _get.CustomrData.Customer_Name_L;
                    _item.Address = _get.CustomrData.Address;
                    _item.Mobile = _get.CustomrData.Mobile;
                    _item.Phone = _get.CustomrData.Phone;
                    _item.NationalityID = _get.CustomrData.NationalityID.ToString();
                    _item.DOB = _get.CustomrData.DOB.ToShortDateString();
                    _item.Relation = _get.CustomrData.Relation;

                    _item.hidBenefID = _get.BeneficiaryData.Benef_Id.ToString();
                    _item.Beneficiary_Name_F = _get.BeneficiaryData.Beneficiary_Name_F;
                    _item.Beneficiary_Name_L = _get.BeneficiaryData.Beneficiary_Name_L;
                    _item.BAddress = _get.BeneficiaryData.Address;
                    _item.BMobile = _get.BeneficiaryData.Mobile;
                    _item.BPhone = _get.BeneficiaryData.Phone;
                    _item.BNationalityID = _get.BeneficiaryData.NationalityID.ToString();
                    _item.MessageToBen = _get.BeneficiaryData.MessageToBen;
                    _item.MessageToAgent = _get.BeneficiaryData.MessageToAgent;
                    lstUser.Add(_item);
                }

                string result = JsonConvert.SerializeObject(lstUser);
                commonLogDetails.LogToDB("Display_TransactionDetails", "N/A", "Success", result, $"AppID: {_AppID},Branch: {_Branch},RefNo: {_RefNo}");

                return lstUser;
            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("Display_TransactionDetails", "N/A", ex.ToString(), "No Response", $"AppID: {_AppID},Branch: {_Branch},RefNo: {_RefNo}");
                throw ex;
            }

        }




        //=================APPROVED TRANSACTION STATUS================//


        public string BatchApproved(List<StopPayment_AprovedStatus> lstItem)
        {
            string Message = "";
            string TransactionNo = "";
            try
            {
                for (int i = 0; i < lstItem.Count; i++)
                {
                    int _Status = lstItem[i].TrStatusID;

                    if (_Status != 0)
                    {
                        if (lstItem[i].IsChk)
                        {

                            int _StatusID = 0;

                            TransactionNo = lstItem[i].SRTRNo;

                            TrMaster.GetTrMaster _GetTr = new TrMaster.GetTrMaster(csCommon.GetConnectionString);
                            _GetTr.Transaction_No = TransactionNo;
                            _GetTr.GetData_ForCancel();
                            _StatusID = _GetTr.Data.TrStatusID;

                            if (_StatusID == Status.Paid.GetHashCode() || _StatusID == Status.Processed.GetHashCode())
                            {
                                using (Transaction.StopPayment.Cancel _Cancel =
                                    new Transaction.StopPayment.Cancel(csCommon.ConnectionString))
                                {
                                    _Cancel.TransactionNumber = TransactionNo;
                                    _Cancel.TrStatusID = lstItem[i].TrStatusID;
                                    _Cancel.EnteredBy = lstItem[i].EnteredBy;
                                    _Cancel.Remark = "Cancel Transaction";

                                    _Cancel.CancelPaidRequest_New();
                                    Message = _Cancel.Message;
                                }
                            }
                            else
                            {
                                using (Transaction.StopPayment.Cancel _Cancel =
                                    new Transaction.StopPayment.Cancel(csCommon.ConnectionString))
                                {
                                    _Cancel.TransactionNumber = TransactionNo;
                                    _Cancel.TrStatusID = lstItem[i].TrStatusID;
                                    _Cancel.EnteredBy = lstItem[i].EnteredBy;
                                    _Cancel.Remark = "Cancel Transaction";

                                    _Cancel.CancelRequest_New();
                                    Message = _Cancel.Message;
                                }
                            }
                        }
                        else
                        {
                            Message = "Please select atleast one record!! ";
                        }

                    }
                    else
                    {
                        throw new Exception("Select Status for Batch Approved.");
                    }
                }

                string result = JsonConvert.SerializeObject(lstItem);
                commonLogDetails.LogToDB("BatchApproved", "N/A", "Success", result, $"TransactionNo: {TransactionNo}");

            }
            catch (Exception ex)
            {
                commonLogDetails.LogToDB("BatchApproved", "N/A", ex.Message, "No Response", $"TransactionNo: {TransactionNo}");
                throw new Exception(":" + ex.Message);
            }

            return Message;
        }



    }
}